{$D+}
program KCEMU;

{$C MOVEABLE PRELOAD PERMANENT}	{gleiche Attribute wie Unit SYSTEM}
{$D KC-Emulator 0.53 (03/00)}
{$S 65535}
{$R KCEMU.RES}
{$R ROMS.RES}

uses
  WinTypes, WinProcs, MMSystem, Win31, CommDlg, ShellApi, WinDos,
  WUtils,prsht,KCHdr,KCDeb;
{Eigene Laufzeitfehler:
 220: kein Speicher bei GlobalAlloc() u.. Windows-Funktionen,
 221: kein Speicher bei LocalAlloc() u.. Windows-Funktionen,
 222: unerwarteter Offset <>0 bei globalem Speicher
 223: Fenster-Handle Null, jedoch erforderlich}

type
 TKCPixmap=record	{Bitmap fr KC85/2..4}
  case Integer of
  1: (bih: TBitmapInfoHeader;		{der Header}
      col: array[0..31] of Integer);	{Paletten-Indizes}
  2: (f0,f1,x,f3,y,f5,f6,b,f8,f9,fa,fb,fc,fd,fe,ff,c: Integer);
		{zum einfacheren (16-bit-)Zugriff auf x,y und die Farbzahl}
  3: (bi: TBitmapInfo);	{Typecast fr BitBlt}
 end;
 TKCPalette=record
  palVersion: Word;
  palNumEntries: Word;
  col: array[0..31] of TColorRef;	{alias LongInt}
 end;
 TThreeWords=array[1..3] of Word;
 PArgs=^TArgs;
 TArgs=record
  argn: Byte;			{Anzahl}
  arg: TThreeWords;		{Argumente}
 end;
 TKccHdr=record			{23 Bytes}
  name: array[0..10]of Char;
  rsv: array[11..15]of Byte;
  args: TArgs;
 end;
 TZ80Hdr=record			{32 Bytes}
  arg: TThreeWords;		{00..05, Anfangs-, Ende- und Startadresse}
  creator: array[0..5] of Char;	{06..0B}
  typ: Char;			{0C C=COM}
  magic: array[0..2] of Char;	{0D..0F, Inhalt D3-D3-D3 oder '...'}
  name: array[0..15] of Char;	{10..1F, Dateiname}
 end;
 TFullKccHdr=record
  case Integer of
  0: (name: array[0..10]of Char;
      rsv: array[11..15]of Byte;
      args: TArgs);
  1: (block: array[0..127] of Char);
 end;
{Die anderen KC's arbeiten mit einer Bitmap (S/W),
 abgesehen vom Z9001 mit Farboption.
 Formate: KC85:  Pixel 320x256, Zeichen 40x32, Zeichenraster 8x8
		oder (WordPro)	Zeichen 80x32, Zeichenraster 4x8
		oder (CP/M)	Zeichen 80x25, Zeichenraster 4x10
	  Z9001: Pixel 320x192, Zeichen 40x24, Zeichenraster 8x8
	  oder(!)Pixel 320x200, Zeichen 40x20, Zeichenraster 8x10
	  Z1013: Pixel 256x256, Zeichen 32x32, Zeichenraster 8x8}
{
FARBBYTE KC85:
 Bit 7: 1=Blinken
 Bit 6: Vordergrund-Farbkreisverschiebung um 30
 Bit 5..3: Vordergrundfarbe G-R-B
 Bit 2..0: Hintergrundfarbe G-R-B in reduzierter Helligkeit
FARBBYTE Z9001:
 Bit 7: 1=Blinken
 Bit 6..4: Vordergrundfarbe B-G-R
 Bit 3: frei
 Bit 2..0: Hintergrundfarbe B-G-R
BILDSCHIRMRAND UND ZEILENUMSTELLUNG Z9001
 Port 136 (88h):
 Bit 5..3: Bildrandfarbe B-G-R (wird via Bildrahmen emuliert)
 Bit 2: 1=20-Zeilen-Modus mit 8x10-Zeichenzellen}
 TCallEvent=function(Msg,wParam:Word; lParam:LongInt):LongInt;

const
 AnimCol=PC_Reserved shl 24;	{max. 8 Farbpaare werden animiert}
 KCPixmap: TKCPixmap=(
  bih: (
   biSize: sizeof(TBitmapInfoHeader);
   biWidth: 320;		{variabel}
   biHeight: 256;		{variabel}
   biPlanes: 1;
   biBitCount: 8;		{variabel}
   biCompression: BI_RGB;
   biSizeImage: 0;
   biXPelsPerMeter: 0;
   biYPelsPerMeter: 0;
   biClrUsed: 32;		{variabel}
   biClrImportant: 0);
  col:(0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,
  25,26,27,28,29,30,31)
 );
type
 PDefPal=^TDefPal;
 TDefPal=record
  num: Integer;
  col: array[0..23] of TColorRef;	{maximal 24 Festfarben zulssig}
 end;
const
 DefPal1: record		{monochrome Palette}
  num: Integer;
  col: array[0..1] of TColorRef;
 end=(num: 2;
  col:($000000,$FFFFFF));

 DefPal3: record		{KC85/3-Palette}
  num: Integer;
  col: array[0..23] of TColorRef;
 end=(num: 24;
  col:($000000,$B00000,$0000B0,$B000B0,$00B000,$B0B000,$00B0B0,$B0B0B0,
       $000000,$FF0000,$0000FF,$FF00FF,$00FF00,$FFFF00,$00FFFF,$FFFFFF,
       $000000,$FF0080,$0080FF,$8000FF,$80FF00,$FF8000,$00FF80,$FFFFFF));

 DefPal7: record		{KC87-Palette}
  num: Integer;
  col: array[0..7] of TColorRef;
 end=(num: 8;
  col:($000000,$0000FF,$00FF00,$00FFFF,$FF0000,$FF00FF,$FFFF00,$FFFFFF));

function DefFetchInstruction:Byte; near; assembler;
 asm	seges	lodsb
 end;

procedure DefDoNothing; near; assembler;
 asm
 end;

function DefIORead:Byte; near; assembler;
 asm	mov	al,$ff
 end;

function DefCallEvent(Msg,wParam:Word; lParam:LongInt):LongInt; far; assembler;
 asm	xor	ax,ax
	cwd
 end;

var
 Palette: TKCPalette;	{Momentane Palette}
 PalPtr: PDefPal;	{Statische Palette des jeweiligen Computers}
 hDisplay: Word;	{Windows-DIB mit 2 oder 256 Farben; Offset ist Null}
 DisplaySize: LongInt;	{Gre der Bitmap/Pixmap, max. 128KB}
 cticks: LongInt;
 expire: Word;
 KCTyp: Integer;
 MenuFlags: Integer;
 Saum: TPoint;		{Add-On von Client auf Fenster}
 AppName: TS31;
 KCName: TS31;		{Beschrnkung wegen Platz in Titelzeile}
 VollbildStr: TS31;	{aus dem System-Men bei Ersetzung durch "Grobild"}
 hPal: HPalette;
 ClrsRealized: Word;
 KC4Port84H: Byte;	{Bit 3: KC 85/4 im /HRG-Modus, Bit 2: Bild-Nr.}
 KC4Port86H: Byte;
 KCIRM: PtrRec;		{KC85/(erst mal nur)4 Videospeicher}
{ KCMem: THandle;	{64K oder 256K}
 KC4Port88H: Byte;	{auch fr Z9001 benutzt}
 KC4Port89H: Byte;
 Z1013Port2: Byte;	{Bit 7: Tonausgabe, Bit 4: Tastatur-??}
 Z1013Port8: Byte;	{Tastaturspaltendekoder}
 Z1013Key: Word;	{Lo: Zeichen (ASCII), Hi: Crtl,Shift}
 WrPerm: array[0..3] of Word;
{Bits gesetzt, wenn Schreibzugriff erlaubt; pro Kilobyte ein Bit}
 PortsOut: array[0..255] of TNearProc;	{Prozedur-Offsets}
 PortsIn:  array[0..255] of TNearProc;
 PortsInstL: array[0..255] of Word;	{Port-Info Low-Byte}
const
 FetchInstruction: Word=ofs(DefFetchInstruction);  {Befehlslese-Prozedur}
 MemWr: Word=ofs(DefDoNothing);			{Speicherschreib-Routine}
 IORd: Word=ofs(DefIORead);
 IOWr: Word=ofs(DefDoNothing);
const
 CallEvent: TCallEvent=DefCallEvent;
var
 IRom: array[0..3] of THandle;		{Initial-ROMs (max. 4)}
 IRomAddr: array[0..3] of Word;		{Einblend-Adressen}
 hCharMap: THandle absolute IRom;	{erster Initial-ROM ist Zeichensatz}
 TickTaken: LongInt;
 TimeTaken: Word;
 EmuBlock: Byte;	{Register: <>0: Z80 blockieren!
  Bit 0: Block wegen modalem Fenster,
  Bit 1: wegen Icon,
  Bit 2: wegen Hintergrund,
  Bit 3: wegen Markiervorgang
  Bit 4: wegen F9,
  Bit 5: wegen ungltiger DLL,}
 EmuBlockMask: Integer;
var
 KCClock: Word;		{Taktfrequenz in Kilohertz}
 LastPaintTime: Word;	{Zeit fr WM_Paint entscheided ber Emu-Dauer}
 Freq: Word;		{Zuletzt gemessene Z80-Frequenz}
 SelectedRegion: HRgn;	{Momentane Markierung}
 SelectedRect: TRect;	{Momentane Markierung}
 RandL,RandR: Integer;	{Rnder links und rechts, 0&0=rechteckig}
 LoadSaveArgs: TArgs;	{Global ist eben einfacher zu handhaben!}
{*** WinG-Bereich ***}
type
 PPointer=^Pointer;
 PRGBQuad=^TRGBQuad;
var
 WinGInst: THandle;
 WinGDC: HDC;
 WinGBM: HBitmap;
 WinGBMMono: HBitmap;
{5 Funktionszeiger}
 WinGCreateDC: function:HDC;
 WinGCreateBitmap: function(WinGDC:HDC; const Header:TBitmapInfo;
   ppBits:PPointer):HBitmap;
 WinGSetDIBColorTable: function(WinGDC:HDC; StartIndex,NumberOfEntries:Word;
   pColors:PRGBQuad):Word;
 WinGStretchBlt: function(
   hdcDest:HDC;nXOriginDest,nYOriginDest,nWidthDest,nHeightDest:Integer;
   hdcSrc: HDC;nXOriginSrc, nYOriginSrc, nWidthSrc, nHeightSrc: Integer):Bool;
 WinGBitBlt: function(
   hdcDest:HDC;nXOriginDest,nYOriginDest,nWidthDest,nHeightDest:Integer;
   hdcSrc: HDC;nXOriginSrc, nYOriginSrc:Integer):Bool;

const
 Installed:Boolean=false;	{Entscheidet ber's automatische Speichern}
 AutoInsert:Boolean=false;	{knftig INS vor jedem ASCII senden!}
 Foreground:Boolean=true;	{Momentan dargestellte Blinkfarbe, ist spter
  der Ausgang eines virtuellen D-Flip-Flops im KC (am Timer U856-Z80CTC)}
 HelpFile:array[0..9]of Char='KCEMU.HLP';
 stKCEMU: array[0..5]of Char='KCEMU';
 BorderRGB: TColorRef=0;	{Randfarbe}
{SETUP-Werte}
 MaxRegions: Integer=1600;	{begrenzt die Aufrufe von InvalidateRect()}
 CpuExpire: Word=$FFFF;		{Anzahl KC-Takte pro "Stck" - nicht benutzt}
 PERatio: Integer=4;
const
 EmuShowClock: Integer=8+2;	{hier: feste Bitzuordnung}
	{Bit 0..1: 0: keine Anzeige, 1: Prozent, 2: MHz}
	{Bit 2: Auch wenn Symbol, Bit 3: KC-Typ anzeigen}
 UseWinG	=$01;
 Blinken	=$02;
 BlinkHighColor	=$04;
 EntireDesktop	=$08;
 ScalableWindow	=$10;
 DrawFrame	=$40;
 SizingLock	=$80;		{Sperre fr WM_Sizing}
 DisplayFlags: Integer=Blinken;
var
 DispFlags: Byte absolute DisplayFlags;
const
 Fliesstext	=$01;
 Strichkiller	=$02;
 Zusatzgrafik	=$04;
 ClipbrdFlags: Integer=Strichkiller or Zusatzgrafik;
 PasteTimeOut: Integer=200;		{Millisekunden fr Zeicheneinfgung}
 PasteEnterTimeOut: Integer=2000;	{mehr Zeit fr ENTER-Taste}
var
 ClipFlags: Byte absolute ClipbrdFlags;

var
 InUpdate: array[0..159] of Byte;	{pro Cursorpos ein Bit, s. KCSCR.ASM}
{Pro Bildschirmlschen kommen so max. 1280 Aufrufe von InvalidateRect()
 zusammen; immer noch besser als per-Pixel-Basis
 Die Array-Gre bezieht sich auf die maximale Bildgre von 320x256!}
 Regions: Integer;	{Abwrtszhler fr InvalidateRect() in KCSCR.ASM}
 ScreenBPP: Integer;	{Bits pro Pixel auf Bildschirm, 2,4,8,15,16,24,32}
 GetAnimIdx: TNearProc;
 Magnify: Integer;	{enthlt 1 (normal) oder 2 (doppelt) oder mehr}
 PixBox: Integer;	{enthlt Dimension einer 8x8-Box auf Bildschirm}
 ChrBox: TPoint;	{enthlt Dimension der Zeichenzelle auf Bildschirm}
 ChrBoxKC: TPoint;	{enthlt Dimension der Zeichenzelle am KC}
 ScreenBox: TRect;	{(momentaner) KC-Bildausschnitt im Fenster}
 MaxPos: TPoint;	{Position links oben bei maximiertem Fenster}
 Border: Integer;	{Breite des (festen) Rahmens in Pixel}
 FullMag: Integer;	{Skalierung fr Vollbild, <1 bedeutet "automatisch"}
 GC_ShortCircuit: Boolean;	{Kurzschluroutine: keine Garbage Collection}
 ResizeLock: Byte;		{Sperre fr ChrBoxChanged nach WM_Size}
 BlinkFarben: array[0..7] of Byte;
{enthlt KC-Farbattribute mit gesetztem Blinkbit (7) oder 0 fr freie
 Eintrge. Korrespondiert zu den 8 animierten Farben der Farbpalette}
 KCEmuVxDEntry: Pointer;

 hWav: HWaveIn;
 Waves: array[0..1] of THandle;
 WaveOption,WaveOutDev,WaveInDev: Integer;
 CurWaveHdr,NextWaveHdr: PWaveHdr;	{ZeigerZeiger auf Daten}
 ByteIndex: Word;
const
 CurrentHelpFile: TS31='KCEMU.HLP';	{!! Test}
const
 WAVBLK=5500;
 MyWav: TPCMWaveFormat=(
  wf:(
   wFormatTag:      WAVE_Format_PCM;
   nChannels:       1;
   nSamplesPerSec:  22050;
   nAvgBytesPerSec: 22050;
   nBlockAlign:     1);
  wBitsPerSample:  8);

procedure Blink_GC; external;
{Garbage Collection fr BlinkFarben: Durchbrowst die 80-KB-Pixmap
 nach Eintrgen zwischen 24 und 31 und entfernt Fehlreferenzen
 aus BlinkFarben[]. Sind alle Farben in Beschlag, dann CY=1.
 PE: CLD! VR: BX,CX}
procedure GetBlinkFarbe; external;
{PE: AL=(unverndertes) Farbattribut; PA:AL=Palettenindex}
{Funktioniert fr alle KC durch Funktionszeiger fr SetAnimColor}
procedure Animate; external;
procedure GetAnimIdx3; external;
procedure GetAnimIdx7; external;

{Invalidierungsfunktionen}
procedure InvalWnd; external;
{PE: -, PA: -, VR: alle auer DS,SI,SP,BP}
procedure Inval8x8; external;
{Invaliditiert Bildschirm-Bereich in 8x8-Kltzchen,
 Eintrittspunkt fr den Gebrauch durch externe Bildschirmsteuerungen
 PE: DL=Zeile(Y), DH=Spalte(X) (also gerade andersherum als im PC-BIOS)
     BX=eindeutiger Bit-Bezeichner fr InUpdate-BitArray
 VR: BX,CL,Flags}
procedure InvalChrBox; external;
{dieselbe Routine wie oben, jedoch in Zeichenzellen statt 8x8}
function InvalBlink:Boolean; external;
{Alle (8x1-)Bereiche mit Blinkfarben invalidieren, liefert TRUE wenn vorhanden}

{Sammlung aller IRM_UpdateX-Routinen (die meisten berhren nur den
 Videospeicher); PE: -, PA: -, VR: Flags}
procedure IRM_Update1; external;
procedure IRM_Update3; external;
procedure IRM_Update4; external;
procedure IRM_Update7; external;
procedure IRM_Update9; external;

{Sammlung aller IRM_AccessX-Routinen
 PE: BX=Schreibadresse, (ES:BX bereits geschrieben), AL=Zeichen
 PA: -, VR: Flags}
procedure IRM_Access1; external;
procedure IRM_Access3; external;
procedure IRM_Access4; external;
procedure IRM_Access7; external;
procedure IRM_Access9; external;
{$L KCSCR}

type
 TUserInfo=record
  hDrv: THandle;
  hLib: THandle;	{Da sind die ROMs}
  memwrite: Pointer;	{4 schnelle Prozeduren: Speicherschreiben}
  ioread: Pointer;	{Portlesen}
  iowrite: Pointer;	{Portschreiben}
  intchk: Pointer;	{Interrupttest}
{Alle anderen Ereignisse gehen ber DriverProc}
  user: LongInt;	{fr den Treiber zur freien Verwendung}
  screen: TPoint;	{(anfngliche) Bildschirmgre in Pixeln}
  color: Boolean;
  freq: Word;		{Nominelle Taktfrequenz}
  rom: array[0..3] of LongRec;	{4 ROMs sollten reichen}
  ram: array[0..3] of LongRec;	{4 RAMs sollten reichen}
 end;
var
 UserInfo: TUserInfo;


{Speicherschreibroutinen mov [ES:BX],AL
 PE: BX=Speicheradresse, AL=Zu schreibendes Byte; PA: -; VR: -}
procedure MemWrite1; near; assembler;
 asm	cmp	bh,0C0h
	jb	@@set		;{0000-BFFF=RAM (bei 48K-Ausbau}
	cmp	bh,0ECh
	jb	@@e		;{C000-EBFF=ROM-Modul (BASIC) oder frei}
	cmp	bh,0F0h
	jnb	@@e		;{EC00-EFFF=IRM, dahinter ROM}
@@irm:	cmp	[es:bx],al
	jz	@@e
	mov	[es:bx],al
	jmp	IRM_Access1
@@set:	mov	[es:bx],al
@@e:
end;

type
{TSegment macht sich wegen des 64K-Moduls und des KC85/2-CAOS erforderlich}
 TSegment=record	{beschreibt ein Speicherabschnitt eines Moduls}
  a,e:ShortInt;		{Anfang und Ende der Einblendung im 64KB-Adreraum}
  r:Integer;		{Referenz auf allozierten Speicherblock}
 end;

 PMemNode=^TMemNode;
 TMemNode=record
  next: Word;		{nchstes Listenelement}
  memblock: THandle;	{Typ des memblock steht in segments[7:4]}
  size: Word;		{Gre des Speichermoduls in KByte}
  switchproc: TNearProc;{Schalt-Prozedur}
  strukturbyte: Byte;	{Rckmeldung beim IN-Befehl}
  steuerbyte: Byte;	{Merker fr letztes Steuerbyte; Bit0=On, Bit1=WrPerm}
  steckplatz: Byte;	{Modulsteckplatz; 0..7: interne Module}
  segments: Byte;	{Anzahl Segmente (siehe unten) Bit3:0}
  seg: array[0..3] of TSegment;
 end;
const
 SegStart=12;		{Bytes bis zu seg[0] - integrierter ASM macht Mist}
 MEMT_None=0;		{nicht alloziert}
 MEMT_ResID=1;		{memblock enthlt Resourcen-ID zum Laden}
 MEMT_Global=2;		{memblock enthlt PageAlloc()-Speicher}
 MEMT_Res=3;		{memblock enthlt LoadResource()-Speicher}

var
 NodeRam0, NodeIRM, NodeBasic, NodeCAOS: Word;

procedure MemWrite3; near; assembler;
{PE: ES:BX=Adresse, AL=Datenbyte; VR: Flags, CL}
 asm	push	bx
	 shr	bx,10		;{Kilobyte}
	 cmp	[Test8086],2
	 jb	@@For286
	 db	0Fh,0A3h,1Eh	;{BT [WrPerm],bx}
	 dw	offset WrPerm
	pop	bx
	jnc	@@e		;{keine Schreiberlaubnis!}
@@w286:	cmp	bh,80h
	jb	@@set		;{nicht im Bereich des IRM}
	cmp	bh,0b2h
	jae	@@set		;{nicht im Bereich des IRM}
	test	[KC4Port88H],4	;{IRM eingeschaltet?}
	jz	@@set		;{nur schreiben}
	cmp	[es:bx],al
	jz	@@e		;{keine Vernderung}
	mov	[es:bx],al
	jmp	IRM_Access3	;{DIB aktualisieren}
@@For286:
	 push	ax
	  mov	al,1
	  mov	cl,bl
	  and	cl,7		;{Bit-Nummer}
	  shl	al,cl		;{Bit in Position bringen}
	  shr	bl,3		;{BH ist bereits 0}
	  test	byte ptr [WrPerm+bx],al
	 pop	ax
	pop	bx
	jnz	@@w286
	ret
@@set:	mov	[es:bx],al
@@e:
end;
{ alte Version
procedure MemWrite3; near; assembler;
 asm	cmp	bh,0c0h
	jae	@@e
	cmp	bh,80h
	jb	@@set
	cmp	bh,0b2h
	jae	@@set
	cmp	[es:bx],al
	jz	@@e
	mov	[es:bx],al
	jmp	IRM_Access3
@@set:	mov	[es:bx],al
@@e:
end;
}
procedure MemWrite4; near; assembler;
{PE: ES:BX=Adresse, AL=Datenbyte; VR: Flags, CL}
 asm	cmp	bh,0c0h
	jae	@@e
	cmp	bh,80h
	jb	@@set
	cmp	bh,0A8h
	jae	@@set
	test	[KC4Port88H],4	{IRM eingeschaltet?}
	jz	@@set		{nein, normaler RAM}
	cmp	[es:bx],al
	jz	@@e
	mov	[es:bx],al
	jmp	IRM_Access4
@@set:	mov	[es:bx],al
@@e:
end;
procedure MemWrite7; near; assembler;
{PE: ES:BX=Adresse, AL=Datenbyte; VR: Flags, CL}
 asm	cmp	bh,0C0h
	jb	@@set		;{0000-BFFF=RAM (bei 48K-Ausbau}
	cmp	bh,0E8h
	jb	@@e		;{C000-E7FF=ROM-Modul (BASIC)}
	cmp	bh,0F0h
	jnb	@@e		;{E800-EFFF=IRM, dahinter ROM}
@@irm:	cmp	[es:bx],al
	jz	@@e
	mov	[es:bx],al
	jmp	IRM_Access7
@@set:	mov	[es:bx],al
@@e:
end;
procedure MemWrite8; near; assembler;
{PE: ES:BX=Adresse, AL=Datenbyte; VR: Flags, CL}
 asm	cmp	bh,0ECh
	jb	@@set		;{0000-EBFF=RAM (bei 64K-Ausbau}
	cmp	bh,0F0h
	jb	@@irm		;{EC00-EFFF=IRM}
	ret			;{F000-FFFF=ROM-nicht schreiben}
@@irm:	cmp	[es:bx],al
	jz	@@e
	mov	[es:bx],al
	jmp	IRM_Access9
@@set:	mov	[es:bx],al
@@e:
end;
procedure MemWrite9; near; assembler;
{PE: ES:BX=Adresse, AL=Datenbyte; VR: Flags, CL}
 asm	cmp	bh,0ECh
	jb	@@set		;{0000-EBFF=RAM (bei 64K-Ausbau}
	cmp	bh,0F0h
	jb	@@irm		;{EC00-EFFF=IRM}
	cmp	bh,0F8h
	jae	@@set		;{F800-FFFF=RAM (bei 64K-Ausbau)}
	ret			;{F000-F7FF=ROM-nicht schreiben}
@@irm:	cmp	[es:bx],al
	jz	@@e
	mov	[es:bx],al
	jmp	IRM_Access9
@@set:	mov	[es:bx],al
@@e:
end;
procedure MemWriteUsr; near; assembler;
{PE: ES:BX=Adresse, AL=Datenbyte; VR: Flags, CL}
 asm	call	[UserInfo.memwrite]	{FAR weiterreichen}
end;
procedure DefMemWrite; near; assembler;
{PE: ES:BX=Adresse, AL=Datenbyte; VR: Flags, CL}
 asm	mov	[es:bx],al
end;
(*
procedure XchgD(var a1,a2; len:Word); assembler;
 asm	pusha; push ds; push es
	 cmp	[Test8086],2	{386er?}
	 cld
	 mov	cx,[len]
	 jcxz	@@e
	 lds	si,[a1]
	 les	di,[a2]
	 jnc	@@l3
	 shl	cx,1
@@l2:	 lodsw
	 mov	dx,es:[di]
	 stosw
	 mov	[si-2],dx
	 loop	@@l2
	 jmp	@@e

@@l3:	 db $66; lodsw
	 db $66; mov	dx,es:[di]
	 db $66; stosw
	 db $66; mov	[si-4],dx
	 loop	@@l3
@@e:	pop es; pop ds; popa
 end;
*)
procedure MovK(SSel,SOfs,DSel,DOfs:Word; KBytes:Integer); assembler;
{maximal 64K am Stck! Kein Selektor-bergang! Offsets in Kilobyte!
 Bearbeitet spter auch Speicherblcke >64K}
 asm	push ds
	 mov	cx,[KBytes]
	 jcxz	@@e
	 shl	cx,9		{Words}
	 mov	al,[Test8086]
	 cld
	 lds	si,dword ptr [SOfs]	{jetzt ist DS weg!}
	 les	di,dword ptr [DOfs]
	 shl	si,10
	 shl	di,10
	 cmp	al,2		{386er?}
	 jc	@@286
	 shr	cx,1		{DWords}
	 db	$66
@@286:	 rep	movsw
@@e:	pop ds
 end;

procedure FillK(DSel,DOfs:Word; KBytes:Integer); assembler;
{maximal 64K am Stck! Kein Selektor-bergang! Fllt mit $FF!
 Bearbeitet spter auch Speicherblcke >64K}
 asm	mov	cx,[KBytes]
	jcxz	@@e
	shl	cx,9		{Words}
	cld
	les	di,dword ptr [DOfs]
	shl	di,10
	mov	ax,$FFFF
	cmp	[Test8086],2	{386er?}
	jc	@@286
	shr	cx,1		{DWords}
	db $66; cbw		{cwde, AX-->EAX}
	db	$66
@@286:	rep	stosw
@@e: end;

procedure SetWrPerm(frombit,tobit:Word; SetRes:Boolean); assembler;
 asm	cmp	[test8086],2
	jnc	@@386
	mov	cx,frombit
	mov	dx,tobit
	inc	dx
	sub	dx,cx	{Bit-Zahl}
	mov	bx,cx
	shr	bx,4
	add	bx,offset WrPerm
	and	cl,0Fh
	mov	ax,1
	shl	ax,cl
	xchg	cx,dx
	cmp	[SetRes],0
	jz	@@res286
@@set286:
	mov	dx,[bx]	{im Register ORen, wegen Geschwindigkeit}
@@s2L:	or	dx,ax
	rol	ax,1
	jc	@@s21	{Bit-Ausschub? DX wechseln!}
	loop	@@s2L
	inc	cx	{wenn geschafft, nur noch speichern}
@@s21:	mov	[bx],dx
	add	bx,2
	loop	@@set286
	jmp	@@e
@@res286:
	not	ax
	mov	dx,[bx]	{im Register ORen, wegen Geschwindigkeit}
@@r2L:	and	dx,ax
	rol	ax,1
	jnc	@@r21	{Bit-Ausschub? DX wechseln!}
	loop	@@r2L
	inc	cx	{wenn geschafft, nur noch speichern}
@@r21:	mov	[bx],dx
	add	bx,2
	loop	@@res286
	jmp	@@e
@@386:
	mov	cx,tobit
	mov	dx,frombit
	inc	cx
	sub	cx,dx		{CX=Bit-Anzahl}
	cmp	[SetRes],0
	jz	@@res386
@@set386:
	db	0Fh,0ABh,16h	{BTS [WrPerm],dx}
	dw	offset WrPerm
	inc	dx
	loop	@@set386
	jmp	@@e
@@res386:
	db	0Fh,0B3h,16h	{BTR [WrPerm],dx}
	dw	offset WrPerm
	inc	dx
	loop	@@res386
@@e: end;

{Das kniffligste scheint die Speicher-Emulation zu sein}

function PageAlloc(KBytes:Integer):THandle; far;
{KBytes MSB: Allokation von stndig gemapptem Speicher: es erfolgt dann
 KEIN GlobalAlloc, jedoch im VxD dennoch PageAllocate}
{Belegt spter im VxD}
 begin
  if KBytes<0 then PageAlloc:=MemKCSel
  else if PtrRec(KCEmuVxDEntry).Sel=0 then begin
   if KBytes=0 then KBytes:=64;	{Sonderfall: 64K-Fenster}
   PageAlloc:=GlobalAlloc(GMEM_Fixed,LongMul(KBytes,1024))
  end else asm
	mov	ah,1
	call	[KCEmuVxDEntry]
	mov	[@Result],ax
  end;
 end;

function PageFree(HMem:THandle):THandle;
{gibt spter im VxD frei, sollte 0 liefern}
{"Normaler" Speicher mit Handle=MemKCSel NICHT freigeben!}
 begin
  PageFree:=0;
  if HMem<>0 then begin
   if PtrRec(KCEmuVxDEntry).Sel=0 then PageFree:=GlobalFree(HMem)
   else asm
	mov	ah,2
	call	[KCEmuVxDEntry]
	mov	[@Result],ax
   end;
  end;
 end;

procedure Map(KCKB:Integer;HMem:THandle;Start,KBytes:Integer; Dir:Boolean);
{Speicher ab Adresse KCOfs ein/ausblenden, Start in KBytes vom HMem-Anfang}
{Wird spter ins VxD verlegt und von der MMU erledigt}
 begin
  if HMem<>0 then begin			{Speicherhandle okay?}
   if Dir then MovK(HMem,Start,MemKCSel,KCKB,KBytes)
					{Dir=TRUE: MapIn}
   else MovK(MemKCSel,KCKB,HMem,Start,KBytes);
					{Dir=FALSE: MapOut}
  end else begin
   if Dir then FillK(MemKCSel,KCKB,KBytes);
					{Dir=TRUE: Speicherloch simulieren}
  end;					{Dir=FALSE: Nichts tun}
 end;

var
 MemChain: Word;	{Listen-Anker (im Grundgert); nur KC85}
 IoChain: Word;		{noch ein Listen-Anker fr Standard-IO}
function LoadROM(ID:Word):THandle; forward;

procedure ShuffleMem(N:Word; start,endi:ShortInt; Richtung:Integer);
{Speicher ein- oder auslagern, Richtung=0: vom MemKCSel, =1: zum MemKCSel,
 2: Speicher mit $FF fllen; start, endi in KByte (0..63)
 Diese Routine ldt ggf. die Resource beim Einblenden bzw. reserviert
 Speicher beim Ausblenden}
 begin
  with PMemNode(Ptr(Seg(HInstance),N))^ do case Richtung of
   0: begin		{"Rckzieher"}
    if segments shr 4 =0 then begin
     memblock:=PageAlloc(size);
     segments:=segments or $20;
    end;
    MovK(MemKCSel,start, memblock,seg[0].r+start-seg[0].a,
      endi-start+1);
{Beim "Rckzieher" ist kein Setzen von Schreibfreigabe-Bits ntig}
   end;
   1: begin		{"Einmapper"}
    if segments shr 4 =1 then begin
     memblock:=LoadROM(memblock);
     segments:=segments or $20;
    end;
    if memblock<>0
    then MovK(memblock,seg[0].r+start-seg[0].a, MemKCSel,start,
      endi-start+1);
{Schreibfreigabe-Bits je nach N^.flags setzen/lschen}
    SetWrPerm(start,endi,steuerbyte and 2 <>0);
   end;
   2: begin
    FillK(MemKCSel,start,endi-start+1);
{Schreibfreigabe-Bits lschen}
    SetWrPerm(start,endi,false);
   end;
  end;
 end;

procedure SchalteEinAus(EinblendNode:Word; Ein:Boolean);
{Ein- oder Ausschalten von EinblendNode}

 procedure Speicherkette(N:Word;start,endi:ShortInt;Dahinter:Boolean);
  var
   S,E:ShortInt;
  begin
   with PMemNode(Ptr(Seg(HInstance),N))^ do begin
    if N=0 then begin
			{ $FF einblenden}
     if Dahinter and not Ein then ShuffleMem(0,start,endi,2);
     exit;
    end;
    if EinblendNode<>N then begin
     if steuerbyte and 1 <>0 then begin	{RAM eingeschaltet?}
			{Schnittmenge sichern, wenn hinter EinblendNode}
      if Dahinter then begin
       S:=max(start,seg[0].a);
       E:=min(endi,seg[0].e);	{Schnittmenge vorhanden?}
       if S<=E then ShuffleMem(N,S,E,Integer(not Ein));
      end;		{mit Differenzmenge weiter rekursieren}
			{Bereich oder Teilbereich davor?}
      S:=seg[0].a;
      if (start<S) then Speicherkette(next,start,min(endi,S-1),Dahinter);	{Bereich dahinter?}
      E:=seg[0].e;
      if (E<endi) then Speicherkette(next,max(start,E+1),endi,Dahinter);
     end else Speicherkette(next,start,endi,Dahinter);
    end else begin
     if not Ein then ShuffleMem(N,start,endi,0);
     SpeicherKette(next,start,endi,true);	{Durch-rekursieren!}
     if Ein then ShuffleMem(N,start,endi,1);
    end;
   end;
  end;

 begin
  with PMemNode(Ptr(Seg(HInstance),EinblendNode))^ do begin
   SpeicherKette(MemChain,seg[0].a,seg[0].e,false);
   steuerbyte:=steuerbyte and not 1 or Integer(Ein);
  end;
 end;

procedure SchalteSchreibfreigabe(EinblendNode:Word; Perm:Boolean);
{Nur aufrufen, wenn sich bei eingeschaltetem Modul ausschlielich
 das Schreibschutz-Bit ndert! Kein Schaufeln/Mapping in dieser Routine.}
 procedure Speicherkette(N:Word;start,endi:ShortInt);
  var
   S,E:ShortInt;
  begin
   with PMemNode(Ptr(Seg(HInstance),N))^ do begin
    if N=0 then exit;	{nichts tun!}
    if EinblendNode<>N then begin
     if steuerbyte and 1 <>0 then begin	{RAM eingeschaltet?}
      S:=seg[0].a;		{Bereich oder Teilbereich davor?}
      if (start<S) then Speicherkette(next,start,min(endi,S-1));
      E:=seg[0].e;		{Bereich oder Teilbereich dahinter?}
      if (E<endi) then Speicherkette(next,max(start,E+1),endi);
     end else Speicherkette(next,start,endi);
				{ausgeschaltete Module ignorieren}
    end else begin
     SetWrPerm(start,endi,Perm);{nun Schreibschutz setzen/lschen}
    end;
   end;
  end;

 begin
  with PMemNode(Ptr(Seg(HInstance),EinblendNode))^ do begin
   SpeicherKette(MemChain,seg[0].a,seg[0].e);
   steuerbyte:=(steuerbyte and not 2) or (Integer(Perm) shl 1);
  end;
 end;

procedure FillWord(var buf; words:Word; val: Word); assembler;
 asm	les	di,[buf]
	mov	cx,[words]
	mov	ax,[val]
	cld
	rep	stosw
 end;

function InsertKCModul(N: Word):Boolean; assembler;
{Diese Funktion liefert FALSE, wenn der Steckplatz bereits belegt ist!}
{Schleifen-Krper: BX=Einfge-Node, SI=Vorgnger-Node, DI=Nachfolger-Node}
 asm	mov	di,offset MemChain
	mov	bx,[N]
	mov	ah,TMemNode[bx].steckplatz
@@l:	mov	si,di
	mov	di,[di]
	or	di,di
	jz	@@break
	mov	al,TMemNode[di].steckplatz
	cmp	al,ah
	jz	@@err		{gleich: Fehler!}
	jc	@@l		{kleiner: Schleife wiederholen!}
@@break:
	mov	[bx],di		{N^.next einsetzen}
	mov	[si],bx		{Vorgnger^.next einsetzen}
	test	TMemNode[bx].steuerbyte,1
	jz	@@off
	push	bx
	push	1
	call	SchalteEinAus	{Voraussetzung: Segmentadressen initialisiert}
@@off:	mov	al,1
	jmp	@@e
@@err:	int	3
	mov	al,0
@@e:	end;

procedure FindKCModul; assembler;
{PE: AH=Steckplatz; PA: SI=PMemNode, CY=1: nicht gefunden;
 VR: SI, Flags}
 asm	mov	si,offset MemChain
@@l:	mov	si,[si]
	or	si,si
	stc
	jz	@@e		{Fehler bei NIL}
	cmp	ah,TMemNode[si].steckplatz
	ja	@@l		{Fehler bei AH<AL}
@@e:	end;

function RemoveKCModul(N: Word):Boolean; assembler;
{N mu sich in der Liste wiederfinden lassen;
 N wird nur aus der Liste entfernt, wird jedoch selbst nicht freigegeben}
 asm	mov	bx,[N]
	test	TMemNode[bx].steuerbyte,1
	jz	@@off
	push	bx
	push	0
	call	SchalteEinAus
	mov	bx,[N]		{Nachladen!!}
	or	TMemNode[bx].steuerbyte,1
@@off:	mov	di,offset MemChain
	mov	al,0		{FALSE}
@@l:	mov	si,di
	mov	di,[di]
	or	di,di
	jz	@@e
	cmp	di,bx		{Gleich?}
	jne	@@l		{nein, weitersuchen}
	mov	ax,[di]
	mov	[si],ax		{Knoten (DI=BX) aushngen}
	mov	al,1		{TRUE}
@@e:	end;

procedure ClearKCModules; assembler;
 asm	xor	di,di
	xchg	di,[MemChain]	{gleichzeitig nullsetzen}
	jmp	@@f
@@l:
	mov	cx,TMemNode[di].memblock
	jcxz	@@1
	push	di
	 mov	al,TMemNode[di].segments
	 shr	al,4
	 cmp	al,MEMT_Res	{Ressource extra freigeben!}
	 je	@@fr		{sonst hagelt es Schutzverletzungen}
	 cmp	al,MEMT_Global
	 jne	@@fm
	 push	cx
	 call	PageFree
	 jmp	@@fm
@@fr:	 push	cx
	 call	FreeResource
@@fm:	pop	di
@@1:	push	di
	mov	di,[di]		{NEXT holen}
	call	LocalFree
@@f:	or	di,di
	jnz	@@l
 end;

function LocalAllocW(siz:Word):Word;
 begin
  siz:=LocalAlloc(LPTR,siz);
  if siz=0 then RunError(221);
  LocalAllocW:=siz;
 end;

type			{Standardbauelemente-Liste (in der IEI-IEO-Kette)}
 PIoNode=^TIoNode;
 TIoNode=record
  next: Word;		{nchstes Listenelement}
  eventproc: TNearProc;	{Ereignis-Prozedur mit msg, wParam und lParam}
  steckplatz: Byte;
  devs: Byte;
  sizeperdev: Word;
  case Integer of
   0: (data: array[0..0] of Char);
{  855: pio: TPIO;}
{  856: sio: TSIO;}
   857: (ctc: TCTC);
{  858: dma: TDMA;}
{  8272: fdc: TFDC;}
 end;
const			{Nachrichten fr EventProc}
 SIZE_IoNode_Header=8;
 IOEV_GetDataSize=1;	{Ermitteln der Gre der bentigten Zusatzdaten}
 IOEV_InitData=2;	{Initialisieren von Datenfeldern, insbesondere Sprungadressen}
 IOEV_Connect=3;	{Anschlieen der peripheren Leitungen}
 IOEV_IAck=4;		{Interrupt-Besttigungs-Zyklus der CPU}
 IOEV_RETI=5;		{RETI-Zyklus (Interrupt-Ende)}
 IOEV_Reset=7;		{RESET-Signal fr den Chip}
 IOEV_Destroy=7;	{Entfernung des Chips; zunchst wie RESET}
 IOEV_Load=9;		{Laden eines gespeicherten Zustandes}
 IOEV_Save=10;		{Speichern eines Momentanzustandes}

procedure MakeRepIoNodeCall; assembler;
{PE: AH=Message, AL=MaxQuery (0=keine Abfrage), DI=PIoNode
 PA: bei CY=1:
	AX=Ergebnis
	CL=Steckplatzschacht
	CH=Gertenummer (0-basiert)
     bei CY=0:
	CL=Steckplatzchacht
	CH=min(devs,MaxQuery)
 VR: AL,BX,CX,DX,DI - weitere (SI) je nach Callback
 Schleife bricht vorzeitig ab, wenn ein Callback CY setzt
 Der Callback wird aufgerufen mit:
 AH=Message, DI=Gerte-interner Strukturzeiger,
 CH=Gertenummer, CL=Steckplatz, BX=Strukturgre (von AH=1).
 Der Callback darf alle Register auer SI und DI (und BP sowieso) verndern}
 asm	mov	cx,word ptr TIoNode[di].steckplatz	{CH=devs}
	cmp	al,ch
	jc	@@min
	xchg	ch,al
@@min:	mov	ch,0
	or	al,al
	jz	@@e	{Das war's, nichts weiter}
	mov	bx,TIoNode[di].sizeperdev
	mov	dx,TIoNode[di].eventproc
	add	di,SIZE_IoNode_Header
@@l:	push	ax
	 push	bx
	 push	cx
	 push	dx
	  call	dx	{darf DI nicht verndern!}
	 pop	dx
	 pop	cx
	 pop	bx
	 jc	@@ex
	pop	ax
	inc	ch
	add	di,bx
	dec	al
	jnz	@@l
	ret
@@ex:	pop	dx	{Stack-Wert verwerfen}
@@e:
 end;

function MakeIoNode(EventP: TNearProc; Steck:Word):Word; assembler;
{Erzeugt eine Instanz (Speichereinheit) fr ein Standard-Peripherieelement,
 welches fortan mit dem Returnwert (Zeiger auf lokalen Speicher) angesprochen
 werden kann. Der Steckplatz ist fr die sptere Einfge-Sortierreihenfolge
 wichtig. Gelscht wird der entstandene Node mit LocalFree().
 MakeIoNode liefert immer ein gltiges Handle;
 bei Speichermangel erfolgt Programm-Abbruch}
 asm	mov	dx,[EventP]
	push	dx
	 mov	ah,IOEV_GetDataSize
	 call	dx
{liefert AH=NumDevs und AL=SizePerDev}
	 push	ax
	  mul	ah
	  add	ax,SIZE_IoNode_Header
	  push	ax
	  call	LocalAllocW
	  xchg	di,ax
	 pop	ax
	 mov	TIoNode[di].devs,ah
	 cbw
	 mov	TIoNode[di].sizeperdev,ax
	pop	dx
	mov	TIoNode[di].eventproc,dx
	mov	ax,[Steck]
	mov	TIoNode[di].steckplatz,al
	push	di	{fr Returnwert}
	 mov	ax,IOEV_InitData*256+0FFh
	 call	MakeRepIoNodeCall	{NumDev-mal aufrufen}
	pop	ax
 end;

procedure InsertIoNode(N: Word); assembler;
{Im Gegensatz zu InsertKCModul() gibt's hier niemals FALSE. Bei identischem
 Steckplatz wird hinter vorhandenen Einheiten auf gleichem Steckplatz
 eingefgt}
{Schleifen-Krper: BX=Einfge-Node, SI=Vorgnger-Node, DI=Nachfolger-Node}
 asm	mov	di,offset IoChain
	mov	bx,[N]
	mov	ah,TIoNode[bx].steckplatz
@@l:	mov	si,di
	mov	di,[di]
	or	di,di
	jz	@@break
	mov	al,TIoNode[di].steckplatz
	cmp	al,ah
	jbe	@@l		{kleiner oder gleich: Schleife wiederholen!}
@@break:
	mov	[bx],di		{N^.next einsetzen}
	mov	[si],bx		{Vorgnger^.next einsetzen}
 end;

function RemoveIoNode(N: Word):Boolean; assembler;
{N mu sich in der Liste wiederfinden lassen;
 N wird nur aus der Liste entfernt, wird jedoch selbst nicht freigegeben}
 asm	mov	bx,[N]
	mov	di,offset IoChain
	xor	ax,ax		{FALSE}
@@l:	mov	si,di
	mov	di,[di]
	or	di,di		{NIL?}
{$IFOPT D+}
	jnz	@@found
 INT 3
	jmp	@@e
@@found:
{$ELSE}
	jz	@@e
{$ENDIF}
	cmp	di,bx		{Gleich?}
	jne	@@l		{nein, weitersuchen}
	mov	[bx],ax		{next-Feld nullsetzen}
	mov	ax,[di]
	mov	[si],ax		{Knoten (DI=BX) aushngen}
	inc	ax		{TRUE}
@@e:	end;

procedure ClearIoNodes; assembler;
{Alle IO-Nodes lschen}
 asm	xor	di,di
	xchg	di,[IoChain]	{gleichzeitig nullsetzen}
	jmp	@@f
@@l:
	push	di
	mov	di,[di]		{NEXT holen}
	call	LocalFree
@@f:	or	di,di
	jnz	@@l
 end;

procedure DispatchIOWrite; near; assembler;
 asm	mov	di,ax
	and	di,0FFh
	add	di,di
	jmp	word ptr [PortsOut+di]
 end;

procedure DispatchIORead; near; assembler;
 asm	mov	di,ax
	and	di,0FFh
	add	di,di
	jmp	word ptr [PortsIn+di]
 end;

procedure SwitchM022; assembler;
{Aufruf mit si=Objektzeiger, bl=neues Steuerbyte; VR: alle}
 asm
{1.: Test, ob sich berhaupt etwas ndert}
	mov	al,bl
	xor	al,TMemNode[si].steuerbyte
	and	al,0c3h		{unwesentliche Bits ausmaskieren}
	jz	@@e		{Wenn sich gar nichts ndert: raus!}
{2.: Test, ob nur das Schreibfreigabe-Bit geschaltet werden soll}
	cmp	al,2		{das einzige, was sich ndern darf!}
	jnz	@@nowr
	mov	al,bl
	test	al,1
	jz	@@nowr		{betrifft nur eingeschaltete Module}
	push	si		{EinblendNode}
	and	ax,2
	shr	ax,1
	push	ax		{neue Schreibfreigabe}
	call	SchalteSchreibfreigabe
	jmp	@@e
{3.: Eventuell eingeschaltetes Modul ausschalten}
@@nowr:
	test	TMemNode[si].steuerbyte,1
	jz	@@no_off
	pusha			{Register retten}
	 push	si
	 push	0
	 call	SchalteEinAus
	popa
@@no_off:
{4.: fertig, wenn Modul nur ausgeschaltet wird}
	test	bl,1
	jz	@@e		{fertig, wenn's ausbleiben soll}
{5.: Neue Einblendadressen eintragen}
	mov	al,bl
	mov	TMemNode[si].steuerbyte,al	{eintragen}
	shr	al,2
	and	al,30h
	mov	TSegment[si+SegStart].a,al
	add	ax,15		{15KB}
	mov	TSegment[si+SegStart].e,al
{5.: Modul (an neuer Adresse) einschalten}
	push	si
	push	1
	call	SchalteEinAus
@@e:
 end;

procedure IOW80; near; assembler;
{Modulsteuerung, hier: 16K-Modul M022}
 asm	cmp	ah,08
	jc	@@e
{und nun ist in BL das Steuerbyte}
	pusha
	push	es
	 call	FindKCModul
	 jc	@@e1
	 call	TMemNode[si].switchproc
@@e1:	pop	es
	popa
@@e:
 end;

procedure KC3IOW88; near; assembler;
 asm	push	ax
	 mov	al,bl
	 xchg	al,[KC4Port88H]
	 xor	al,bl
	 test	al,80h
	 jz	@@nobasic
	 pusha
	 push	es
	  shr	bl,7
	  push	word ptr [NodeBasic]
	  push	bx
	  call	SchalteEinAus
	 pop	es
	 popa
@@nobasic:
	 test	al,4	{IRM ein/aus}
	 jz	@@noirm
	 pusha
	 push	es
	  shr	bl,2
	  and	bl,1
	  push	word ptr [NodeIRM]
	  push	bx
	  call	SchalteEinAus
	 pop	es
	 popa
@@noirm:
	pop	ax
 end;

procedure KC3IOW89; near; assembler;
 asm	mov	[KC4Port89H],bl
 end;

(*
procedure IOWrite3; near; assembler;
 asm	cmp	al,80h
	jne	@@joj
	jmp	IOW80
@@joj:	cmp	al,89h
	jnz	@@w1
	mov	[KC4Port89H],bl
	jmp	@@e
@@w1:	cmp	al,88h
	jnz	@@e
	push	ax
	 mov	al,bl
	 xchg	al,[KC4Port88H]
	 xor	al,bl
	 test	al,80h
	 jz	@@nobasic
	 pusha
	 push	es
	  shr	bl,7
	  push	word ptr [NodeBasic]
	  push	bx
	  call	SchalteEinAus
	 pop	es
	 popa
@@nobasic:
	 test	al,4	{IRM ein/aus}
	 jz	@@noirm
	 pusha
	 push	es
	  shr	bl,2
	  and	bl,1
	  push	word ptr [NodeIRM]
	  push	bx
	  call	SchalteEinAus
	 pop	es
	 popa
@@noirm:
	pop	ax
@@e: end;
*)
procedure SetNewPixmap(x,y:Integer; Bunt:Boolean); forward;
procedure ChrBoxChanged; forward;
function SetBorder(NewBorder: Integer):Boolean; forward;

procedure IOWZ88; near; assembler;
 asm
	pusha
	push	es
	 mov	al,bl
	 xchg	al,[KC4Port88H]
	 xor	al,bl
	 test	al,4		;{Bit-Vernderung: Videomodus-Umschaltung?}
	 jz	@@e1		;{nein}
	 test	bl,4
	 jz	@@a1
	 mov	[ChrBoxKC.Y],10
	 push	320
	 push	200
	 jmp	@@w1
@@a1:
	 mov	[ChrBoxKC.Y],8
	 push	320
	 push	192
@@w1:	 mov	al,true
	 cmp	[KCTyp],7	;{in Farbe?}
	 sbb	al,0
	 push	ax
	 call	SetNewPixmap	;{Speicherlschung hier nicht erforderlich}
	 call	ChrBoxChanged
	 mov	ax,offset IRM_Update1
	 cmp	[KCTyp],7	;{Welches Update bitteschn?}
	 jne	@@b1
	 mov	ax,offset IRM_Update7
@@b1:	 call	ax
@@e1:	 cmp	[KCTyp],7	;{Bildrandfarbe ndern?}
	 jne	@@e2
	 mov	al,[KC4Port88H]
	 and	ax,38h
	 shr	ax,3		;{Index zurechtschieben}
	 push	ax
	 call	SetBorder	;{Rand ggf. ndern (lassen)}
@@e2:	pop	es
	popa
 end;

procedure IOW4_88; near; assembler;
 asm
	push	ax
	 mov	al,bl
	 xchg	al,[KC4Port88H]
	 xor	al,bl		;{Bit-Vernderungen}
	 test	al,80h		;{Betrifft BASIC-ROMC?}
	 jz	@@1
	 test	[KC4Port86H],80h	{CAOS ROMC eingeschaltet?}
	 jnz	@@1		;{Nichts tun! (der ist hherpriorisiert)}
	 pusha
	 push	es
	  push	48		;{ab 48K (0c000h)}
	  test	bl,80h		;{EIN oder AUS?}
	  jnz	@@ein
	  push	0
	  jmp	@@aus
@@ein:	  push	word ptr [IRom+4]	{HC-BASIC}
@@aus:	  push	0		;{Start im Segment}
	  push	8		;{Kilobytes}
	  push	1
	  call	map
	 pop	es
	 popa
@@1:	pop	ax
 end;

procedure IOW4_89; near; assembler;
 asm
	push	ax
	 mov	al,bl
	 xchg	al,[KC4Port89H]
	 xor	al,bl		;{Bit-Vernderungen}
	 test	al,80h		;{Betrifft Blinken?}
	 jz	@@1
@@1:	pop	ax
 end;

procedure IOW4_84; near; assembler;
 asm
	push	ax
	 mov	al,bl
	 xchg	al,[KC4Port84H]
	 xor	al,bl		;{Bit-Vernderungen}
	 test	al,6		;{Pixel/Farb- oder Bild-Umschaltung?}
	 jz	@@1
	 pusha
	 push	es
	  push	32		;{ab 32K (8000h)}
	  push	[KCIRM].Sel
	  mov	al,[KC4Port84H]
	  and	ax,6
	  shl	ax,13
	  mov	[KCIRM].Ofs,ax	;{neu!}
	  shr	ax,10		;{in Kilobytes}
	  push	ax
	  push	10		;{Kilobytes}
	  push	true
	  call	Map		;{Map-In, kein Map-Out erforderlich!}
	 pop	es
	 popa
@@1:	 test	al,9		;{Modus- oder Bild-Umschaltung?}
	 jz	@@2
	 call	IRM_Update4	;{Komplett neu zeichnen}
@@2:	pop	ax
 end;

procedure IOW4_86; near; assembler;
 asm
	push	ax
	 mov	al,bl
	 xchg	al,[KC4Port86H]
	 xor	al,bl		;{Bit-Vernderungen}
	 test	al,80h		;{Betrifft CAOS-ROMC?}
	 jz	@@1
	 pusha
	 push	es
	  push	48		;{ab 48K (0c000h)}
	  test	bl,80h		;{EIN oder AUS?}
	  jnz	@@caos
	  test	[KC4Port88H],80h
	  jnz	@@basic
	  push	0
	  jmp	@@aus
@@caos:	  push	word ptr [IRom+2]	{CAOS-ROMC}
	  jmp	@@aus
@@basic:  push	word ptr [IRom+4]	{HC-BASIC}
@@aus:	  push	0		;{Start im Segment}
	  push	8		;{Kilobytes}
	  push	1
	  call	map
	 pop	es
	 popa
@@1:	pop	ax
 end;

(*
procedure IOWrite4; near; assembler;
 asm	cmp	al,88h
	jne	@@w1
	jmp	IOW4_88
@@w1:	cmp	al,89h
	jne	@@w2
	jmp	IOW4_89
@@w2:	cmp	al,84h
	jne	@@w3
	jmp	IOW4_84
@@w3:	cmp	al,86h
	jne	@@w4
	jmp	IOW4_86
@@w4: end;
*)
(*
procedure IOWrite13; near; assembler;
 asm	cmp	al,2
	jne	@@w1
	jmp	IOW13_2
@@w1:	{cmp	al,3
	jne	@@w2
	jmp	IOW13_3
@@w2:}	cmp	al,8
	jne	@@w3
	mov	[Z1013Port8],bl
@@w3: end;
*)
procedure IOR80; near; assembler;	{Module KC85}
 asm	cmp	ah,08h		{keine "internen" Module schalten!}
	jc	@@e
	push	si
	 call	FindKCModul
	 mov	al,TMemNode[si].strukturbyte
	pop	si
	jc	@@e		{kein Modul!}
	ret
@@e:	mov	al,0FFh		{kein Modul}
 end;

procedure IOR88; near; assembler;	{PIO KC85 und Z9001}
 asm	mov	al,[KC4Port88H]
 end;

procedure IOR89; near; assembler;	{PIO KC85}
 asm	mov	al,[KC4Port89H]
 end;

procedure IOW13_2; near; assembler;	{PIO Z1013 Kanal B}
 asm
	and	bl,10010000b
	mov	[Z1013Port2],bl
 end;

procedure IOW13_8; near; assembler;	{Tastaturspaltendekoder Z1013}
 asm	and	bl,0Fh
	mov	[Z1013Port8],bl
 end;

const
 KTABA: array[0..55] of char=		{fr Z1013 A2}
	'1QAY2WSX3EDC4RFV5TGB6ZHN7UJM8IK,9OL.0P+/-@*^[]\_'+
	#$17#$0D#$08#$09' '#$00#$0B#$0A;

procedure IORead13A_2; near; assembler;
{Z1013-Tastaturabfrage}
 asm
	mov	bx,[Z1013Key]
	and	bl,bl
	jz	@@inf
	mov	al,[Z1013Port8]	{Spalte}
	cmp	al,6
	jnz	@@sp6
	test	bh,2
	jz	@@sp6
	test	[Z1013Port2],10h
	jnz	@@sp6
	mov	al,$D
	jmp	@@in

@@sp6:	cmp	al,7
	jnz	@@spx
	test	[Z1013Port2],10h
	jz	@@inf
	test	bh,4
	jz	@@sp7
	mov	al,$B
	jmp	@@in

@@sp7:	cmp	bl,$16
	jnz	@@inf
	mov	al,7
	jmp	@@in

@@spx:  shl	al,3
	test	[Z1013Port2],10h
	jz	@@1
	add	al,4
@@1:	xor	ah,ah
	push	si
	push	cx
	 lea	si,[KTABA]
	 add	si,ax
	 xor	cl,cl
@@2:	 lodsb
	 cmp	al,bl
	 jz	@@3
	 inc	cl
	 cmp	cl,4
	 jnz	@@2
@@3:	 mov	al,$FE
	 rol	al,cl
	 and	al,$F
	pop	cx
	pop	si
	jmp	@@in
@@inf:	mov	al,$F
@@in:	or	al,[Z1013Port2]{Tape-Bit noch setzen!!!}
 end;

const
 KTABB: array[0..95] of Char=		{fr Z1013 Brosig}
	#$0B#$08#$0A#$05#$03#$8E#$86#$20+
	#$82#$83#$84#$85#$88#$87#$89#$8A+
	#$0D#$FF'\'+#$FF#$14#$01#$FF#$FF+
	#$15#$09#$1B#$16#$10#$12#$7F#$1E+
	'JIHGFEDC'+
	#$00#$00#$00#$81#$00#$00#$00#$00+
	':]['#$16'=-98'+
	#$00#$00#$00#$00#$00#$00#$00#$00+	{Spalte Shift+Control}
	'76543210'+
	'ZYXWVUTS'+
	'BA'#$0B'/.,'#$93''''+
	'RQPONMLK';
 {Spalte Shift+Control Belegung:
  0: ?
  1: ?
  2: ?
  3: ?
  4: -
  5: Grafik
  6: Shift
  7: Grafik
 }

procedure IORead13B_2; near; assembler;
 asm
	cmp	WordRec[Z1013Key].lo,0
	jz	@@inf		{keine Taste gedrckt}
	mov	al,[Z1013Port8]
	mov	cl,96		{alle Codes}
	mov	bx,offset KTabB
	cmp	al,0Fh
	je	@@allkeys	{Test: irgendeine Taste gedrckt?}
	cmp	al,12
	jnc	@@inf		{keine Tastenabfrage}
	cmp	al,7
	je	@@modkeys
	shl	al,3		{*8}
	add	bl,al
	adc	bh,0		{BX=Such-Startadresse}
	mov	cl,8		{8 Codes zum Vergleich}
@@allkeys:
	mov	al,WordRec[Z1013Key].lo
@@such:	cmp	[bx],al
	jz	@@found
	inc	bx
	dec	cl
	jnz	@@such
	jmp	@@inf		{nicht gefunden}
@@found:
	mov	al,8
	sub	al,cl		{Zeile ermitteln (1-->7, 2-->6, 8-->0)}
	jmp	@@in
@@modkeys:
	mov	cl,WordRec[Z1013Key].hi
	mov	al,-1
	test	cl,2		{Control}
	jz	@@1
	mov	al,1
@@1:	test	cl,4		{Shift}
	jz	@@2
	mov	al,6
@@2:
	jmp	@@in
@@inf:	mov	al,-1
@@in:	inc	al
	xor	al,0Fh
	or	al,[Z1013Port2]{Tape-Bit noch setzen!!!}
 end;
(*
procedure IORead13; near; assembler;
 asm	cmp	al,2
	jnz	@@w
	jmp	IORead13_2
@@w:	mov	al,$ff
 end;
*)
function MakeFrameRgn:HRgn;
 var
  R: TRect;
  r1,r2: HRgn;
 begin
  GetClientRect(MainWnd,R);
  r1:=CreateRectRgnIndirect(R);
  r2:=CreateRectRgnIndirect(ScreenBox);
  CombineRgn(r1,r1,r2,RGN_Diff);
  DeleteObject(r2);
  MakeFrameRgn:=r1;
 end;

function SetBorder(NewBorder: Integer):Boolean;
 var
  Color: TColorRef;
  fr: HRgn;
 begin
  Color:=0;
  if NewBorder>=0 then Color:=Palette.col[NewBorder];
  if Color<>BorderRGB then begin
   BorderRGB:=Color;
   fr:=MakeFrameRgn;
   InvalidateRgn(MainWnd,fr,true);
   DeleteObject(fr);
  end;
 end;

procedure AttachPalette;
{Palette auswechseln (fr High- und True-Color erforderlich)}
 var
  DC:HDC;
 begin
  DC:=GetDC(MainWnd);
  if hPal<>0 then begin
   SelectPalette(DC,GetStockObject(Default_Palette),false);
   DeleteObject(hPal);
  end;
  hPal:=CreatePalette(PLogPalette(@Palette)^);
  SelectPalette(DC,hPal,false);
  ClrsRealized:=0;	{RealizePalette() erzwingen}
  ReleaseDC(MainWnd,DC);
 end;

procedure SetPalette(NewPal:PDefPal);
 var
  I: Integer;
 begin
  if PalPtr<>NewPal then begin
   PalPtr:=NewPal;
   Palette.palVersion:=$0300;
   Palette.palNumEntries:=32;
   if PtrRec(PalPtr).Ofs<>0 then begin
    for I:=0 to PalPtr^.num-1 do Palette.col[I]:=PalPtr^.col[I];
   end;
   for I:=24 to 31 do Palette.col[I]:=AnimCol;{hier Animationsfarben setzen}
   AttachPalette;
  end;
 end;

function GetNormalBorder:Integer; assembler;
{Fr den Fall "Skalierbares Fenster" ist der Rand unwirksam; liefert Null}
 asm	xor	ax,ax
	test	[DispFlags],ScalableWindow
	jnz	@@e
	mov	ax,[Border]
@@e:
 end;

function ClientSize(Mag,Border:Integer):LongInt; assembler;
{Ergebnis uninteressant wenn maximiert auf ganzen Desktop sowie
 wenn frei skalierbar (kann dann als Minimum herhalten)}
 asm	mov	cx,[Mag]
	mov	bx,[Border]
	add	bx,bx
	mov	ax,[KCPixmap.y]
	mul	cx
	add	ax,bx
	push	ax
	 mov	ax,[KCPixmap.x]
	 mul	cx
	 add	ax,bx
	pop	dx
 end;

function WindowSize(Mag,Border:Integer):LongInt; assembler;
{Ergebnis uninteressant wenn maximiert auf ganzen Desktop sowie
 wenn frei skalierbar (kann dann als Minimum herhalten)}
 asm	push	[Mag]
	push	[Border]
	call	ClientSize
	add	ax,[Saum.x]
	add	dx,[Saum.y]
 end;

procedure ChrBoxChanged; assembler;
{bei Vernderungen der Bildgre, Skalierung, Border oder ChrBoxKC mssen:
 * ChrBox
 * PixBox
 * ScreenBox
 * ggf. die reale Fenstergre
 nachgefhrt werden}
 var
  R: TRect;
 asm	{1. Schritt: ChrBox und PixBox berechnen}
	mov	cx,[Magnify]
	mov	ax,[ChrBoxKC.X]
	mul	cl
	mov	[ChrBox.X],ax
	mov	ax,[ChrBoxKC.Y]
	mul	cl
	mov	[ChrBox.Y],ax
	mov	al,8
	mul	cl
	mov	[PixBox],ax	{fr Inval8x8 - bei Vollgrafik-Computern}
{2. ScreenBox-Ausdehnung berechnen (X=SI und Y=DI)}
	mov	ax,[KCPixmap.x]
	mul	cx
	xchg	si,ax
	mov	ax,[KCPixmap.y]
	mul	cx
	xchg	di,ax
{3. Testen auf notwendige Anpassung von ClientSize}
	push	[MainWnd]
	lea	ax,[R]
	push	ss
	push	ax
	call	GetClientRect
	push	[MainWnd]
	call	IsZoomed	{!! konfus falls Fenster mimimiert!?}
	or	ax,ax
	mov	dx,[Border]
	jnz	@@zoomed
	test	[DispFlags],ScalableWindow
	jz	@@calc		{nicht skalierbar: auf jeden Fall rechnen}
	xor	dx,dx		{hier: kein Rand erzwingen}
	cmp	si,[R.right]
	ja	@@calc		{zu klein: Neuberechnung!}
	cmp	di,[R.bottom]
	ja	@@calc		{zu klein: Neuberechnung!}
	jmp	@@ncalc
@@zoomed:
	test	[DispFlags],EntireDesktop
	jnz	@@ncalc		{nie rechnen}
@@calc:
{4. Berechnen von neuer (Mindest-)ClientSize, PE: DX=Rahmenbreite}
	add	dx,dx
	mov	ax,si
	add	ax,dx
	mov	bx,di
	add	bx,dx
	cmp	ax,[R.right]
	jne	@@swp
	cmp	bx,[R.bottom]
	je	@@ncalc		{kein (unntiges) SetWindowPos}
{5. Setzen der realen Fenstergre
 !! SPTER unter Beachtung, da das Fenster nicht aus Desktop herausfllt?}
@@swp:	inc	[ResizeLock]
	push	[MainWnd]
	push	0
	push	0
	push	0
	add	ax,[Saum.x]
	add	bx,[Saum.y]
	push	ax
	push	bx
	push	SWP_NoMove or SWP_NoZOrder or SWP_NoActivate
	call	SetWindowPos
	dec	[ResizeLock]
{5.a Ermitteln des dadurch neuen Client-Rechtecks}
	push	[MainWnd]
	lea	ax,[R]
	push	ss
	push	ax
	call	GetClientRect
@@ncalc:
{6. Berechnen von neuer, zentrierter ScreenBox}
	mov	ax,[R.right]
	sub	ax,si
	sar	ax,1
	mov	[ScreenBox.left],ax
	add	ax,si
	mov	[ScreenBox.right],ax

	mov	ax,[R.bottom]
	sub	ax,di
	sar	ax,1
	mov	[ScreenBox.top],ax
	add	ax,di
	mov	[ScreenBox.bottom],ax
 end;



procedure CPUEmu; near; external;
procedure CallAX; near; external;
procedure DoNMI; near; external;
procedure DoINT; near; external;	{Interrupt mit Vektor AL ausfhren}
procedure DoReset; near; external;	{Prozessor-Reset}
{$L KC880}

function KC3GetDividerCTC0:Word; near; assembler;
 asm	mov	ax,56		{Doppelte Zeilenfrequenz bzgl. 1.75 MHz}
 end;

function KC3GetDividerCTC2:Word; near; assembler;
 asm	mov	ax,35000	{Bildfrequenz (50 Hz) bzgl. 1.75 MHz}
 end;

function KC7GetDividerCTC3:Word; near; assembler;
 asm	mov	ax,256*$96	{eigentlich: Zeitgeber-Ausgang von Kanal 2}
 end;

procedure KC3SoundR; near; assembler;
{Sound-Ausgabe rechter Kanal; PE: DX:AX=Gesamtteiler}
 asm	cmp	[WaveOption],3
	jne	@@ex		{Keine Tonausgabe wenn nicht PC-Speaker}
	pusha
	push	es
	 mov	cx,ax
	 or	cx,dx
	 jz	@@stop
 {Teiler_PC:=Teiler_KC*2/Frequenz_KC*Frequenz_PC}
	 add	ax,ax
	 adc	dx,dx
	 jnz	@@stop		{Teiler zu gro}
	 push	ax
	 push	1193		{Taktfrequenz PC}
	 push	[KCClock]
	 call	MulDiv
	 push	ax
	  cli
	  mov	al,0B6h
	  out	43h,al
	 pop	ax
	 out	42h,al
	 xchg	ah,al
	 out	42h,al
	 sti
	 in	al,61h
	 or	al,3
	 out	61h,al
	 jmp	@@e
@@stop:
	 in	al,61h
	 and	al,not 3
	 out	61h,al
@@e:
	pop	es
	popa
@@ex:
 end;

procedure KC3SoundL; near; assembler;
{Sound-Ausgabe linker Kanal; PE: DX:AX=Gesamtteiler}
{Zu beachten ist noch der angeschlossene Taktteiler am CTC-Ausgang!}
 asm	{call	KC3SoundR}
 end;

procedure CtcOut; near; external;
{Ausgabe-Aufruf mit AX=Portadresse, BL=Datenbyte, DI=LOW(Portadresse)*2}
procedure CtcIn; near; external;
{Eingabe-Aufruf mit AX=Portadresse, DI=LOW(Portadresse)*2, RET:AL=Datenbyte}
function Event_CTC(Msg,wParam:Word; lParam: LongInt):Word; near; external;
{$L KCCTC}

procedure InsertKC3CTC;
{Einfgen und "Anschlieen" der CTC in der KC85-Serie}
 var
  io: PIoNode;
  i: Integer;
 begin
  io:=Ptr(Seg(HInstance),MakeIoNode(ofs(Event_CTC),0));
  io^.ctc[0].getp:=ofs(KC3GetDividerCTC0);
  io^.ctc[1].getp:=ofs(KC3GetDividerCTC0);
  io^.ctc[2].getp:=ofs(KC3GetDividerCTC2);
  io^.ctc[3].getp:=ofs(KC3GetDividerCTC2);
  io^.ctc[0].putp:=ofs(KC3SoundR);
  io^.ctc[1].putp:=ofs(KC3SoundL);
  for i:=0 to 3 do begin
   PortsOut[$8C+i]:=ofs(CtcOut);
   PortsIn[$8C+i]:=ofs(CtcIn);
   PortsInstL[$8C+i]:=ofs(io^.ctc[i]);
  end;
  InsertIoNode(ofs(io^));
 end;

procedure InsertKC7CTC;
{Einfgen und "Anschlieen" der CTC in der KC87-Serie}
{IEI-IEO-Verkettung:
 1. Steckkarten
 2. PIO Tastatur
 3. PIO User
 4. CTC: typischer Robotron-Schwachsinn}
 var
  io: PIoNode;
  i: Integer;
 begin
  io:=Ptr(Seg(HInstance),MakeIoNode(ofs(Event_CTC),3));
  io^.ctc[3].getp:=ofs(KC7GetDividerCTC3); {die anderen sind unbeschaltet}
  io^.ctc[0].putp:=ofs(KC3SoundR);
  for i:=0 to 3 do begin
   PortsOut[$80+i]:=ofs(CtcOut);
   PortsIn[$80+i]:=ofs(CtcIn);
   PortsInstL[$80+i]:=ofs(io^.ctc[i]);
  end;
  InsertIoNode(ofs(io^));
 end;

{Die KC's mten sich eigentlich strukturieren lassen!}
type
 TKCInfo=record
  memwrite: Word;	{Speicherschreib-Prozedur}
  event: TCallEvent;	{Langsame Prozeduren mit KCEV_xxx-Konstanten}
  screen: TPoint;	{(anfngliche) Bildschirmgre in Pixeln}
  color: Boolean;
  freq: Word;		{Nominelle Taktfrequenz}
  rom: array[0..3] of Word;	{Bis zu 4 intiale ROMs automatisch laden}
  romaddr: array[0..3] of Word;	{Initiale Einblendadressen}
  DefPal: Word;		{Offset zur Default-Palette}
 end;
const
 KCEV_Init=DRV_User+1;	{lParam zeigt auf Hilfe-Datei}
 KCEV_Done=DRV_User+2;
 KCEV_KeyDown=DRV_User+3;
 KCEV_KeyUp=DRV_User+4;
 KCEV_Copy=DRV_User+5;
 KCEV_PasteHint=DRV_User+6;
 KCEV_Reset=DRV_User+7;	{wParam=0: kalt, wParam=1: warm}
 KCEV_Repaint=DRV_User+8;
 KCEV_Load=DRV_User+9;
 KCEV_Save=DRV_User+10;
 KCEV_ReasCallHint=DRV_User+11;
  {nach CALL zu bestimmten Adressen steht oft DB xx als UP-Nr., systemabh.}
 KCEV_GetKeyword=DRV_User+12;
  {Hilfe zu Schlsselwort an Cursorposition (wParam=-1)
   bzw. an Mausposition (wParam.lo=X, wParam.hi=Y, Cursor-Koordinaten)}

function LoadKCMem(src:Pointer; dst:Word; len:Word):Boolean; assembler;
{liefert FALSE, wenn sich nach dem Laden Bytes unterscheiden}
{!!spter: Nicht vergessen, Breakpoints auf Speicherschreibzugriff totzulegen}
 asm	cld
	les	si,[src]
	mov	bx,[dst]
	mov	cx,[len]
	mov	ah,TRUE
	jcxz	@@e
@@l:	seges	lodsb
	push	es
	 mov	es,[MemKCSel]
	 call	[memwr]
	 cmp	al,es:[bx]	{gleich?}
	 je	@@1
	 mov	ah,FALSE
@@1:	 inc	bx
	pop	es
	loop	@@l
@@e:	xchg	ah,al
 end;

function ModulProc(Wnd:HWnd; Msg,wParam:Word; lParam:LongInt):Bool; export;
{nichtmodales Fenster zum Stecken und Ziehen von KC-Modulen}
 var
  S: array[byte] of Char;
  I,K: Integer;
  W: HWnd;
  IA: array[0..34] of Integer;		{Index-Array, wir haben 35 Module}
 begin
  ModulProc:=false;
  case Msg of
   WM_InitDialog: begin
    W:=GetDlgItem(Wnd,104);
    for I:=2048 to 2082 do begin
     LoadString(Seg(HInstance),I,S,sizeof(S));
     SendMessageP(W,LB_AddString,0,@S);
    end;
    ModulProc:=true;
   end;
   WM_Activate: if wParam<>0 then hKBWnd:=Wnd else hKBWnd:=0;
   WM_EnterIdle: SendMessage(MainWnd,Msg,wParam,lParam);
					{wird nur frs Systemmen gebraucht}
   WM_Command: case wParam of
    102: begin				{Dazu}
     W:=GetDlgItem(Wnd,104);
     K:=SendMessageP(W,LB_GetSelItems,sizeof(IA) div 2,@IA);
     for I:=0 to K-1 do begin
      SendMessageP(W,LB_GetText,IA[I],@S);
      SendDlgItemMsgP(Wnd,101,LB_AddString,0,@S);
     end;
    end;
    103: begin				{Weg}
     W:=GetDlgItem(Wnd,101);
     K:=SendMessageP(W,LB_GetSelItems,sizeof(IA) div 2,@IA);
     for I:=0 to K-1 do begin
      SendMessage(W,LB_DeleteString,IA[I],0);
     end;
    end;
    ID_OK: ;				{Module wirksam machen}
    ID_Cancel: DestroyWindow(Wnd);	{Wegtreten}
    9: WinHelp(Wnd,HelpFile,HELP_Context,105);
   end;
   WM_Destroy: begin
    hModul:=0;
   end;
  end;
 end;

function KeySetProc(Wnd:HWnd; Msg,wParam:Word; lParam:LongInt):Bool; export;
{Modaler Dialog: Scancode setzen}
 var
  f: Integer;
 begin
  KeySetProc:=false;
  case Msg of
   WM_InitDialog: begin
    SetDlgItemText(Wnd,100,PChar(lParam));
    KeySetProc:=true;
   end;
   WM_Command: case wParam of
    ID_OK,ID_Cancel: EndDialog(Wnd,1);
    9: WinHelp(Wnd,HelpFile,HELP_Context,205);
   end;
  end;
 end;

function KeymapProc(Wnd:HWnd; Msg,wParam:Word; lParam:LongInt):Bool; export;
{nichtmodales Fenster zum Festlegen der Tastaturzuordnung}
 var
  lPar: LongRec absolute lParam;
  S: array[0..31] of Char;
  I,K: Integer;
  W: HWnd;
 begin
  KeymapProc:=false;
  case Msg of
   WM_InitDialog: begin
    W:=GetWindow(Wnd,GW_Child);		{Fensterliste durchgehen}
    repeat
     I:=GetDlgCtrlID(W)-100;
     if (0<I) and (I<100) then begin	{Scancode?}
      if I>=70 then I:=I or $100;	{Nicht den num. Block!}
      if GetKeyNameText(MakeLong(0,I),S,sizeof(S)-1)>0 then begin
       S[4]:=#0;			{String begrenzen}
       SetWindowText(W,S);		{Neuer Schriftzug!}
      end;
     end;
     W:=GetWindow(W,GW_HWndNext);
    until W=0;
    KeymapProc:=true;
   end;
   WM_Activate: if wParam<>0 then hKBWnd:=Wnd else hKBWnd:=0;
   WM_EnterIdle: SendMessage(MainWnd,Msg,wParam,lParam);
					{wird nur frs Systemmen gebraucht}
   WM_Command: case wParam of
    101..199: begin
     I:=wParam-100;
     if I>=70 then I:=I or $100;	{Nicht den num. Block!}
     if GetKeyNameText(MakeLong(0,I),S,sizeof(S)-1)<=0
     then GetWindowText(lPar.Lo,S,sizeof(S));
     DialogBoxParam(Seg(HInstance),MakeIntResource(205),Wnd,@KeySetProc,
       LongInt(@S));
    end;
    ID_OK: ;				{Tastatur wirksam machen}
    ID_Cancel: DestroyWindow(Wnd);	{Wegtreten}
    9: WinHelp(Wnd,HelpFile,HELP_Context,204);
   end;
   WM_Destroy: hKeymap:=0;
  end;
 end;

function AboutProc(Wnd:HWnd; Msg,wParam:Word; lParam:LongInt):Bool; export;
 const
  RME: array[0..18]of Char='NOTEPAD README.TXT';
 var
  f: Integer;
 begin
  AboutProc:=false;
  case Msg of
   WM_InitDialog: AboutProc:=PostMessage(Wnd,WM_User+100,0,0);
   WM_User+100: begin
    f:=_lopen(RME+8,0);
    if f<>-1 then begin
     _lclose(f);
     EnableWindow(GetDlgItem(Wnd,11),true);
    end;
   end;
   WM_Command: case wParam of
    ID_OK,ID_Cancel: EndDialog(Wnd,1);
    11: WinExec(RME,SW_Show);
   end;
  end;
 end;

procedure SetBlinken(NewBlinken:Boolean);
 begin
  if (DispFlags and Blinken <>0)<>NewBlinken then begin
   asm xor [DispFlags],Blinken end;
   if (2<=KCTyp) and (KCTyp<=6) then begin
    if NewBlinken
    then SetTimer(MainWnd,1,400,nil)
    else KillTimer(MainWnd,1);
   end;
  end;
 end;


function GetTitleFirst:PChar;
 begin
  GetTitleFirst:=AppName;
  if (EmuShowClock and 8 <>0) and (KCTyp<>0)
  then GetTitleFirst:=KCName;
 end;

procedure AppendMagnify(S: PChar);
 begin
  if (magnify>1) and (not IsIconic(MainWnd))
  then wvsprintf(S+lstrlen(S),'  [%dX]',magnify);
 end;

procedure ShowFreq;
 var
  vsrec: record
   sp: PChar;
   over: PChar;
   hz: LongInt;	{bestehend aus Zahl und Rest}
  end;
  S: array[0..63] of Char;
 begin
  vsrec.sp:=GetTitleFirst;
  vsrec.over:='>';
  if Freq<>$FFFF then Inc(vsrec.over);	{Kein ">" anzeigen}
  if EmuShowClock and 3 >1 then begin
   vsrec.hz:=LongDivWR(Freq,1000);
   wvsprintf(S,'%s - %s%u.%03u MHz',vsrec);
  end else begin
   vsrec.hz:=LongDivWR(MulDivW(Freq,1000,KCClock),10);
		{!! Gefahrenstelle (/0 ERROR) wenn KCClock<1000}
   wvsprintf(S,'%s - %s%u.%u %%',vsrec);
  end;
  AppendMagnify(S);
  SetWindowText(MainWnd,S);
 end;

procedure SetFreq(NewFreq:Word);	{Freq in Kilohertz}
{Wird niemals gerufen, wenn EmuBlock<>0}
 begin
  if Freq<>NewFreq then begin
   Freq:=NewFreq;
   if (EmuShowClock and 3 =0)
   or (EmuShowClock and 4 =0) and IsIconic(MainWnd)
   then exit;	{nichts tun!}
   ShowFreq;
  end;
 end;

procedure ShowBlocked;		{Anzeige "KC-Emulator (Angehalten)"}
 var
  vsrec: record
   s1,s2: PChar;
  end;
  S: array[0..63] of Char;
  S1: array[0..16] of Char;
 begin
  vsrec.s1:=GetTitleFirst;
  LoadString(Seg(HInstance),107,S1,sizeof(S1));
  vsrec.s2:=S1;
  wvsprintf(S,'%s (%s)',vsrec);
  AppendMagnify(S);
  SetWindowText(MainWnd,S);
 end;

procedure DrawTitle;		{Neuzeichnen des Titels}
 begin
  if (EmuShowClock and 3 =0)
  or (EmuShowClock and 4 =0) and IsIconic(MainWnd) and (EmuBlock=0)
  then SetWindowText(MainWnd,GetTitleFirst)
  else if EmuBlock<>0 then ShowBlocked else ShowFreq;
 end;

procedure SetBlock(NewBlock:Byte);	{<>0 wenn Blockierung}
 begin
  if EmuBlock<>NewBlock then begin
   if EmuShowClock and 3 <>0 then begin	{sonst nichts an Titelzeile tun!}
    if (EmuBlock=0) and (NewBlock<>0) then ShowBlocked;
    if (EmuBlock<>0) and (NewBlock=0) then begin
     ShowFreq;				{Frequenz wieder anzeigen}
     TickTaken:=cTicks;
     TimeTaken:=Word(GetTickCount);	{Neue Messung}
    end;
   end;
   CheckMenuItem(GetMenu(MainWnd),230,
     Bool2MenuCheck(Bool(NewBlock and $10)) or MF_ByCommand);
   EmuBlock:=NewBlock;
  end;
 end;

procedure SetShowClock(NewShowClock:Integer);
 begin
  if EmuShowClock<>NewShowClock then begin
   EmuShowClock:=NewShowClock;
   DrawTitle;
  end;
 end;

procedure SetMenuFlags(NewMenuFlags:Integer);
 var
  M: HMenu;
  I,Mask: Word;
 begin
  M:=GetMenu(MainWnd);
  Mask:=1;
  for I:=201 to 203 do begin
   if (NewMenuFlags xor MenuFlags) and Mask <>0 then begin
    MenuFlags:=MenuFlags xor Mask;
    CheckMenuItem(M,I,Bool2MenuCheck(Bool(MenuFlags and Mask)));
   end;
  end;
 end;

function GetWindowArgs(Wnd: HWnd):Boolean;
{liefert TRUE, wenn alle Argumente okay oder auch leere Zeichenkette.
 PA: LoadSaveArgs gefllt
 Args.argn enthlt die gewandelte Argumente-Zahl, auch bei Rckkehr mit FALSE}
 var
  S: array[0..31] of Char;
  SP,SP1,SP2: PChar;
  EC: Integer;
 begin
  GetWindowArgs:=false;
  SP:=S+1;
  GetWindowText(Wnd,SP,sizeof(S)-1);
  LoadSaveArgs.argn:=0;
  while (LoadSaveArgs.argn<3)
  and (SP^<>#0) do begin
   SP1:=lStrChr(SP,' ');
   if SP1<>nil then SP1^:=#0;	{am Leerzeichen terminieren}
   if SP^='#' then SP2:=SP+1	{Dezimal-Kennung}
   else begin
    SP2:=SP-1;
    SP2^:='$';			{Prfix fr Hex-VAL}
   end;
   Val(SP2,LoadSaveArgs.arg[LoadSaveArgs.argn+1],EC);
   if EC<>0 then exit;		{Fehler!}
   if SP1<>nil then SP:=SP1+1 else SP^:=#0;
   Inc(LoadSaveArgs.argn);
  end;
  GetWindowArgs:=true;
 end;

procedure SetWindowArgs(Wnd: HWnd);
{setzt bis zu 3 hexadezimale Argumente, mit je 1 Leerzeichen getrennt
 PE: LoadSaveArgs: Argumente}
 var
  S: array[0..31] of Char;
  I: Integer;
  Z: Integer;
 begin
  Z:=0;		{Zeichenzahl}
  for I:=1 to LoadSaveArgs.argn do begin
   Inc(Z,wvsprintf(S+Z,'%04X',LoadSaveArgs.arg[I]));
   if I<>LoadSaveArgs.argn then begin
    S[Z]:=' '; Inc(Z);
   end;
  end;
  S[Z]:=#0;
  SetWindowText(Wnd,S);
 end;

function GetFileArgs(f,Typ: Integer):Boolean;
{Typ ist hierbei bitteschn niemals 0!
 Liefert in LoadSaveArgs die "Argumente" der Datei
 f ist eine frisch zum Lesen geffnete Datei, Dateizeiger=0!
 liefert FALSE wenn keine gltige .KCC-Datei, zu groe Binrdatei oder
 ungltiges BASIC-Programm. Bei FALSE ist LoadSaveArgs.argn undefiniert!}
 var
  Z80Hdr: TZ80Hdr;
  KccHdr: TKccHdr absolute Z80Hdr;
  L: LongInt;
 begin
  GetFileArgs:=false;
  case Typ of
   1: begin
    _lread(f,PChar(@KCCHdr),sizeof(KCCHdr));
    if (KccHdr.args.argn<2) or (KccHdr.args.argn>10) then exit;
    _llseek(f,$80,0);
    Move(KccHdr.args,LoadSaveArgs,sizeof(LoadSaveArgs));
    if LoadSaveArgs.argn>3 then LoadSaveArgs.argn:=3;
   end;
   2: begin
    L:=_llseek(f,0,2);
    if L>$BE00 then exit;	{SOO groe Programme gibt's ja gar nicht!}
    _llseek(f,0,0);
    LoadSaveArgs.argn:=2;
    LoadSaveArgs.arg[1]:=$200;		{mal angenommen}
    LoadSaveArgs.arg[2]:=LoadSaveArgs.arg[1]+LongRec(L).Lo;
   end;
   3: begin
    LoadSaveArgs.argn:=2;
    LoadSaveArgs.arg[1]:=$401;		{Anfang fr ROM-BASIC}
    _lread(f,PChar(@LoadSaveArgs.arg[2]),2);{Zeiger jetzt richtig}
    if LoadSaveArgs.arg[2]>$BB00 then exit;	{BASIC-Programm zu gro}
    Inc(LoadSaveArgs.arg[2],LoadSaveArgs.arg[1]);
   end;
   4: begin
    _lread(f,PChar(@Z80Hdr),sizeof(Z80Hdr));
    if (Z80Hdr.magic[0]<>Z80Hdr.magic[1])
    or (Z80Hdr.magic[0]<>Z80Hdr.magic[2]) then exit;
    if (Z80Hdr.magic[0]<>#$d3) and (Z80Hdr.magic[0]<>'.') then exit;
    LoadSaveArgs.argn:=2;
    if Z80Hdr.typ='C' then LoadSaveArgs.argn:=3;
    LoadSaveArgs.arg:=Z80Hdr.arg;
   end;
  end;
  GetFileArgs:=true;
 end;

procedure ResizeDlgWindow(Wnd:HWnd; X,Y: Integer);
 var
  R: TRect;
 begin
  GetWindowRect(Wnd,R);	{Fenster vergrern}
  Inc(R.right,X);		{hier: ungenutzt}
  Inc(R.bottom,Y);
  MoveRectIntoFullScreen(R);	{zu groes R.bottom verhindern}
  MoveWindow(Wnd,R.left,R.top,R.right-R.left,
    R.bottom-R.top,false);
 end;

const
 ID_OfnFileEdit=1152;
 ID_OfnFileList=1120;
 ID_OfnFilter=1136;
 ID_OfnComment=100;
 ID_OfnHelp=1038;
 ID_OfnWriteProt=1040;
var
 WM_FileOK: Word;
var
 SFile: array[0..255] of Char;
 SFilter: array[0..255] of Char;
 SExt: array[0..15] of Char;
function OFNHook(Wnd:HWnd; Msg,wParam:Word; lParam:Longint):Word;
  export; forward;
const
 Ofn: TOpenFileName=(
  lStructSize: sizeof(TOpenFileName);
  hWndOwner: 0;
  hInstance: Seg(HInstance);
  lpstrFilter: SFilter;
  lpstrCustomFilter: SExt;
  nMaxCustFilter: sizeof(SExt);
  nFilterIndex: 0;
  lpstrFile: SFile;
  nMaxFile: sizeof(SFile);
  lpstrFileTitle: nil;
  nMaxFileTitle: 0;
  lpstrInitialDir: nil;
  lpstrTitle: nil;
  Flags: OFN_LongNames or OFN_FileMustExist or OFN_ShowHelp
    or OFN_EnableHook or OFN_OverwritePrompt;
  nFileOffset: 0;
  nFileExtension: 0;
  lpstrDefExt: nil;
  lCustData: 0;
  lpfnHook: OfnHook;
  lpTemplateName: nil);

function OFNHook(Wnd:HWnd; Msg,wParam:Word; lParam:Longint):Word;
{Diese Hook-Funktion verlngert die Datei-ffnen-Standarddialoge um eine
 Zeile fr Anfangs-, End- und (ggf) Startadresse.
 LoadSaveArgs enthlt die Daten des Zusatzfensters.
 lCustData zeigt auf TArgs-Struktur.}
 label err;
 var
  lPar: LongRec absolute lParam;
  S: array[0..31]of Char;	{Dateiname sowie Lade-Strings}
  f: Integer;
  R: TRect;
  P: TPoint;
  Fnt: HFont;
  W: HWnd absolute P;
  ofnp: POpenFileName absolute lParam;
 begin
  OFNHook:=0;
  case Msg of
   WM_InitDialog: begin
    WM_FileOK:=RegisterWindowMessage(FileOKString);
    Longint(P):=GetDialogBaseUnits;
    GetClientRect(Wnd,R);	{Neue Dialogelemente an die Unterkante}
    LoadString(Seg(HInstance),104,S,sizeof(S));
    SetDlgItemText(Wnd,ID_OfnWriteProt,S);
    LoadString(Seg(HInstance),103,S,sizeof(S));
    Fnt:=SendMessage(Wnd,WM_GetFont,0,0);
    SendMessage(CreateWindow('STATIC',S,
      WS_Child or WS_Visible or SS_Left or WS_Group,
      MulDiv(P.X,6,4),R.bottom,MulDiv(P.X,34,4),MulDiv(P.Y,8,8),
      Wnd,Word(-1),Seg(HInstance),nil),WM_SetFont,Fnt,0);
    SendMessage(CreateWindow('EDIT','',
      WS_Child or WS_Visible or WS_Border or WS_TabStop
      or ES_Left or ES_AutoHScroll {or ES_ReadOnly},
      MulDiv(P.X,40,4),R.bottom+MulDiv(P.Y,-2,8),
      R.right+MulDiv(P.X,-46,4),MulDiv(P.Y,10,8),
      Wnd,ID_OfnComment,Seg(HInstance),nil),WM_SetFont,Fnt,0);
    ResizeDlgWindow(Wnd,0,MulDiv(P.Y,14,8));
    OfnHook:=1;
   end;

   WM_Command: case wParam of
	{ID_OfnFilter unntig, Dateiliste wird ohnehin neu aufgebaut}
    ID_OfnFileList: if lPar.Hi=LBN_SelChange then begin
     ofn.nFilterIndex:=SendDlgItemMessage(Wnd,ID_OfnFilter,CB_GetCurSel,0,0)+1;
     R.left:=SendMessage(lPar.Lo,LB_GetCurSel,0,0);
     W:=GetDlgItem(Wnd,ID_OfnComment);
     SetWindowText(W,'?');
     if R.left<0 then exit;	{mit Fragezeichen stehenlassen}
     SendMessageP(lPar.Lo,LB_GetText,R.left,@S);
     f:=_lopen(S,0);
     if f=-1 then exit;
     if GetFileArgs(f,ofn.nFilterIndex)
     then SetWindowArgs(W);
     _lclose(f);
    end;

    ID_OfnHelp: WinHelp(Wnd,HelpFile,HELP_Context,102);

   end{case wParam};
   else if Msg=WM_FileOK then begin
    W:=GetDlgItem(Wnd,ID_OfnComment);
    if not GetWindowArgs(W) then goto err;
    if LongRec(ofnp^.flags).lo and OFN_HideReadOnly <>0	{SAVE}
    then case ofnp^.nFilterIndex of
     1,2: if LoadSaveArgs.argn<2 then goto err;
    end else case ofnp^.nFilterIndex of		{LOAD}
     1: if LoadSaveArgs.argn<2 then goto err;
     2: if LoadSaveArgs.argn<1 then goto err;
    end;
    exit;
err:
    MBox1(Wnd,106,nil);
    SetEditFocus(W);
    OfnHook:=1;		{Nicht weiterarbeiten!}
   end;

  end{case Msg};
 end;

function lstrcmpin2(LongS,ShortS:PChar):Integer;
{Ist ShortS der Anfang von LongS?}
 var
  c: Char;
  SP: PChar;
 begin
  SP:=LongS+lstrlen(ShortS);
  c:=SP^;
  SP^:=#0;
  lstrcmpin2:=lstrcmpi(LongS,ShortS);
  SP^:=c;
 end;

function FindExtensionInFilter:PChar;
 var
  I: Integer;
  SP1: PChar;
 begin
  SP1:=SFilter;
  for I:=Integer(Ofn.nFilterIndex)*2 downto 2	{min. 1x}
  do Inc(SP1,lstrlen(SP1)+1);
  FindExtensionInFilter:=SP1;
 end;

procedure PrepareOFN;
 var
  SP1,SP2:PChar;
  I: Integer;
 begin
  Ofn.hWndOwner:=MainWnd;
  LoadString(Seg(HInstance),102,SFilter,sizeof(SFilter));
  if Integer(Ofn.nFilterIndex)<>0 then begin
   SP1:=FindExtensionInFilter;
{Bug der COMMDLG.DLL bereinigen (welcher war das?)}
   if lstrcmpin2(SP1,SExt+1)<>0 then begin
    SP2:=SP1+lstrlen(SP1);	{String-Ende}
    memmove(SP1+lstrlen(SExt+1),SP2,SFilter+sizeof(SFilter)-SP2);
    lstrcpy(SP1,SExt+1);	{User-Extension einfgen}
   end;
  end;
  SFile[0]:=#0;
  ofn.lpstrDefExt:=nil;
 end;

function ScanInt(var SP: PChar; var I:Integer):Boolean;
{Zerhackt den String durch Ersetzung von Leerzeichen}
 var
  SP1: PChar;
  K,EC: Integer;
 begin
  ScanInt:=false;
  SP1:=lStrChr(SP,' ');
  if SP1<>nil then SP1^:=#0;
  Val(SP,K,EC);
  if EC=0 then begin
   if SP1<>nil then SP:=SP1+1 else Inc(SP,lstrlen(SP));
   I:=K;
   ScanInt:=true;
  end;
 end;

function ScanFreq(SP: PChar; F:PWord):Boolean;
{Was, wenn ich keine Gleitkommazahlen WILL!?}
 var
  SP1: PChar;
  K,L,M: Word;
  EC: Integer;
 begin
  ScanFreq:=false;
  SP1:=lStrChr(SP,'.');
  if SP1=nil then SP1:=lStrChr(SP,',');	{auch ein Komma ist hier zulssig}
  if SP1<>nil then SP1^:=#0;
  Val(SP,K,EC);			{Vorkommastellen}
  if EC<>0 then exit;
  if K>8 then exit;		{mehr als 8MHz sind utopisch!}
  M:=1000;
  K:=K*M;
  L:=0;
  if SP1<>nil then begin
   Inc(SP1);
   Val(SP1,L,EC);
   if EC<>0 then exit;
   while SP1^<>#0 do begin
    M:=M div 10;
    if M=0 then exit;
    Inc(SP1);
   end;
   K:=K+L*M;
  end;
  if F<>nil then F^:=K;		{keine Zuweisung, nur Test bei NIL}
  ScanFreq:=true;		{alles okay}
 end;

procedure ApplyColorTable;
 var
  C: array[0..31] of TRGBQuad;
  I: Integer;
 begin
  for I:=0 to 31 do with C[I],TPaletteEntry(Palette.col[I]) do begin
   rgbBlue:=peBlue;		{einzelbyteweise, weil verdreht!}
   rgbGreen:=peGreen;
   rgbRed:=peRed;
   rgbReserved:=peFlags;
  end;
  WinGSetDibColorTable(WinGDC,0,32,PRGBQuad(@C));
 end;

procedure ClearDisplayBuffer;
{gibt den hDisplay-Puffer frei und ggf. die zugehrige WinG-Pixmap}
 begin
  if hDisplay<>0 then begin
   if (DispFlags and UseWinG <>0) and (WinGBM<>0) then begin
    SelectObject(WinGDC,WinGBMMono);
    DeleteObject(WinGBM);
    WinGBM:=0;
    hDisplay:=0;
   end else hDisplay:=GlobalFree(hDisplay);
  end;
 end;

function MyLoadLibrary(LibName: PChar): THandle;
 var
  OldErrorMode: Word;
 begin
  OldErrorMode:=SetErrorMode(SEM_NoOpenFileErrorBox);
  MyLoadLibrary:=LoadLibrary(LibName);
  SetErrorMode(OldErrorMode);
 end;

function SetWinGUse(NewUse:Boolean):Boolean;
{diese Funktion erlaubt sogar das Ein- und Ausschalten von WinG
 whrend der Emulation, indem ggf. der Bildspeicher umgeschaufelt wird}
 const
  LibName='WING.DLL';
  SecName='WinG';
  KeyName='ProfileMessage';
 var
  S: array[0..255] of Char;
  hMem: THandle absolute S;
  P: Pointer absolute S;
 begin
  SetWinGUse:=true;
  if NewUse<>(DispFlags and UseWinG <>0) then begin
   if NewUse then begin
    LoadString(Seg(HInstance),109,S,sizeof(S));
    WriteProfileString(SecName,KeyName,S);	{eine deutsche Meldung geben}
    WinGInst:=MyLoadLibrary(LibName);	{das Laden fhrt ggf. zum Profiling}
    WriteProfileString(SecName,KeyName,nil);	{wieder lschen!}
    if WinGInst>=32 then begin
     TFarProc(@WinGCreateDC):=		GetProcAddress(WinGInst,PChar(1001));
     TFarProc(@WinGCreateBitmap):=	GetProcAddress(WinGInst,PChar(1003));
     TFarProc(@WinGSetDibColorTable):=	GetProcAddress(WinGInst,PChar(1006));
     TFarProc(@WinGStretchBlt):=	GetProcAddress(WinGInst,PChar(1009));
     TFarProc(@WinGBitBlt):=		GetProcAddress(WinGInst,PChar(1010));
     WinGDC:=WinGCreateDC;
     if hDisplay<>0 then begin
      WinGBM:=WinGCreateBitmap(WinGDC,KCPixmap.bi,@P);
      if WinGBM<>0 then begin
       if PtrRec(P).Ofs <>0 then RunError(222);
       hmemcpy(P,Ptr(hDisplay,0),DisplaySize);	{umschaufeln}
       GlobalFree(hDisplay);
       hDisplay:=PtrRec(P).Sel;
       WinGBMMono:=SelectObject(WinGDC,WinGBM);
       ApplyColorTable;
      end;
     end;
     asm or DispFlags,UseWinG end;
    end else begin
     MBox1(MainWnd,110,LibName);	{spter: Verzweigung?}
     SetWinGUse:=false;			{einziger Fall des Versagens}
    end;
   end else begin
    if WinGBM<>0 then begin		{momentan Bitmap in Verwendung?}
     hMem:=GlobalAlloc(GMEM_Fixed,DisplaySize);
     if hMem=0 then RunError(220);	{Hoppla!?}
     hmemcpy(Ptr(hMem,0),Ptr(hDisplay,0),DisplaySize);
     ClearDisplayBuffer;		{UseWinG ist noch TRUE!}
     hDisplay:=hMem;
    end;
    DeleteDC(WinGDC);
    FreeLibrary(WinGInst);
    asm and DispFlags,not UseWinG end;
   end;
  end;
 end;

function GSM: Integer; near; assembler;
{GetSystemMetrics fr Assembler-Gebrauch, PE: AL=Konstante
 (macht nur mit NEAR Sinn)}
 asm	cbw
	push	ax
	call	GetSystemMetrics
 end;

function FindMagnify(x,y,bor:Integer):Integer; assembler;
{Ermittelt grtmgliche Vergrerung fr angegebenes Rahmenrechteck,
 Routine lt SI und DI unverndert}
 asm	mov	ax,1
	cmp	ax,[KCPixmap.x]
	jg	@@e
	cmp	ax,[KCPixmap.y]
	jg	@@e
	mov	bx,[bor]
	add	bx,bx
	mov	ax,[y]
	sub	ax,[Saum.y]
	sub	ax,bx
	cwd
	idiv	[KCPixmap.y]
	xchg	cx,ax
	mov	ax,[x]
	sub	ax,[Saum.x]
	sub	ax,bx
	cwd
	idiv	[KCPixmap.x]
	cmp	ax,cx
	jl	@@t
	xchg	cx,ax
@@t:	or	ax,ax
	jg	@@e
	mov	ax,1	{mindestens Eins! (und nie negativ)}
@@e:
 end;

function GetBorderSizes: LongInt; assembler;
{ermittelt Randbreiten des Hauptfensters als Punkt (Lo=X und Hi=Y=DI)}
 asm	mov	al,SM_CYFrame
	call	GSM		{Y}
	push	ax
	 mov	al,SM_CXFrame
	 call	GSM		{X}
	pop	dx
 end;

function MaxDisplayMagnify: Integer; assembler;
{Liefert grte vollstndig darstellbare Vergrerung
 je nach KCPixmap und Bildgre, mindestens jedoch 1 (fr Windows CE:-)}
 asm	call	GetBorderSizes
	xchg	si,ax
	mov	di,dx
	mov	al,SM_CXFullScreen
	call	GSM
	add	ax,si
	push	ax
	mov	al,SM_CYFullScreen
	call	GSM
	add	di,ax
	mov	al,SM_CYCaption
	call	GSM
	add	ax,di
	push	ax
	push	0		{mit Border=0 rechnen}
	call	FindMagnify
 end;

function MaximumMagnify: Integer;
 begin
  if FullMag=0
  then MaximumMagnify:=MaxDisplayMagnify
  else MaximumMagnify:=FullMag;
 end;

function GetMainWndPlacement(var wp:TWindowPlacement): Bool;
{auerdem: Bugfix fr showcmd whrend Initialisierung}
 begin
  wp.length:=sizeof(wp);
  GetMainWndPlacement:=GetWindowPlacement(MainWnd,@wp);
  if not IsWindowVisible(MainWnd) then wp.showcmd:=SW_Hide;
 end;

procedure SetMainWndPlacement(const wp: TWindowPlacement);
{auerdem: Bugfix fr IsZoomed}
 begin
  SetWindowPlacement(MainWnd,@wp);	{wird nicht wirksam wenn IsZoomed!}
  if IsZoomed(MainWnd) then begin
   Inc(ResizeLock);
   SetWindowPos(MainWnd,0,wp.ptMaxPosition.x,wp.ptMaxPosition.y,
     $7FFF,$7FFF,SWP_NoZOrder or SWP_NoActivate);
   Dec(ResizeLock);
  end;
 end;
(*
procedure ResizeWindow;
{Fenster an neue ClientSize anpassen, sofern Border<>AUTO}
 begin
  if (Border>=0)
  then SetWindowPos(MainWnd,0,0,0,ClientSize.x+Saum.x,ClientSize.y+Saum.y,
    SWP_NoMove or SWP_NoZOrder);
 end;
*)
procedure SetNewPixmap(x,y:Integer; Bunt:Boolean);
{x darf nicht 0 sein, sonst wrde das Fenster zu schmal gesetzt werden.
 y dagegen darf 0 sein und stellt den Client-Bereich auf Hhe Null}
 var
  WP: TWindowPlacement;
  NewDisplay: Boolean absolute WP;
  I: Integer absolute WP;
  P: Pointer absolute WP;
 begin
  NewDisplay:=hDisplay=0;	{neues Display auf jeden Fall wenn Null}
  if (KCPixmap.x<>x) or (KCPixmap.y<>y) then begin
   KCPixmap.x:=x;
   KCPixmap.y:=y;		{Neue Dimensionen eintragen}
(* if y<>0 then begin		{Nullclient sieht erst mal doof aus!}
    wp.length:=sizeof(wp);
    if GetMainWndPlacement(WP)
    then with WP,WP.rcNormalPosition do begin
     right:=left+x+Border+Border+Saum.x;
     bottom:=top+y+Border+Border+Saum.y;
     SetMainWndPlacement(WP);	{Fenster umsetzen}
    end;
   end;
*)
   NewDisplay:=true;
  end;
  if bunt and (KCPixmap.b=1) then begin
   KCPixmap.b:=8;
   KCPixmap.c:=32;
   NewDisplay:=true;
  end;
  if not bunt and (KCPixmap.b<>1) then begin
   KCPixmap.b:=1;
   KCPixmap.c:=2;
   NewDisplay:=true;
  end;
  if NewDisplay then begin
   ClearDisplayBuffer;			{alles aufrumen}
   if not bunt then x:=x shr 3;		{S/W: 1 Byte fr 8 Pixel!}
   if y<>0 then begin
    DisplaySize:=LongMul(x+3 and not 3,y);{Auf /4 teilbare Bytezahl aufrunden}
    if DispFlags and UseWinG <>0 then begin
     WinGBM:=WinGCreateBitmap(WinGDC,KCPixmap.bi,@P);
     if WinGBM<>0 then begin		{ist 0 z.B. bei Win31 und S/W-Bitmap}
      WinGBMMono:=SelectObject(WinGDC,WinGBM);
      ApplyColorTable;
      hDisplay:=PtrRec(P).Sel;
      if PtrRec(P).Ofs<>0 then RunError(222);	{Oops?}
     end;
    end;
    if hDisplay=0 then hDisplay:=GlobalAlloc(GMEM_Fixed,DisplaySize);
    if hDisplay=0 then RunError(220);
   end;
   asm or DispFlags,DrawFrame end;	{irgendwie ist's erforderlich!}
   InvalidateRect(MainWnd,nil,true);	{hier: einschlielich Rand!}
  end;
 end;

procedure PokeKC3Char(C:Char); assembler;
 asm	mov	es,[MemKCSel]
	mov	al,[C]
	mov	bx,[Regs.IX]
	add	bx,0dh
	call	[MemWR]
	add	bx,8-0dh
	mov	al,es:[bx]
	or	al,1
	call	[MemWR]		{Keycode-Avail-Bit setzen}
	jmp	@@e
@@e: end;

procedure KeyUpKC3; assembler;
 asm	mov	es,[MemKCSel]
	mov	bx,[Regs.IX]
	add	bx,0dh
	mov	al,0
	call	[MemWR]
		{Tastencode lschen, Keycode-Avail-Bit bleibt stehen!}
 end;

procedure InsertROMs;		{geladene ROMs (wieder) einblenden}
 var
  I: Integer;
 begin
  for I:=0 to 3 do if (IRom[I]<>0) and (IRomAddr[I]<>0)
  then Move(Mem[IRom[I]:0],Mem[MemKCSel:IRomAddr[I]],GlobalSize(IRom[I]));
 end;

function LoadROM(ID:Word):THandle;
 var
  h: THandle;
 begin
  h:=LoadResource(Seg(HInstance),
    FindResource(Seg(HInstance),MakeIntResource(ID),RT_RCData));
  if h=0 then RunError(220);
  LoadROM:=h;
 end;

function MakeNode1(seg,stse,sust,proc,siz,block:Word):Word; assembler;
 asm	push	TYPE TMemNode-12	{nur ein seg}
	call	LocalAllocW
	push	ax
	 xchg	di,ax
	 push	ds
	 pop	es
	 xor	ax,ax
	 cld
	 stosw		{.next lschen}
	 lea	si,block
	 mov	cx,6	{alle Argumente einkopieren}
	 segss
	 rep	movsw
	 stosw		{seg[0].r lschen}
	pop	ax
 end;
{TMemNode sollte auerdem enthalten:
 extra Byte fr Handle-Typ
 extra Byte fr Ein/Aus und Schreibschutz
 neues Word fr Create/Info/Destroy-Prozedur}

procedure BroadcastIoEvent(Msg:Byte); assembler;
 asm	mov	di,offset IOChain
@@l:	mov	di,[di]
	or	di,di
	jz	@@e
	mov	ah,[Msg]
	mov	al,0FFh
	push	di
	 call	MakeRepIoNodeCall
	pop	di
	jmp	@@l
@@e:
 end;

type
 TConvFunc=function(Code:Char):Char;

function KC2Ansi(Code:Char):Char; far;	{fr KC85}
 begin
  Byte(code):=Byte(code) and $7F;
  case Byte(code) of
   $00: KC2Ansi:=' ';
   $5B: KC2Ansi:=#$80;	{Vollcursor}
   $5C: KC2Ansi:='|';
   $5D: KC2Ansi:=#$AC;	{Negation}
   $60: KC2Ansi:=#$A9;	{Copyright}
   $7B: KC2Ansi:=#$E4;	{}
   $7C: KC2Ansi:=#$F6;	{}
   $7D: KC2Ansi:=#$FC;	{}
   $7E: KC2Ansi:=#$DF;	{}
   else KC2Ansi:=code;
  end;
 end;

function NoConversion(Code:Char):Char; far;	{fr Z9001 und Z1013}
 begin
  NoConversion:=Code;
 end;

function GetScreenText(scr_x,scr_y:Integer; scr_a:PChar; Convert:TConvFunc):
  THandle;
{verwendet SelectedRegion, SelectedRect, RandL, RandR}
 var
  SP,SP0: PChar;
  HMem: THandle;
  x,y,siz: Integer;
  R: TRect;
 begin
  CopyRect(R,SelectedRect);
  if SelectedRegion=0 then SetRect(R,0,0,scr_x,scr_y);
  if RandL or RandR =0 then siz:=(R.right-R.left+2)*(R.bottom-R.top+1)+1
  else siz:=(scr_x+2)*scr_y;	{noch unsicher!}
  HMem:=GlobalAlloc(GMEM_Share,siz);
  SP:=GlobalLock(HMem);
  for y:=R.top to R.bottom do begin
   SP0:=SP;
   for x:=R.left to R.right-1 do begin
    SP^:=Convert(scr_a[y*scr_x+x]);
    Inc(SP);
   end;
   if R.top=R.bottom then break;	{Einzeilig: kein CRLF, Spaces lassen}
   while (SP<>SP0) and ((SP-1)^=' ') do Dec(SP);{Nachlaufende Leerzeichen weg}
   SP^:=#13; Inc(SP); SP^:=#10; Inc(SP);
  end;
  SP^:=#0;
  GlobalUnlock(HMem);
  GetScreenText:=HMem;
 end;

procedure IsCAN; assembler;
{PE: AL=Zeichencode, PA: Z=1 wenn nicht alphanumerisch}
 asm	pusha
	push	es
	 push	ax
	 call	IsCharAlphaNumeric
	 or	ax,ax
	pop	es
	popa
 end;

procedure IsCA; assembler;
{PE: AL=Zeichencode, PA: Z=1 wenn kein Buchstabe}
 asm	pusha
	push	es
	 push	ax
	 call	IsCharAlpha
	 or	ax,ax
	pop	es
	popa
 end;

procedure KC3_CharAtDX; assembler;
{PE: DX=Cursorpos in Bildschirm-Koordinaten,
     ES:DI=Video-RAM-Basisadresse
 PA: SI=Video-RAM-Adresse
     AL=Zeichencode
 VR: AL,SI}
 asm	push	ax
	 mov	al,40
	 mul	dh
	 add	al,dl
	 adc	ah,0
	 add	ax,di
	 xchg	si,ax
	pop	ax
	mov	al,es:[si]
 end;

procedure KC3_PreloadBXCXDX; assembler;
{PE: DX=absolute Position oder -1
 PA: CY=1: Fehler (auerhalb BS)}
 asm	mov	cx,es:[0B79Ch]	{Fenster-Anfang}
	mov	bx,es:[0B79Eh]	{Fenster-Lnge}
	add	bl,cl
	add	bh,ch		{2x Fenster-Ende}
	cmp	dx,-1		{DX schon vorgegeben?}
	jne	@@dx_ok
	mov	dx,es:[0B7A0h]
	add	dx,cx		{in Absolutkoordinate umwandlen}
@@dx_ok:
	cmp	dl,40
	jnc	@@inval
	cmp	dh,32
	jnc	@@inval
	cmp	dl,cl
	jc	@@out
	cmp	dl,bl
	jnc	@@out
	cmp	dh,ch
	jc	@@out
	cmp	dh,bh
	jc	@@no_out
@@out:
	mov	cx,0		{BS-Anfang}
	mov	bx,32*256+40	{BS-Ende}
@@no_out:
	stc
@@inval:
	cmc
 end;

procedure KC3_MoveCursor; assembler;
{PE: BX=Fenster-Ende,
     CX=Fenster-Anfang,
     DX=Cursorpos in Bildschirm-Koordinaten,
     ES=[MemKCSel],
     CY=1: Laufrichtung rckwrts
 PA: DX=neue Cursorposition
     CY=1: Kann nicht mehr (DX unverndert)
 VR: BX,CX
 N:  Ist DX innerhalb eines Fensters, bezieht sich der Bewegungsrahmen
     auf das eingestellte Fenster, sonst auf den Bildschirm.
     Routine ist allgemein anwendbar!}
 asm	push	dx
	 jc	@@back
	 inc	dl		{nchste Spalte}
	 cmp	dl,bl		{Rechts raus?}
	 js	@@ok		{nein}
	 mov	dl,cl		{links!}
	 inc	dh		{Nchste Zeile}
	 cmp	dh,bh		{Unten raus?}
	 js	@@ok
	 jmp	@@err
@@back:
	 dec	dl
	 cmp	dl,cl		{Links raus?}
	 jns	@@ok		{nein}
	 mov	dl,bl
	 dec	dl		{doch, rechts!}
	 dec	dh
	 cmp	dh,ch		{Oben raus?}
	 jns	@@ok
@@err:	pop	dx
	stc
	ret
@@ok:	add	sp,2
	clc
 end;

procedure Def_KCM_Event(Msg,wParam:Word; lParam:LongInt);
{verarbeitet gleiche Ereignisse auf allen Mhlhausen-Rechnern}
 begin
  case Msg of
   KCEV_Init: begin
    GetAnimIdx:=Ofs(GetAnimIdx3);
    lstrcpy(PChar(lParam),'KCCAOS');
    PortsIn[$80]:=ofs(IOR80);
    PortsIn[$88]:=ofs(IOR88);
    PortsIn[$89]:=ofs(IOR89);
    PortsOut[$80]:=ofs(IOW80);
   end;
   KCEV_Reset: case wParam of
    0: Regs.pc:=$F000;	{Reset-Startpunkt}
    1: Regs.pc:=$E000;	{PowerOn-Startpunkt}
   end;
   KCEV_KeyDown: PokeKC3Char(Char(wParam));
   KCEV_KeyUp: KeyUpKC3;
   KCEV_PasteHint: asm		{lParam=Zeiger auf Bool}
	mov	es,[MemKCSel]
	mov	bx,[Regs.IX]
	xor	ax,ax
	test	es:byte ptr es:[bx+8],1	{Keycode-Avail-Bit testen}
	jnz	@@1
	inc	ax
@@1:	les	bx,[lParam]
	mov	es:[bx],ax
   end;
   KCEV_GetKeyword: asm		{!! bevorzugt Markierung als Schlsselwort}
	mov	es,[MemKCSel]
	mov	dx,[wParam]
	call	KC3_PreloadBXCXDX
	mov	di,0B200h	{Anfang IRM}
	cmp	[KCTyp],4
	je	@@4extra
	cmp	[KCTyp],5
	jne	@@no4extra
@@4extra:
	mov	di,es:[0B7CBh]	{hier gibt es einen Zeiger!}
@@no4extra:
	call	KC3_CharAtDX
	call	IsCAN
	jnz	@@ok1
	stc
	call	KC3_MoveCursor	{Zurck}
	jc	@@inval
	call	KC3_CharAtDX
	call	IsCAN
	jz	@@inval
@@ok1:	{hier knnte ein Schlsselwort sein; Anfang suchen!}
	mov	ah,8		{max. 8 Zeichen zurckgehen}
@@scanstart:
	stc
	call	KC3_MoveCursor
	jc	@@scanstop
	call	KC3_CharAtDX
	call	IsCAN
	jz	@@scanstop1
	dec	ah
	jnz	@@scanstart
	jmp	@@inval		{kein Anfang gefunden!}
@@scanstop1:
	mov	ah,8		{Suchen nach erstem Buchstaben}
@@scanr1:
	clc
	call	KC3_MoveCursor	{nach rechts}
	jc	@@inval		{rechts raus: Fehler!}
	jmp	@@v1
@@scanstop:
	mov	ah,8		{Suchen nach erstem Buchstaben}
@@v1:
	call	KC3_CharAtDX
	call	IsCA
	jnz	@@startKeyword
	dec	ah
	jnz	@@scanr1
	jmp	@@inval		{kein Buchstabe gefunden, nur Zahlen}
@@startKeyword:
	mov	ah,8		{max. 8 Zeichen}
@@l:	push	es
	 les	si,[lParam]
	 mov	es:[si],al
	 inc	LongRec[lParam].lo
	pop	es
	clc
	call	KC3_MoveCursor	{weiter rechts}
	jc	@@terminate
	call	KC3_CharAtDX
	call	IsCAN		{Alphanumerisch?}
	jz	@@terminate
	dec	ah
	jnz	@@l
@@terminate:
	les	si,[lParam]
	mov	byte ptr es:[si],0
@@inval:
   end;
  end;
 end;

procedure Def_Z_Event(Msg,wParam:Word; lParam:LongInt);
{fr Gemeinsamkeiten bei Z9001/KC87}
 begin
  case Msg of
   KCEV_Init: begin
    KC4Port88H:=0;	{damit die Zuordnung zum initialen Videomodus stimmt}
    lstrcpy(PChar(lParam),'KCZ9001');
    PortsOut[$88]:=ofs(IOWZ88);
    PortsIn[$88]:=ofs(IOR88);
    InsertKC7CTC;
   end;
   KCEV_Reset: Regs.pc:=$F000;	{PowerOn- und Reset-Startpunkt}
   KCEV_Done: begin
    BroadcastIoEvent(IOEV_Destroy);
    ClearIoNodes;
   end;
   KCEV_KeyDown: asm
	mov	es,[MemKCSel]
	mov	al,byte ptr [wParam]
	mov	bx,24h
	call	[memwr]
	inc	bx
	call	[memwr]
   end;
   KCEV_KeyUp: asm
	mov	es,[MemKCSel]
	mov	al,0
	mov	bx,24h
	call	[memwr]
   end;
   KCEV_Copy: begin
    wParam:=24; if KC4Port88H and 4 <>0 then wParam:=20;
    SetClipboardData(CF_Text,
      GetScreenText(40,wParam,Ptr(MemKCSel,$EC00),NoConversion));
   end;
   KCEV_PasteHint: asm		{lParam=Zeiger auf Bool}
	mov	es,[MemKCSel]
	xor	ax,ax
	cmp	es:byte ptr [25h],1	{CY=1: OK fr Paste}
	adc	ax,ax
	les	bx,[lParam]
	mov	es:[bx],ax
   end;
  end;
 end;

function Event1(Msg,wParam:Word; lParam:LongInt):LongInt; far;
 begin
  Def_Z_Event(Msg,wParam,lParam);
  Event1:=0;
  case Msg of
   KCEV_Init: ;
   KCEV_Repaint: IRM_Update1;
   KCEV_Done: ;
  end;
 end;

function Event7(Msg,wParam:Word; lParam:LongInt):LongInt; far;
 begin
  Def_Z_Event(Msg,wParam,lParam);
  case Msg of
   KCEV_Init: begin
    GetAnimIdx:=Ofs(GetAnimIdx7);
    SetBorder(0);
   end;
   KCEV_Repaint: IRM_Update7;
   KCEV_Done: begin
    SetBorder(-1);
   end;
  end;
 end;

(*
function Event2(Msg,wParam:Word; lParam:LongInt):LongInt; far;
 begin
  Def_KCM_Event(Msg,wParam,lParam);
  case Msg of
   KCEV_Repaint: IRM_Update3;
  end;
 end;
function MakeNode(steckplatz:Byte;flags:Byte; start,endi:ShortInt;
  SwitchProc:Word; Strukturbyte:Byte; P:THandle):Word;
 var
  N: PMemNode;
 begin
  N:=Ptr(Seg(Hinstance),LocalAlloc(LPTR,sizeof(TMemNode)));
  if PtrRec(N).Ofs=0 then RunError(221);
  N^.steckplatz:=steckplatz;
  N^.steuerbyte:=flags;
  N^.size:=endi-start+1;		{Notlsung!}
  N^.switchproc:=SwitchProc;
  N^.strukturbyte:=Strukturbyte;
  N^.memblock:=P;
  N^.segments:=1;
  N^.seg[0].a:=start;
  N^.seg[0].e:=endi;
  MakeNode:=PtrRec(N).Ofs;
 end;
*)
function Event3(Msg,wParam:Word; lParam:LongInt):LongInt; far;
 begin
  Def_KCM_Event(Msg,wParam,lParam);
  case Msg of
   KCEV_Init: begin
    KC4Port88H:=$FF;
{    asm int 3 end;}
    FillK(MemKCSel,0,64);	{alles $FF}
    SetWrPerm(0,63,false);	{alles ist schreibgeschtzt}
    NodeRam0:=MakeNode1($0F00,$0100,$03FF,0,16,0);	{ein, schreibbar}
    InsertKCModul(NodeRam0);
    NodeIRM:= MakeNode1($2F20,$0101,$03FF,0,16,0);
    InsertKCModul(NodeIRM);
    if KCTyp<>2 then begin
     NodeBasic:=MakeNode1($3730,$1102,$01FF,0,8,6);
     InsertKCModul(NodeBasic); IRom[1]:=0;	{ROM in Eigenverwaltung}
     NodeCAOS:= MakeNode1($3F38,$3103,$01FF,0,8,IRom[0]);
     InsertKCModul(NodeCAOS); IRom[0]:=0;	{ROM in Eigenverwaltung}
    end;
    InsertKCModul(MakeNode1(0,$0108,$00F4,Ofs(SwitchM022),16,0));
    InsertKCModul(MakeNode1(0,$010C,$00F4,Ofs(SwitchM022),16,0));
    PortsOut[$88]:=ofs(KC3IOW88);
    PortsOut[$89]:=ofs(KC3IOW89);
    InsertKC3CTC;
   end;
   KCEV_Repaint: IRM_Update3;
   KCEV_Done: begin
    ClearKCModules;
    BroadcastIoEvent(IOEV_Destroy);
    ClearIoNodes;
   end;
   KCEV_Copy: begin		{hoffentlich ist der IRM an!}
    SetClipboardData(CF_Text,
      GetScreenText(40,32,Ptr(MemKCSel,$B200),KC2Ansi));
   end;
  end;
 end;

function Event4(Msg,wParam:Word; lParam:LongInt):LongInt; far;
 begin
  Def_KCM_Event(Msg,wParam,lParam);
  case Msg of
   KCEV_Init: begin
    IRom[1]:=GlobalReAlloc(IRom[1],$2000,GMEM_ZeroInit);
    KCIRM.Sel:=PageAlloc(64);
    KCIRM.Ofs:=0;
    KC4Port84H:=0;		{z.Z. Pixel-Zugriff, hohe Auflsung}
    KC4Port86H:=0;
    KC4Port88H:=$FF;
    KC4Port89H:=$FF;
    PortsOut[$84]:=ofs(IOW4_84);
    PortsOut[$85]:=ofs(IOW4_84);
    PortsOut[$86]:=ofs(IOW4_86);
    PortsOut[$87]:=ofs(IOW4_86);
    PortsOut[$88]:=ofs(IOW4_88);
    PortsOut[$89]:=ofs(IOW4_89);
    InsertKC3CTC;
    {InitKCModules;}
   end;
   KCEV_Repaint: IRM_Update4;
   KCEV_Done: begin
    BroadcastIoEvent(IOEV_Destroy);
    ClearIoNodes;
    ClearKCModules;	{noch keine in Betrieb...}
    KCIRM.Sel:=PageFree(KCIRM.Sel);
   end;
   KCEV_Copy: begin		{hoffentlich ist der IRM an!}
    SetClipboardData(CF_Text,
      GetScreenText(40,32,Ptr(MemKCSel,MemW[MemKCSel:$B7CB]),KC2Ansi));
   end;
  end;
 end;

function Event8(Msg,wParam:Word; lParam:LongInt):LongInt; far;
 begin
  SendDriverMessage(UserInfo.hDrv,Msg,lParam,LongInt(@UserInfo));
 end;

function Event9(Msg,wParam:Word; lParam:LongInt):LongInt; far;
 begin
  case Msg of
   KCEV_Init: begin
    lstrcpy(PChar(lParam),'KCZ1013');
    PortsOut[2]:=ofs(IOW13_2);
    PortsOut[8]:=ofs(IOW13_8);
    PortsIn[2]:=ofs(IORead13A_2);
    if KCTyp=8 then PortsIn[2]:=ofs(IORead13B_2);
   end;
   KCEV_Repaint: IRM_Update9;
   KCEV_Done: begin
   end;
   KCEV_Reset: Regs.pc:=$F000;	{PowerOn- und Reset-Startpunkt}
   KCEV_KeyDown: asm
	mov	ax,[wParam]
	xor	ah,ah
	cmp	al,$08; jc @@k1
	cmp	al,$0C; jc @@ke; jz @@k1
	cmp	al,$0D; jz @@ke
	cmp	al,$16; jc @@k1
	cmp	al,$18; jc @@ke
	cmp	al,$20; jz @@ke; jnc @@k2;
@@k1:	add al,$40; or ah,2; jmp @@ke
@@k2:	cmp	al,$2a; jnc @@k3; add al,$10; or ah,4; jmp @@ke
@@k3:	cmp	al,$3a; jc  @@ke
	cmp	al,$40; jnc @@k4; sub al,$10; or ah,4; jmp @@ke
@@k4:	cmp	al,$60; jc  @@ke
	cmp	al,$80; jnc @@k5; sub al,$20; or ah,4; jmp @@ke
@@k5:	xor	al,al
@@ke:	mov	[Z1013Key],ax
   end;
   KCEV_KeyUp: Z1013Key:=0;
   KCEV_Copy: begin
    SetClipboardData(CF_Text,
      GetScreenText(32,32,Ptr(MemKCSel,$EC00),NoConversion));
   end;
  end;
 end;

const
 KCInfo: array[1..9] of TKCInfo=((	{KC85/1 - Z9001}
  memwrite: ofs(MemWrite1);
  event: Event1;
  screen: (x:320; y:192);
  color: false;
  freq: 2458;
  rom:(10131,9001,006,9002);
  romaddr:(0,$F000,$C000,$E000);
  defpal: Ofs(DefPal1)
 ),(					{KC85/2 - HC900}
  memwrite: ofs(MemWrite3);
  event: Event3;
  screen: (x:320; y:256);
  color: true;
  freq: 1750;
  rom:(220,221,0,0);
  romaddr:($E000,$F000,0,0);
  defpal: Ofs(DefPal3)
 ),(					{KC85/3}
  memwrite: ofs(MemWrite3);
  event: Event3;
  screen: (x:320; y:256);
  color: true;
  freq: 1750;
  rom:(310,006,0,0);
  romaddr:($E000,$C000,0,0);
  defpal: Ofs(DefPal3)
 ),(					{KC85/4}
  memwrite: ofs(MemWrite4);
  event: Event4;
  screen: (x:320; y:256);
  color: true;
  freq: 1750;
  rom:(420,421,006,0);
  romaddr:($E000,$C000,0,0);
  defpal: Ofs(DefPal3)
 ),(					{KC85/5 mit CAOS 4.3 (ML)}
  memwrite: ofs(MemWrite4);
  event: Event4;
  screen: (x:320; y:256);
  color: true;
  freq: 1750;
  rom:(430,431,006,0);
  romaddr:($E000,$C000,0,0);
  defpal: Ofs(DefPal3)
 ),(					{KC85/3 mit CAOS 3.4 (h#s)}
  memwrite: ofs(MemWrite3);
  event: Event3;
  screen: (x:320; y:256);
  color: true;
  freq: 1750;
  rom:(340,006,0,0);
  romaddr:($E000,$C000,0,0);
  defpal: Ofs(DefPal3)
 ),(					{KC87 mit Farboption}
  memwrite: ofs(MemWrite7);
  event: Event7;
  screen: (x:320; y:192);
  color: true;
  freq: 2458;
  rom:(10131,9001,006,9002);
  romaddr:(0,$F000,$C000,$E000);
  defpal: Ofs(DefPal7)
 ),(					{Z1013 mit Brosig-ROM}
  memwrite: ofs(MemWrite8);
  event: Event9;
  screen: (x:256; y: 256);
  color: false;
  freq: 2000;
  rom:(10131,10132,0,0);		{ZG und Brosig-ROM (4K)}
  romaddr:(0,$F000,0,0);
  defpal: Ofs(DefPal1)
 ),(					{Z1013 mit A2-ROM}
  memwrite: ofs(MemWrite9);
  event: Event9;
  screen: (x:256; y: 256);
  color: false;
  freq: 2000;
  rom:(10131,10130,0,0);
  romaddr:(0,$F000,0,0);
  defpal: Ofs(DefPal1)
 ));

procedure PowerOn;
 begin
  InsertROMs;
  DoReset;		{CPU-Register rcksetzen}
  CallEvent(KCEV_Reset,0,0);
  SetBlock(EmuBlock and not $10);	{F9-Block aufheben}
 end;

procedure MakeReset;
 begin
  DoReset;		{CPU-Register rcksetzen}
  BroadcastIoEvent(IOEV_Reset);
  CallEvent(KCEV_Reset,1,0);
  SetBlock(EmuBlock and not $10);	{F9-Block aufheben}
 end;

procedure RemoveAnySelection; forward;

procedure RemoveET(S:PChar); assembler;
{&(ET)-Zeichen entfernen, auch fr japanisches Windows?}
 asm	cld
	les	di,[S]
	mov	si,di
@@l:	seges	lodsb
	cmp	al,'&'
	je	@@j		{alle '&' bergehen, doppelte einfach!}
	stosb
	push	es
	push	ax
	 push	ax
	 call	IsDbcsLeadByte	{Windows-Funktionen belassen SI und DI}
	 or	ax,ax
	pop	ax
	pop	es
	jz	@@n
@@j:	seges	lodsb		{Nachfolge-Zeichen unbesehen kopieren}
	stosb			{allerdings auf Null testen!}
@@n:	or	al,al
	jnz	@@l
 end;

procedure SetNewKC(NewKCTyp: Integer);
{hier erfolgt zentral die Ressourcenverwaltung fr die einzelnen Typen.
 Bei bergabe von 0 werden alle Ressourcen freigegeben}
 var
  M: HMenu;
  R: TRect;
  I: Integer;
 begin
  RemoveAnySelection;
  if KCTyp<>NewKCTyp then begin
   M:=GetMenu(MainWnd);
   if KCTyp<>0 then begin
    CheckMenuItem(M,KCTyp+310,MF_Unchecked);
    CallEvent(KCEV_Done,0,0);
    if (DispFlags and Blinken <>0)
    and (KCPixMap.c>2) then KillTimer(MainWnd,1);
    for I:=0 to 3 do
     if IRom[I]<>0 then IRom[I]:=THandle(FreeResource(IRom[I]));
    if KCTyp>=10 then begin
     if UserInfo.hDrv<>0
     then CloseDriver(UserInfo.hDrv,UserInfo.user,LongInt(@UserInfo));
     SetBlock(EmuBlock and not $20);	{NoDLL-Block aufheben}
    end;
   end;
   KCTyp:=NewKCTyp;
   if KCTyp<>0 then begin
    CheckMenuItem(M,KCTyp+310,MF_Checked);
    GetMenuString(M,KCTyp+310,KCName,sizeof(KCName),0);
    RemoveET(KCName);
    ChrBoxKC.X:=8; ChrBoxKC.Y:=8;	{fr die meisten Computer der Fall}
    if KCTyp>=10 then begin
{     Move(screen,UserInfo.screen,12);
     Move(rom,UserInfo.rom,32);}
     lstrcat(KCName,'.KCE');
     UserInfo.hDrv:=OpenDriver(KCName,nil,LongInt(@UserInfo));
     if UserInfo.hDrv<>0 then begin
{      Move(UserInfo.screen,screen,12);
      Move(UserInfo.rom,rom,32);}
     end else begin
      SetBlock(EmuBlock or $20);	{NoDLL-Block setzen}
      MBox1(MainWnd,108,KCName);
     end;
    end else with KCInfo[KCTyp] do begin
     SetPalette(Ptr(Seg(HInstance),defpal));
     SetNewPixmap(screen.x,screen.y,color);
     FillWord(PortsOut,256,ofs(DefDoNothing));
     FillWord(PortsIn,256,ofs(DefIORead));
     if (DispFlags and Blinken <>0)
     and (KCPixMap.c>2) then SetTimer(MainWnd,1,400,nil);
     KCClock:=freq;
 {    FetchInstruction:=ofs(DefFetchInstruction);}
     MemWR:=memwrite;
     IORd:=ofs(DispatchIORead);
     IOWr:=ofs(DispatchIOWrite);
     CallEvent:=event;
 {Initiale ROMs laden}
     for I:=0 to 3 do begin
      if rom[I]<>0 then begin
       IRom[I]:=LoadROM(rom[I]);
       IRomAddr[I]:=romaddr[I];		{Standard-Einblendadresse}
      end;
     end;
    end;
    CallEvent(KCEV_Init,0,LongInt(@CurrentHelpFile));
    if GetFileNameExt(CurrentHelpFile)^=#0
    then lstrcat(CurrentHelpFile,'.HLP');
    PowerOn;				{RESET-Signal}
    CallEvent(KCEV_Repaint,0,0);
   end else ClearDisplayBuffer;		{Display aufrumen}
  end;
 end;

function MakeWaveBlock(var M:THandle):PWaveHdr;
{benutzt globale Variablen hWav und Modus}
 var
  WH: PWaveHdr;
 begin
  M:=GlobalAlloc(GHND or GMEM_Share,sizeof(TWaveHdr)+WAVBLK);
  WH:=GlobalLock(M);
  WH^.lpData:=PChar(WH)+sizeof(TWaveHdr);
  WH^.dwBufferLength:=WAVBLK;
  WaveOutPrepareHeader(hWav,WH,sizeof(TWaveHdr));
  MakeWaveBlock:=WH;
 end;

function FreeWaveBlock(Wav:HWave; var M:THandle):Boolean;
 var
  WH: PWaveHdr;
 begin
  WH:=GlobalLock(M);	{Pointer beschaffen}
  WaveOutUnprepareHeader(Wav,WH,sizeof(TWaveHdr));
  GlobalUnlock(M);
  GlobalUnlock(M);	{der Block war die ganze Zeit gelockt!}
  M:=GlobalFree(M);
  FreeWaveBlock:=true;
 end;

procedure HandleMMError(Code:Integer);
 var
  S: array[byte]of Char;
 begin
  case Code of
   MMSysErr_Allocated: MBox1(MainWnd,117,nil);
   WAVERR_Sync: MBox1(MainWnd,116,nil);
   else begin
    WaveInGetErrorText(Code,S,sizeof(S));
    MBox1(MainWnd,118,S)
   end;
  end;
 end;

procedure SetSound(OnOff:Boolean);
 var
  I:integer;
 begin
  if OnOff then begin
   if WaveOption=1 then begin
    I:=WaveOutOpen(@hWav,WaveOutDev,PWaveFormat(@MyWav),
      MainWnd,0,Callback_Window);
    if I<>0 then begin
     WaveOption:=0;		{kein Sound!!}
     HandleMMError(I);
    end else begin
     CurWaveHdr:=nil;NextWaveHdr:=nil;
    end;
   end;
  end else begin
   WaveOutReset(hWav);
   WaveOutClose(hWav);
   CurWaveHdr:=nil;NextWaveHdr:=nil;
  end;
 end;

function GetMaxPos: LongInt; assembler;
 asm	mov	ax,[MaxPos.x]
	mov	dx,[MaxPos.y]
	test	[DispFlags],EntireDesktop
	jz	@@e
	call	GetBorderSizes
	neg	ax
	neg	dx
@@e:
 end;

procedure SetDispFlags(NewDisplay:Integer);
{Alle Display-Flags setzen, kann die Gre von MainWnd modifizieren;
 ChrBoxChanged mu der Aufrufer anschlieend aufrufen!?}
 var
  W: Byte absolute NewDisplay;
  WX: Byte;
  M: HMenu;
  wp: TWindowPlacement;
  S: TS31;
 begin
  WX:=W xor DispFlags;	{Vernderte Bits}
  M:=GetSystemMenu(MainWnd,FALSE);
  {if WX and UseWinG <>0 then} SetWinGUse(W and UseWinG <>0);
  {if WX and Blinken <>0 then} SetBlinken(W and Blinken <>0);
  if WX and BlinkHighColor <>0 then asm xor DispFlags,BlinkHighColor end;
  if WX and EntireDesktop <>0 then with wp do begin
   asm xor DispFlags,EntireDesktop end;
   GetMainWndPlacement(wp);
   LongInt(ptMaxPosition):=GetMaxPos;
   if W and EntireDesktop <>0 then begin
    if VollbildStr[0]<>#0
    then ModifyMenu(M,SC_Zoom,0,SC_Zoom,VollbildStr);
   end else begin
    LoadString(Seg(HInstance),101,S,sizeof(S));	{Grobild}
    if VollbildStr[0]=#0
    then GetMenuString(M,SC_Zoom,VollbildStr,sizeof(VollbildStr),0);
    ModifyMenu(M,SC_Zoom,0,SC_Zoom,S);
   end;
   SetMainWndPlacement(wp);
  end;
  if WX and ScalableWindow <>0 then begin
   asm
	xor	[DispFlags],ScalableWindow;
   end;
  end;
 end;

{****************************************}
{** Dialog-Prozeduren (modale Dialoge) **}
{****************************************}
const
 ID_Apply=5;
 ID_Help=9;

procedure ModifyDialog(Wnd:HWnd);
{garniert einen "buttonlosen" Dialog (gedacht fr PropertySheets)
 mit einer vernderten berschrift und den notwendigen Buttons}
 const
  IDs: array[0..3] of Byte=(ID_OK,ID_Cancel,ID_Apply,ID_Help);
 var
  SP: PChar;
  I,X,Y: Integer;
  Style: LongInt;
  Fnt: HFont;
  P: TPoint;
  R: TRect;
  S,S2,S3: TS63;
 begin
  SP:=nil;
  if LoadString(Seg(HInstance),124,S,sizeof(S))<>0 then begin
   GetWindowText(Wnd,S2,sizeof(S2));
   SP:=S2;
   wvsprintf(S3,S,SP);		{Titelzeilen-Formatierung}
   SetWindowText(Wnd,S3);
   SP:=S;
  end;
  LongInt(P):=GetDialogBaseUnits;
  GetClientRect(Wnd,R);
  X:=R.right div 4;			{Button-Abstand}
  Y:=MulDiv(P.y,14,8);
  SetRect(R,0,R.bottom,X,R.bottom+Y);
  InflateRect(R,-P.x div 2,-P.y div 6); {etwas Platz rundherum}
  Style:=WS_Child or WS_Visible or WS_TabStop or WS_Group
    or BS_DefPushButton;
  Fnt:=SendMessage(Wnd,WM_GetFont,0,0);
  for i:=0 to 3 do begin
   if SP<>nil then SP:=SP+lstrlen(SP)+1;
   if i=2 then asm or LongRec[Style].hi,WS_Disabled shr 16 end;
   SendMessage(CreateWindow('BUTTON',SP,Style,
   R.left,R.top,R.right-R.left,R.bottom-R.top,
   Wnd,IDs[i],Seg(HInstance),nil),WM_SetFont,Fnt,0);
   Style:=WS_Child or WS_Visible or WS_TabStop or BS_PushButton;
   OffsetRect(R,X,0);	{nchster Button}
  end;
  ResizeDlgWindow(Wnd,0,Y);
 end;

const
 CheckProp: Byte=0;
 WM_Apply=WM_User+150;
 WM_Check=WM_User+151;
 WM_Init=WM_User+152;

function DefaultDlgProc(lParP: PLongInt; ID: Word): Bool;
{verarbeitet WM_Command mit IDCancel und IDHelp; ID ist die Dialogres-ID}
 type
  PMsgStack=^TMsgStack;
  TMsgStack=record
   lparam: LongInt;
   wparam,msg:Word;
   wnd: HWnd;
  end;
 const
  InInit: Boolean=false;
 var
  MSP: PMsgStack absolute lParP;
  PNPP: ^PPshNotify absolute lParP;
 begin
  DefaultDlgProc:=false;
  with MSP^ do begin
   case msg of
    WM_InitDialog: begin
     if CheckProp and 2 =0 then ModifyDialog(wnd); {Modifizierung}
     InInit:=true;
     SendMessage(wnd,WM_Init,0,0);
     InInit:=false;
     DefaultDlgProc:=true;
    end;
{Verarbeitung fr klassischen Dialog}
    WM_Command: case wparam of
     ID_OK: if SendMessage(wnd,WM_Check,0,0)=0 then begin
      SendMessage(wnd,WM_Apply,0,0);
      EndDialog(wnd,1);
     end;
     ID_Cancel: EndDialog(wnd,2);
     ID_Apply: if SendMessage(wnd,WM_Check,0,0)=0 then begin
      SendMessage(wnd,WM_Apply,0,0);
      EnableWindow(HWnd(lParam),false);	{wieder grau machen}
     end;
     ID_Help: WinHelp(wnd,HelpFile,HELP_Context,ID);
     else if not InInit then case LongRec(lparam).hi of
      BN_Clicked, EN_Change, CBN_SelChange: if CheckProp and 2 <>0
      then SendMessage(GetParent(wnd),PSM_Changed,wnd,0)
      else EnableWindow(GetDlgItem(Wnd,ID_Apply),true);
     end;
    end;
{Verarbeitung fr PropertySheet}
    WM_Notify: with PNPP^^ do begin
     case hdr.code of
      PSN_KillActive: if SendMessage(wnd,WM_Check,0,0)<>0
      then begin
       SetWindowWord(wnd,DWL_MsgResult,1);	{Will nicht!}
       DefaultDlgProc:=true;			{nicht weiterverarbeiten}
      end;
      PSN_Apply: if SendMessage(wnd,WM_Check,0,0)=0
      then begin
       SendMessage(wnd,WM_Apply,0,0);
       SetWindowWord(wnd,DWL_MsgResult,1);
       SendMessage(hdr.hwndfrom,PSM_Unchanged,wnd,0);
      end;
      PSN_Help: WinHelp(wnd,HelpFile,HELP_Context,ID);
     end;
    end;
   end;
  end;
 end;

function EmuSetProc(Wnd:HWnd; Msg,wParam:Word; lParam:LongInt):Bool; export;
 var
  lPar: LongRec absolute lParam;
  W: Word;
  S: array[0..31] of Char;
 begin
  EmuSetProc:=DefaultDlgProc(@lParam,207);
  case Msg of
   WM_Init: begin
    lParam:=LongDivWR(KCClock,1000);
    wvsprintf(S,'%u.%03u',lParam);
    SetDlgItemText(Wnd,110,S);
    CheckDlgButton(Wnd,111+MenuFlags and 1,1);
    CheckDlgButton(Wnd,114+MenuFlags shr 3 and 1,1);
    SetCheckboxGroup(Wnd,101,104,EmuBlockMask xor $F);
   end;
   WM_Check: begin
    W:=GetDlgItem(Wnd,110);
    GetWindowText(W,S,sizeof(S));
    if not ScanFreq(S,nil) then begin
     MBox1(Wnd,111,S);
     SetEditFocus(W);
     SetWindowWord(Wnd,DWL_MsgResult,1);
     EmuSetProc:=true;
    end;
   end;
   WM_Apply: begin
    GetDlgItemText(Wnd,110,S,sizeof(S));
    ScanFreq(S,@KCClock);
    SetMenuFlags(MenuFlags and not $9
      or IsDlgButtonChecked(Wnd,112)
      or IsDlgButtonChecked(Wnd,115) shl 3);
    EmuBlockMask:=GetCheckboxGroup(Wnd,101,104) xor $F;
   end;
  end;
 end;

function ScrollNumberEdit(Wnd:HWnd; ID:Word; u,o,by: Integer):Integer;
{liefert vorhandenen Wert - bei u>o Initialisierung mit by}
 begin
  if u<=o then begin
   by:=min(max(by+GetDlgItemInt(Wnd,ID,nil,true),u),o);
  end;
  SetDlgItemInt(Wnd,ID,by,true);
  ScrollNumberEdit:=by;
 end;

var
 EditProc: TFarProc;

function Msg2VScroll(Msg,wParam:Word):Integer; assembler;
{liefert <>0 wenn eine Scroll-Nachricht (von Tastatur oder Rollbalken)}
 asm	mov	dx,[Msg]
	mov	ax,[wParam]
	cmp	dx,WM_VScroll
	jne	@@1
	cmp ax,SB_PageUp;   mov dl, 10; je @@e
	cmp ax,SB_LineUp;   mov dl,  1; je @@e
	cmp ax,SB_LineDown; mov dl, -1; je @@e
	cmp ax,SB_PageDown; mov dl,-10; je @@e
	jmp	@@z
@@1:	cmp	dx,WM_KeyDown
	jne	@@z
	cmp ax,VK_Prior;    mov dl, 10; je @@e
	cmp ax,VK_Up;       mov dl,  1; je @@e
	cmp ax,VK_Down;     mov dl, -1; je @@e
	cmp ax,VK_Next;     mov dl,-10; je @@e
@@z:	mov	dl,0
@@e:	xchg	dx,ax
	cbw
 end;

function BorderEditHook(Wnd:HWnd; Msg,wParam:Word; lParam:LongInt):LongInt; export;
 var
  I: Integer;
 begin
  I:=Msg2VScroll(Msg,wParam);
  if I<>0 then begin
   ScrollNumberEdit(GetParent(Wnd),GetDlgCtrlID(Wnd),0,100,I);
   BorderEditHook:=0;
  end else BorderEditHook:=CallWindowProc(EditProc,Wnd,Msg,wParam,lParam);
 end;

function MagEditHook(Wnd:HWnd; Msg,wParam:Word; lParam:LongInt):LongInt; export;
 var
  I: Integer;
  S: TS15;
 begin
  if (Msg=WM_SetText) and (lstrcmp(PChar(lParam),'0')=0)
  then begin
   LoadString(Seg(HInstance),115{"Auto"},S,sizeof(S));
   lParam:=LongInt(@S);		{Null durch "Auto" ersetzen}
  end;
  I:=Msg2VScroll(Msg,wParam);
  if I<>0 then begin
   ScrollNumberEdit(GetParent(Wnd),GetDlgCtrlID(Wnd),0,4,I);
   MagEditHook:=0;
  end else MagEditHook:=CallWindowProc(EditProc,Wnd,Msg,wParam,lParam);
 end;

function DispSetProc(Wnd:HWnd; Msg,wParam:Word; lParam:LongInt):Bool; export;
 var
  lPar: LongRec absolute lParam;
  ID: Word;
  I: Integer;
 begin
  DispSetProc:=DefaultDlgProc(@lParam,208);
  case Msg of
   WM_Init: begin
    CheckDlgButton(Wnd,101+EmuShowClock and 3,1);
    SetCheckboxGroup(Wnd,104,105,EmuShowClock shr 2);
    if WinGBM<>0 then CheckDlgButton(Wnd,109,1);	{nur als Anzeige}
    SetCheckboxGroup(Wnd,110,114,DisplayFlags);
    LongInt(EditProc):=GetWindowLong(GetDlgItem(Wnd,10),GWL_WndProc);
    SetWindowLong(GetDlgItem(Wnd,10),GWL_WndProc,LongInt(@BorderEditHook));
    SetWindowLong(GetDlgItem(Wnd,12),GWL_WndProc,LongInt(@MagEditHook));
    ScrollNumberEdit(Wnd,10,0,-1,Border);
    ScrollNumberEdit(Wnd,12,0,-1,FullMag);
   end;

   WM_Apply: begin
    SetShowClock(GetRadioCheck(Wnd,101,103) or
      (GetCheckboxGroup(Wnd,104,105) shl 2));
    SetDispFlags(GetCheckboxGroup(Wnd,110,114));
    Border:=ScrollNumberEdit(Wnd,10,0,100,0);
    FullMag:=ScrollNumberEdit(Wnd,12,0,4,0);
    I:=MaximumMagnify;
    if IsZoomed(MainWnd)
    and (Magnify<>I) then begin
     Magnify:=I;			{nachziehen}
     asm or DispFlags,DrawFrame end;
     InvalidateRect(MainWnd,nil,true);	{falls Vollbild: neu zeichnen!}
    end;
    ChrBoxChanged;
    CheckDlgButton(Wnd,109,Word(WinGBM<>0));	{Aktivierung ggf. anzeigen}
   end;
  end;
 end;

function SoundSetProc(Wnd:HWnd; Msg,wParam:Word; lParam:LongInt):Bool; export;
 var
  S: array[0..255] of Char;
  WaveOutCaps: TWaveOutCaps absolute S;
  WaveInCaps: TWaveInCaps absolute S;
  lPar: LongRec absolute lParam;
  W,Mask: Word;
  I,J,K:integer;
  WODProc,WIDProc: Integer;
 begin
  SoundSetProc:=DefaultDlgProc(@lParam,209);
  WODProc:=WaveOutDev;
  case Msg of
   WM_Init: begin
    CheckDlgButton(Wnd,101+WaveOption,1);
    EnableWindow(GetDlgItem(Wnd,112),WaveOption=1);
    EnableWindow(GetDlgItem(Wnd,123),WaveOption=2);
{    EnableWindow(GetDlgItem(Wnd,106),false); ..schon in Ressource..}
    W:=GetDlgItem(Wnd,112);	{Handle Kombobox WaveOUT}
    I:=WaveOutGetNumDevs;
    for J:=-1 to I-1 do begin	{mit Wave_Mapper beginnen}
     if (WaveOutGetDevCaps(Word(J),@WaveOutCaps,sizeof(WaveOutCaps))=0)
     and (WaveOutCaps.dwFormats and WAVE_Format_2M08 <>0)
     and (WaveOutCaps.dwSupport and WAVECAPS_Sync =0) then begin
      K:=SendMessageP(W,CB_AddString,0,@WaveOutCaps.szPName);
      SendMessage(W,CB_SetItemData,K,J);
      if J=WaveOutDev then SendMessage(W,CB_SetCurSel,K,0);
     end;
    end;
    W:=GetDlgItem(Wnd,113);	{Handle Kombobox WaveIN}
    I:=WaveInGetNumDevs;
    for J:=-1 to I-1 do begin	{mit Wave_Mapper beginnen}
     if (WaveInGetDevCaps(Word(J),@WaveInCaps,sizeof(WaveInCaps))=0)
     and (WaveInCaps.dwFormats and WAVE_Format_2M08 <>0) then begin
      K:=SendMessageP(W,CB_AddString,0,@WaveInCaps.szPName);
      SendMessage(W,CB_SetItemData,K,J);
      if J=WaveInDev then SendMessage(W,CB_SetCurSel,K,0);
     end;
    end;
   end;
   WM_Command: case wParam of
    101..104: begin
     EnableWindow(GetDlgItem(Wnd,112),wParam=102);
     EnableWindow(GetDlgItem(Wnd,113),wParam=103);
    end;
    112: if lPar.Hi=CBN_SelChange then begin
     I:=SendMessage(lPar.Lo,CB_GetCurSel,0,0);
     if I>=0 then WODProc:=SendMessage(lPar.Lo,CB_GetItemData,I,0);
    end;
    113: if lPar.Hi=CBN_SelChange then begin
     I:=SendMessage(lPar.Lo,CB_GetCurSel,0,0);
     if I>=0 then WIDProc:=SendMessage(lPar.Lo,CB_GetItemData,I,0);
    end;
   end;
   WM_Apply: begin
    case WaveOption of
     1,2: SetSound(false);
     3: asm xor ax,ax; cwd; call KC3SoundR end;
    end;
    W:=GetDlgItem(Wnd,112);
    I:=SendMessage(W,CB_GetCurSel,0,0);
    if I>=0 then WaveOutDev:=SendMessage(W,CB_GetItemData,I,0);
    W:=GetDlgItem(Wnd,113);
    I:=SendMessage(W,CB_GetCurSel,0,0);
    if I>=0 then WaveInDev:=SendMessage(W,CB_GetItemData,I,0);

    WaveOption:=GetRadioCheck(Wnd,101,104);
    if WaveOption in [1,2] then SetSound(true);
   end;
  end;
 end;

function ClipbrdSetProc(Wnd:HWnd; Msg,wParam:Word; lParam:LongInt):Bool; export;
{Dialog fr Zwischenablage-Einstellungen}
 var
  lPar: LongRec absolute lParam;
  ew: Word;
  bo: Bool;
 begin
  ClipbrdSetProc:=DefaultDlgProc(@lParam,210);
  case Msg of
   WM_Init: begin
    SetCheckboxGroup(Wnd,101,103,ClipbrdFlags);
    SetDlgItemInt(Wnd,10,PasteEnterTimeOut,true);
    SetDlgItemInt(Wnd,11,PasteTimeOut,true);
   end;
   WM_Check: begin
    repeat
     ew:=10;
     if Integer(GetDlgItemInt(Wnd,ew,@bo,true))<=0 then break;
     if not bo then break;
     Inc(ew);
     if Integer(GetDlgItemInt(Wnd,11,@bo,true))<=0 then break;
     if not bo then break;
     exit;
    until true;
    MBox1(Wnd,114,nil);
    SetEditFocus(GetDlgItem(Wnd,ew));
    SetWindowWord(Wnd,DWL_MsgResult,1);
    ClipbrdSetProc:=true;
   end;
   WM_Apply: begin
    PasteEnterTimeOut:=GetDlgItemInt(Wnd,10,nil,true);
    PasteTimeOut:=GetDlgItemInt(Wnd,11,nil,true);
    ClipbrdFlags:=GetCheckboxGroup(Wnd,101,103);
   end;
  end;
 end;

function InternSetProc(Wnd:HWnd; Msg,wParam:Word; lParam:LongInt):Bool; export;
 var
  lPar: LongRec absolute lParam;
  ew: Word;
  bo: Bool;
 begin
  InternSetProc:=DefaultDlgProc(@lParam,211);
  case Msg of
   WM_Init: begin
    SetDlgItemInt(Wnd,10,CpuExpire,false);
    SetDlgItemInt(Wnd,11,MaxRegions,true);
    SetDlgItemInt(Wnd,12,PERatio,true);
   end;
   WM_Check: begin
    repeat
     ew:=10;
     GetDlgItemInt(Wnd,ew,@bo,false);	{Null ist hier erlaubt (noch!)}
     if not bo then break;
     Inc(ew);
     if Integer(GetDlgItemInt(Wnd,ew,@bo,true))<=0 then break;
     if not bo then break;
     Inc(ew);
     if Integer(GetDlgItemInt(Wnd,ew,@bo,true))<=0 then break;
     if not bo then break;
     exit;
    until true;
    MBox1(Wnd,114,nil);
    SetEditFocus(GetDlgItem(Wnd,ew));
    SetWindowWord(Wnd,DWL_MsgResult,1);
    InternSetProc:=true;
   end;
   WM_Apply: begin
    CpuExpire:=GetDlgItemInt(Wnd,10,nil,false);
    MaxRegions:=Integer(GetDlgItemInt(Wnd,11,nil,true));
    PERatio:=max(Integer(GetDlgItemInt(Wnd,12,nil,true)),1);
   end;
  end;
 end;

const
 psp: array[0..4]of TPropSheetPage=((
  dwSize: sizeof(TPropSheetPage);
  dwFlags: PSP_HasHelp;
  hInstance: Seg(HInstance);
  pszTemplate: MakeIntResource(207);	{Emu}
  pszIcon: nil;
  pszTitle: nil;
  pfnDlgProc: @EmuSetProc),(
  dwSize: sizeof(TPropSheetPage);
  dwFlags: PSP_HasHelp;
  hInstance: Seg(HInstance);
  pszTemplate: MakeIntResource(208);	{Display}
  pszIcon: nil;
  pszTitle: nil;
  pfnDlgProc: @DispSetProc),(
  dwSize: sizeof(TPropSheetPage);
  dwFlags: PSP_HasHelp;
  hInstance: Seg(HInstance);
  pszTemplate: MakeIntResource(209);	{Sound}
  pszIcon: nil;
  pszTitle: nil;
  pfnDlgProc: @SoundSetProc),(
  dwSize: sizeof(TPropSheetPage);
  dwFlags: PSP_HasHelp;
  hInstance: Seg(HInstance);
  pszTemplate: MakeIntResource(210);	{Clipboard}
  pszIcon: nil;
  pszTitle: nil;
  pfnDlgProc: @ClipbrdSetProc),(
  dwSize: sizeof(TPropSheetPage);
  dwFlags: PSP_HasHelp;
  hInstance: Seg(HInstance);
  pszTemplate: MakeIntResource(211);	{Intern}
  pszIcon: nil;
  pszTitle: nil;
  pfnDlgProc: @InternSetProc));

 psh: TPropSheetHeader=(
  dwSize: sizeof(TPropSheetHeader);
  dwFlags: PSH_HasHelp or PSH_PropSheetPage or PSH_PropTitle;
  hwndParent: 0;
  hInstance: Seg(HInstance);
  pszIcon: 0;
  pszCaption: AppName;
  nPages: 5;
  nStartPage: 0;		{nullbasiert!}
  ppsp: @psp[0]);

var
 hCommCtrl: THandle;
 PropertySheet: function(const psh: TPropSheetHeader):Integer;

procedure StartDialog(index: Integer);
 begin
  if CheckProp=0 then begin
   Inc(CheckProp);
   psh.hwndParent:=MainWnd;
   hCommCtrl:=MyLoadLibrary('COMMCTRL.DLL');
   if hCommCtrl>=32 then begin
    @PropertySheet:=GetProcAddress(hCommCtrl,PChar(159));
    if @PropertySheet<>nil then Inc(CheckProp)
    else begin	{Windows 3.11}
     FreeLibrary(hCommCtrl);
     hCommCtrl:=0;
    end;
   end;
  end;
  if CheckProp and 2 <>0 then begin
   psh.nStartPage:=index;
   PropertySheet(psh);
  end else with psp[index] do begin
   DialogBox(Seg(HInstance),pszTemplate,MainWnd,pfnDlgProc);
  end;
 end;

const
 stConfigKey='KCEMU\config';
 stPlacement='placement';
 stKCTyp    ='kctyp';
 stDisplay  ='display';
 stSound    ='sound';
 stKeyboard ='keyboard';
 stKCLoad   ='KCEMU\KCLOAD';	{nur damit KCLOAD von der Installation wei}

procedure LoadConfig;
 var
  SP: PChar;
  I: Integer;
  Key: HKey;	{Mit geffnetem Schlssel geht's schneller!}
  wp: TWindowPlacement;
  S: array[0..255]of Char;
 begin
  if RegOpenKey(HKCR,stConfigKey,Key)<>0 then exit;
  if RegGetVal(Key,stKCTyp,S,sizeof(S)) then begin
   SP:=S;
   if ScanInt(SP,I) then SetNewKC(I);
   if ScanInt(SP,I) then SetMenuFlags(I);
   if ScanInt(SP,I) then EmuBlockMask:=I;
   if ScanInt(SP,I) then LongRec(ofn.nFilterIndex).lo:=Word(I);
   if ScanInt(SP,I) then CpuExpire:=Word(I);
  end;
  if RegGetVal(Key,stDisplay,S,sizeof(S)) then begin
   SP:=S;
   if ScanInt(SP,I) then SetShowClock(I);
   if ScanInt(SP,I) then SetDispFlags(I);
   if ScanInt(SP,I) then Border:=I;
   if ScanInt(SP,I) then FullMag:=I;
   if ScanInt(SP,I) then MaxRegions:=I;
  end;
  if RegGetVal(Key,stSound,S,sizeof(S)) then begin
   SP:=S;
   if ScanInt(SP,I) then WaveOption:=I;
   if ScanInt(SP,I) then WaveOutDev:=I;
   if ScanInt(SP,I) then WaveInDev:=I;
  end;
  if RegGetVal(Key,stKeyboard,S,sizeof(S)) then begin
   SP:=S;
   if ScanInt(SP,I) then ClipFlags:=I;
   if ScanInt(SP,I) then PasteTimeOut:=I;
   if ScanInt(SP,I) then PasteEnterTimeOut:=I;
  end;
  if RegGetVal(Key,stPlacement,S,sizeof(S))
  then with wp do begin
   Installed:=true;
   SP:=S;
   ScanInt(SP,Integer(CmdShow));
   if (HPrevInst=0)
   and GetMainWndPlacement(wp)	{wegen ptMaxPosition}
   then begin	{nur das 1. Fenster nach Konfig setzen!}
{vermeidet das exakte bereinanderplazieren, was den User verwirrt}
    showcmd:=SW_Hide;
    flags:=0;
    with rcNormalPosition do begin
     ScanInt(SP,left);
     ScanInt(SP,top);
     PLongint(@right)^:=WindowSize(1,GetNormalBorder);
     Inc(right,left);
     Inc(bottom,top);
    end;
    MoveRectIntoFullScreen(rcNormalPosition);	{immer ganz sichtbar laden!}
    ScanInt(SP,MaxPos.x);
    ScanInt(SP,MaxPos.y);
    if DispFlags and EntireDesktop=0 then ptMaxPosition:=MaxPos;
    SetMainWndPlacement(wp);
   end;
  end;
  RegCloseKey(Key);
 end;

procedure SaveConfig;
 const
  pd5: array[0..14] of Char='%d %d %d %d %d';
 var
  ia: array[0..4] of Integer;
  Key: HKey;	{mit geffnetem Schlssel sollte das Speichern schneller sein}
  wp: TWindowPlacement;
  S: array[0..255]of Char;
 begin
  RegCreateKey(HKCR,stKCLoad,Key);	{Diesen fr KCLOAD anlegen}
  if RegCreateKey(HKCR,stConfigKey,Key)<>0 then exit;
  if GetMainWndPlacement(wp) then begin
   ia[0]:=wp.showCmd;
   ia[1]:=wp.rcNormalPosition.left;
   ia[2]:=wp.rcNormalPosition.top;
   ia[3]:=MaxPos.x;		{NT: nicht aus WindowPlacement nehmen}
   ia[4]:=MaxPos.y;
   wvsprintf(S,pd5,ia);
   RegSetVal(Key,stPlacement,S);
  end;
  ia[0]:=KCTyp;
  ia[1]:=MenuFlags;
  ia[2]:=EmuBlockMask;
  ia[3]:=ofn.nFilterIndex;
  ia[4]:=Integer(CpuExpire);
  wvsprintf(S,pd5,ia);
  RegSetVal(Key,stKCTyp,S);
  ia[0]:=EmuShowClock;
  ia[1]:=DisplayFlags;
  ia[2]:=Border;
  ia[3]:=FullMag;
  ia[4]:=MaxRegions;
  wvsprintf(S,pd5,ia);
  RegSetVal(Key,stDisplay,S);
  ia[0]:=WaveOption;
  ia[1]:=WaveOutDev;
  ia[2]:=WaveInDev;
  wvsprintf(S,pd5+6,ia);
  RegSetVal(Key,stSound,S);
  ia[0]:=ClipFlags;
  ia[1]:=PasteTimeOut;
  ia[2]:=PasteEnterTimeOut;
  wvsprintf(S,pd5+6,ia);
  RegSetVal(Key,stKeyboard,S);
  RegCloseKey(Key);
 end;

function InputArgsProc(Wnd:HWnd; Msg,wParam:Word; lParam:LongInt):Bool;
  export;
 var
  ArgP: PArgs absolute lParam;
 begin
  InputArgsProc:=false;
  case Msg of
   WM_InitDialog: begin
    SetWindowArgs(GetDlgItem(Wnd,100));
    InputArgsProc:=true;
   end;
   WM_Command: case wParam of
    ID_OK: begin
     if GetWindowArgs(GetDlgItem(Wnd,100))
     then EndDialog(Wnd,ID_OK)
     else begin
      MBox1(Wnd,106,nil);
      SetFocus(GetDlgItem(Wnd,100));
     end;
    end;
    ID_Cancel: EndDialog(Wnd,ID_Cancel);
    9: WinHelp(Wnd,HelpFile,HELP_Context,102);
   end;
  end;
 end;

function LoadFile(Name:PChar; Typ: Integer; IgnoreROM: Boolean):Boolean;
{Benutzt die globale Variable LoadSaveArgs}
{Typ=0: je nach Endung, =1: .COM,.KCC, =2: .BIN, =3: .SSS,.BAS,...}
{IgnoreROM=true, wenn ROM gnadenlos berschrieben werden soll}
 var
  Ext: PChar;
  f: Integer;
  P: PChar;		{Hilfsspeicher}
  aa,ea,len: Word;
 begin
  f:=_lopen(Name,0);
  if f=-1 then begin
   MBox1(MainWnd,105,Name);	{Huch?}
   exit;
  end;
  if Typ=0 then begin
   Ext:=GetFileNameExt(Name);
   Typ:=2;	{Normalerweise: Speicherabzug}
   if (lstrcmpi(Ext,'.COM')=0) or (lstrcmpi(Ext,'.KCC')=0) then Typ:=1;
   if (lstrcmpi(Ext,'.SSS')=0) or (lstrcmpi(Ext,'.BAS')=0) then Typ:=3;
   if lstrcmpi(Ext,'.Z80')=0 then Typ:=4;
  end;
  if LoadSaveArgs.argn=0 then begin	{Adressen erfragen}
   if not GetFileArgs(f,Typ) then begin
    MBox1(MainWnd,105,nil);
    exit;
   end;
   if DialogBox(Seg(HInstance),MakeIntResource(102),MainWnd,
     @InputArgsProc)<>ID_OK then exit;
  end;
  if LoadSaveArgs.argn>=1 then aa:=LoadSaveArgs.arg[1];
  if LoadSaveArgs.argn>=2 then len:=LoadSaveArgs.arg[2]-aa;
  case Typ of
   1: begin			{Maschinenprogramm}
    if LoadSaveArgs.argn<2 then exit;
    _llseek(f,$80,0);
   end;
   2: begin			{Speicherabzug}
    if LoadSaveArgs.argn<1 then exit;
    len:=_llseek(f,0,2);	{Lnge der Datei bestimmen (hoffentlich <64K)}
    if LoadSaveArgs.argn>=2
    then len:=minW(len,LoadSaveArgs.arg[2]-aa);
    _llseek(f,0,0);
   end;
   3: begin			{BASIC-Programm}
    if LoadSaveArgs.argn<1 then aa:=$401;
    _llseek(f,0,0);
    _lread(f,PChar(@len),2);	{Lnge holen}
    if LoadSaveArgs.argn>=2 then len:=minW(len,LoadSaveArgs.arg[2]-aa);
    ea:=aa+len;
    if LoadKCMem(@ea,$3D7,2)
    and LoadKCMem(@ea,$3D9,2)
    and LoadKCMem(@ea,$3DB,2)	{Endadresse eintragen, Variablen lschen}
    then else MBox1(MainWnd,120,nil);
   end;
   4: begin
    _llseek(f,$20,0);
   end;
  end;
  if IgnoreROM then _lread(f,Ptr(MemKCSel,aa),len)
  else begin
   P:=Ptr(GlobalAlloc(GMEM_Fixed,len),0);
   _lread(f,P,len);
   if LoadKCMem(P,aa,len)
   then else MBox1(MainWnd,120,nil);
   GlobalFree(PtrRec(P).Sel);
  end;
  _lclose(f);
  if LoadSaveArgs.argn=3 then Regs.PC:=LoadSaveArgs.arg[3];
 end;

function SaveFile(Name:PChar; Typ: Integer):Boolean;
{Benutzt die globale Variable LoadSaveArgs}
{Typ=1: .COM,.KCC, =2: .BIN, =3: .SSS,.BAS, =4:Z80...}
 var
  Ext: PChar;
  f: Integer;
  len: Word;
  hdr: TFullKccHdr;
  Z80Hdr: TZ80Hdr absolute hdr;
 begin
  SaveFile:=false;
  f:=_lcreat(Name,0);
  if f=-1 then begin
   MBox1(MainWnd,105,Name);	{Huch?}
   exit;
  end;
  case Typ of
   1: begin			{KCC-Programm}
    lstrcpyn(hdr.name,GetFileNamePtr(Name),sizeof(hdr.name));
    if (LoadSaveArgs.argn=0)	{Adressen erfragen}
    and (DialogBox(Seg(HInstance),MakeIntResource(102),MainWnd,
      @InputArgsProc)<>ID_OK)
    then begin
     _lclose(f);
     exit;
    end;
    hdr.args:=LoadSaveArgs;
    _lwrite(f,PChar(@hdr),128);
   end;
   2: begin			{Speicherabzug}
    if (LoadSaveArgs.argn=0)	{Adressen erfragen}
    and (DialogBox(Seg(HInstance),MakeIntResource(102),MainWnd,
      @InputArgsProc)<>ID_OK)
    then begin
     _lclose(f);
     exit;
    end;
   end;
   3: begin			{BASIC-Programm (Disketten-Format)}
    LoadSaveArgs.argn:=2;
    LoadSaveArgs.arg[1]:=$401;
    LoadSaveArgs.arg[2]:=MemW[MemKCSel:$3D7];
    if (LoadSaveArgs.arg[2]<=$401)
    or (LoadSaveArgs.arg[2]>=$C000)
    then begin
     _lclose(f);
     MBox(MainWnd,113,LoadSaveArgs.arg[2]);	{Kann nicht speichern!}
     exit;
    end;
    len:=LoadSaveArgs.arg[2]-LoadSaveArgs.arg[1];
    _lwrite(f,PChar(@len),2);	{Lnge schreiben}
   end;
   4: begin
    FillWord(Z80Hdr,sizeof(Z80Hdr) div 2,0);
    lstrcpyn(Z80Hdr.name,GetFileNamePtr(name),sizeof(Z80Hdr.name));
    if (LoadSaveArgs.argn=0)	{Adressen erfragen}
    and (DialogBox(Seg(HInstance),MakeIntResource(102),MainWnd,
      @InputArgsProc)<>ID_OK)
    then begin
     _lclose(f);
     exit;
    end;
    Z80Hdr.arg:=LoadSaveArgs.arg;
    Z80Hdr.typ:='M'; if LoadSaveArgs.argn=3 then Z80Hdr.typ:='C';
    FillChar(Z80Hdr.magic,sizeof(Z80Hdr.magic),#$D3);
    _lwrite(f,PChar(@Z80Hdr),sizeof(Z80Hdr));
   end;
  end;
  len:=LoadSaveArgs.arg[2]-LoadSaveArgs.arg[1];
  if _lwrite(f,Ptr(MemKCSel,LoadSaveArgs.arg[1]),len)<>len
  then MBox1(MainWnd,112,Name);	{"Fehler beim Schreiben"}
  SaveFile:=_lclose(f)=0;
 end;

procedure PokeChar(C:Char);
 begin
  CallEvent(KCEV_KeyDown,Word(C),0);
 end;

procedure PokeChar2(W:Word);
 begin
  if (KCTyp=5) and (Mem[MemKCSel:$B7A2] and $20 <>0)	{IBM-Zeichensatz?}
  then PokeChar(Char(Hi(W)))
  else PokeChar(Char(Lo(W)));
 end;

procedure PokeKey(W:Word); assembler;
 asm	push	VK_Shift
	call	GetKeyState
	test	ax,$FFFE
	mov	ax,W		{Low-Teil ohne Shift}
	jz	@@1
	xchg	al,ah		{High-Teil mit Shift}
@@1:	push	ax
	call	PokeChar
 end;

var
 BremsZeit: Word;
 BremsTick: LongInt;

function WriteB:Boolean;
{Kontext: MMTASK.TSK}
 begin
  WriteB:=true;
  if Z1013Port2<$80
   then CurWaveHdr^.lpData[ByteIndex]:=char($0)
   else CurWaveHdr^.lpData[ByteIndex]:=char($FF);
  Inc(ByteIndex);
  if ByteIndex>=LongRec(CurWaveHdr^.dwBufferLength).Lo then begin
   WaveOutWrite(hWav,CurWaveHdr,sizeof(TWaveHdr));	{vollen Puffer hinein}
   if NextWaveHdr=nil then begin CurWaveHdr:=nil;WriteB:=false;
   end else begin CurWaveHdr:=NextWaveHdr;NextWaveHdr:=nil;end;
   ByteIndex:=0;
  end;
 end;

function IdleAction:Boolean;
{Hier kommt der Code der Emulation hin. Routine sollte nicht lnger als
 100 ms in Anspruch nehmen, da dann gestrter Bildaufbau und zhes Windows.
 IdleAction liefet normalerweise TRUE, was bedeutet: Emulation fortsetzen.
 Wenn das Programm dagegen z.B. auf Taste wartet, FALSE zurckgeben, damit
 Windows (und damit die CPU eines Laptops) "idlen" kann.}
 const
  ExitCounter: Word=0;	{zur automatischen Festlegung einer mglichst
    kleinen Expire-Zeit; fr flssigere Animationen auf schnellen Rechnern}
 var
  T,I: Word;
  L: LongInt;
  S: array[0..32] of Char;
 begin
  IdleAction:=false;
  if MemWr=0 then exit;
  SetBlock(EmuBlock and not 4);	{Es fehlt da ein WM_LeaveIdle...}
  if EmuBlock<>0 then exit;
  {$Q-}
  case WaveOption of
   1: begin
{     asm int 3 end;}
     If CurWaveHdr=nil then exit;
     repeat
      for I:=0 to 65535 div 90 do begin
       Expire:=90;
       CpuEmu;
       if not WriteB then exit;
      end;
     until Word(GetTickCount)-T >= LastPaintTime;
     IdleAction:=true;
   end;
   else begin
     IdleAction:=true;
     T:=Word(GetTickCount);
     if MenuFlags and 1 <>0 then begin	{Bremsen!}
      I:=T-BremsZeit;			{Differenz seit letzter Zeitnahme}
      L:=cTicks-BremsTick;
      if LongRec(L).Hi>=KCClock then begin
       L:=0;	{Notnagel!}
       BremsTick:=cTicks;
      end;
      if I+54 < lLongDivW(L,KCClock) then begin
       if ExitCounter<$FFFF then Inc(ExitCounter);
       exit;
      end;
      if I>100 then begin			{nicht zu lange "nachlaufen"!}
       if cTicks-BremsTick > LongMulW(200,KCClock)
       then BremsTick:=cTicks-LongMulW(0,KCClock)
       else Inc(BremsTick,LongMulW(I,KCClock));
       BremsZeit:=T;
      end;
     end{ else BremsTick:=cTicks};		{Hm, immer?}
     repeat
      if MenuFlags and 1 <>0 then case ExitCounter of
       0..3: Expire:=CpuExpire;
       4..10: Expire:=CpuExpire shr 1;
       11..20: Expire:=CpuExpire shr 3;
       21..40: Expire:=CpuExpire shr 5;
       41..80: Expire:=CpuExpire shr 7;
       else Expire:=CpuExpire shr 9;
      end else Expire:=CpuExpire;
{      asm int 3 end;}
      CpuEmu;
     until Word(GetTickCount)-T >= LastPaintTime;
     ExitCounter:=0;
   end;
  end;
  LastPaintTime:=0;
  GC_ShortCircuit:=false;
  if EmuShowClock and 3 <>0 then begin
   T:=Word(GetTickCount); I:=T-TimeTaken;
   if I>=1000 then begin	{Zeitdifferenz (Intervall) >=1 Sekunde?}
    SetFreq(lLongDivW(cTicks-TickTaken,I));	{in kHz}
    TickTaken:=cTicks;
    TimeTaken:=T;
   end;
  end;
 end;

function PasteString(S:PChar):Boolean;
 label raus;
 var
  SaveEmuBlock: Byte;		{whrend PASTE Emulator aktivieren}
  Msg: TMsg;
  T,TOut: Word;
  PasteOK: Bool;
  LastEnter: Boolean;
 begin
  SaveEmuBlock:=EmuBlock;
  SetBlock(0);
  LastEnter:=false;
  while S^<>#0 do begin
   if S^<>#10 then begin	{nur 0Dh (ENTER) verarbeiten}
    TOut:=PasteTimeOut;
    if LastEnter then TOut:=PasteEnterTimeOut;
    LastEnter:=S^=#13;
    T:=Word(GetTickCount);	{Start-Zeit nehmen}
    CallEvent(KCEV_KeyDown,Word(S^),0);
    repeat
     while PeekMessage(Msg,0,0,0,PM_Remove) do begin
      if Msg.message<WM_KeyFirst then begin	{Keine Kdo's verarbeiten}
       if (Msg.message=WM_KeyDown)
       and (Msg.wParam=VK_Cancel) then goto raus;
       if Msg.message=WM_Quit then asm int 3 end;
       TranslateMessage(Msg);
       DispatchMessage(Msg);
      end;
     end;
     IdleAction;
     PasteOK:=false;		{der Z1013 hat keine PasteOK-Mglichkeit}
     CallEvent(KCEV_PasteHint,0,LongInt(@PasteOK));
    until PasteOK or (Word(GetTickCount)-T>=TOut);
   end;
   Inc(S);
  end;
raus:
  SetBlock(SaveEmuBlock);
 end;

function TakeScreenshot:THandle;
{kopiert die momentane Pixmap und entfernt Blinkfarben}
 var
  HMem: THandle;
  P: PChar;			{Wandernder Zeiger}
  bih: PBitmapInfoHeader absolute P;	{Alias}
  col: PRGBQuad absolute P;		{Alias}
  siz: LongInt;			{(verbleibende) Bytes in Pixmap}
  I,J: Integer;
 begin
  TakeScreenshot:=0;
  if hDisplay=0 then exit;
  siz:=DisplaySize;
  J:=min(KCPixmap.c,24);	{Farbzahl, Blinkfarben auslassen!}
  HMem:=GlobalAlloc(GMEM_Share,sizeof(TBitmapInfoHeader)+(J shl 2)+siz);
  P:=GlobalLock(HMem);
  bih^:=KCPixmap.bih;		{ganze Struktur kopieren}
  bih^.biClrUsed:=J;		{Farbzahl ggf. minimieren}
  Inc(P,sizeof(TBitmapInfoHeader));
  for I:=0 to J-1 do with col^,TPaletteEntry(Palette.col[I]) do begin
   rgbBlue:=peBlue;		{einzelbyteweise, weil verdreht!}
   rgbGreen:=peGreen;		{in Assembler wre hier ein stosb so schn!}
   rgbRed:=peRed;
   rgbReserved:=0;
   Inc(P,sizeof(TRGBQuad));	{4 Bytes vorrcken}
  end;
  hmemcpy(P,Ptr(hDisplay,0),siz);	{Pixmap kopieren (lassen)}
  if KCPixmap.c>24 then begin	{Blinkfarben ausfiltern?}
   repeat
    asm	les	di,[P]
	mov	al,es:[di]	{Farb-Index lesen}
	sub	al,24
	cmp	al,8		{Blink-Farbe?}
	jnc	@@1		{nein, unverndert lassen}
	mov	ah,0
	add	ax,offset BlinkFarben
	xchg	bx,ax
	mov	al,[bx]
	or	al,al		{Z:=0, VFarbe liefern!}
	call	[GetAnimIdx]	{Index computerspezifisch beschaffen}
	mov	es:[di],al	{Index 0..23 hinschreiben}
@@1:end;
    IncHP(P,1);			{P als Huge-Zeiger vorrcken}
    Dec(siz);
   until siz=0
  end;
  GlobalUnlock(HMem);
  TakeScreenshot:=HMem;
 end;

function CreateTRectRegion:HRgn;
 var
  R2: TRect;
  Rgn1,Rgn2: HRgn;	{Hilfsregion zum Zusammensetzen}
 label
  L1;
 begin
  Rgn1:=0; Rgn2:=0;
  CopyRect(R2,SelectedRect);
  if (RandL<RandR) and (R2.top<>R2.bottom) then begin
{So umsortieren, da der 1. Punkt oben und der 2. Punkt unten ist}
   if R2.top>R2.bottom then SetRect(R2,R2.right,R2.bottom,R2.left,R2.top);
{Test auf Anomalie (Mittelbereich hat negative Breite)}
   if R2.top+1>R2.bottom then begin
    SortRect(R2);	{richtig sortieren}
    goto L1;		{weiter wie ohne Rnder}
   end;
{Oberer Schwanz}
   if R2.left<RandR then begin
    Rgn1:=CreateRectRgn(R2.left,R2.top,RandR,R2.top+1);
   end else Rgn1:=0;
   Inc(R2.top,1);	{weiter 'runter}
{Unterer Schwanz}
   if R2.right>RandL then begin
    Rgn2:=CreateRectRgn(RandL,R2.bottom,R2.right,R2.bottom+1);
   end else Rgn2:=0;
{Kombinieren zu Rgn1}
   if Rgn2<>0 then begin
    if Rgn1=0 then Rgn1:=Rgn2
    else begin
     CombineRgn(Rgn1,Rgn1,Rgn2,RGN_XOR);
     DeleteObject(Rgn2);
    end;
   end;
{Mittelbereich}
   if R2.top<R2.bottom then begin
    Rgn2:=CreateRectRgn(RandL,R2.top,RandR,R2.bottom);
   end else Rgn2:=0;
{Kombinieren zu Rgn1}
   if Rgn2<>0 then begin
    if Rgn1=0 then Rgn1:=Rgn2
    else begin
     CombineRgn(Rgn1,Rgn1,Rgn2,RGN_XOR);
     DeleteObject(Rgn2);
    end;
   end;
{Wert-Rckgabe}
   CreateTRectRegion:=Rgn1;
  end else begin
   SortRect(R2);
{Nun Rechteck auf (mindestens) Buchstabenhhe aufblasen}
L1:
   Inc(R2.bottom);
   CreateTRectRegion:=CreateRectRgnIndirect(R2);
  end;
 end;

procedure DrawSelection(DC:HDC);
 var
  OldMap: Integer;
 begin
  if SelectedRegion<>0 then begin
   OldMap:=SetMapMode(DC,MM_AnIsotropic);
   SetViewportOrg(DC,ScreenBox.left,ScreenBox.top);
   SetViewportExt(DC,ChrBox.X,ChrBox.Y);{Bildschirm-Buchstaben}
   SetWindowExt(DC,1,1);		{ganze Buchstaben}
   InvertRgn(DC,SelectedRegion);
   SetMapMode(DC,OldMap);
  end;
 end;

procedure SelectionChanged;
{Aufruf, wenn sich SelectedRect oder RandL/R gendert hat}
 var
  DC:HDC;
  hReg:HRgn;
 begin
  DC:=GetDC(MainWnd);
  if SelectedRegion<>0 then begin
   hReg:=CreateTRectRegion;
   CombineRgn(SelectedRegion,SelectedRegion,hReg,RGN_XOR);
   DrawSelection(DC);			{die Differenzmenge "umklappen"}
   DeleteObject(SelectedRegion);	{alte Selektierung weg!}
   SelectedRegion:=hReg;		{neue Region setzen}
  end else begin
   SelectedRegion:=CreateTRectRegion;
   DrawSelection(DC);
  end;
  ReleaseDC(MainWnd,DC);
 end;

function Pix2ChrBoxX(x:Integer):Integer;
 begin
  x:=max(min(x,ScreenBox.right-1),ScreenBox.left)-ScreenBox.left;
  if ChrBox.x>0				{GPF vermeiden}
  then Pix2ChrBoxX:=(ChrBox.X shr 1 +x) div ChrBox.X
  else Pix2ChrBoxX:=0;
 end;

function Pix2ChrBoxY(y:Integer):Integer;
 begin
  y:=max(min(y,ScreenBox.bottom-1),ScreenBox.top)-ScreenBox.top;
  if ChrBox.y>0				{GPF vermeiden}
  then Pix2ChrBoxY:=y div ChrBox.Y
  else Pix2ChrBoxY:=0;
 end;

procedure MouseDrag(x,y:Integer);	{Linke Maustaste gedrckt...}
 begin
  x:=Pix2ChrBoxX(x);
  y:=Pix2ChrBoxY(y);
				{Clipping und in Zeichen umrechnen}
  if (SelectedRect.right<>x) or (SelectedRect.bottom<>y) then begin
   SelectedRect.right:=x;
   SelectedRect.bottom:=y;		{Neue zweite Ecke}
   SelectionChanged;
  end;
 end;

procedure RemoveAnySelection;
 var
  DC:HDC;
 begin
  if SelectedRegion<>0 then begin
   DC:=GetDC(MainWnd);
   DrawSelection(DC);
   SelectedRegion:=0;		{Nichts mehr selektiert}
   ReleaseDC(MainWnd,DC);
  end;
 end;

var			{Variablen zum Hinberretten ber TrackPopupMenu()}
 MouseX: Integer;		{Maus-Position vor TrackPopupMenu()}
 LineDrawn: Boolean;		{Linie eingezeichnet oder nicht?}
 Keyword: array[0..9] of Char;	{Vorgefundenes Schlsselwort}

procedure DrawRandLinie(DC:HDC);
 var
  I: Integer;
  R: TRect;	{hier: 2 Punkte fr PolyLine}
 begin
  I:=min(MouseX*ChrBox.x+ScreenBox.left,ScreenBox.right-1);
  SetRect(R,I,ScreenBox.top,I,ScreenBox.bottom-1);
  I:=SetROP2(DC,R2_NOT);
  PolyLine(DC,R,2);
  SetROP2(DC,I);
 end;

procedure MakeModeless(var Wnd:HWnd; Res:Word; Proc: TFarProc);
 begin
  if Wnd<>0 then begin
   ShowWindow(Wnd,SW_Restore);		{falls ikonifiziert}
   SetFocus(Wnd);			{sonst: Fokus wechseln!}
  end else begin
   Wnd:=CreateDialog(Seg(HInstance),MakeIntResource(Res),0,Proc);
  end;
 end;

procedure FillMenuWithHelpFiles(m: HMenu);
 var
  S: TS255;
  I: Integer;
  SR: TSearchRec;
  eq: Boolean;
 begin
{1. Men leeren}
  for I:=1001 to 1050 do if not DeleteMenu(m,I,MF_ByCommand) then break;
{2. Men wieder fllen}
  GetModuleFileName(Seg(HInstance),S,sizeof(S));
  lstrcpy(GetFileNamePtr(S),'*.HLP');
  I:=1001;
  FindFirst(S,0,SR);
  while DosError=0 do begin
   eq:=lstrcmpi(SR.Name,CurrentHelpFile)=0;
   GetFileNameExt(SR.Name)^:=#0;	{Extension entfernen}
   AppendMenu(m,MF_String,I,SR.Name);
   if eq then CheckMenuItem(m,I,MF_ByCommand or MF_Checked);
   Inc(I);
   if I>1050 then break;
   FindNext(SR);
  end;
 end;

procedure FillMenuWithUserKCs(m: HMenu);
 var
  S: TS255;
  I: Integer;
  SR: TSearchRec;
 begin
{1. Men leeren}
  for I:=320 to 329 do if not DeleteMenu(m,I,MF_ByCommand) then break;
{2. Men wieder fllen}
  GetModuleFileName(Seg(HInstance),S,sizeof(S));
  lstrcpy(GetFileNamePtr(S),'*.KCE');
  I:=320;
  FindFirst(S,0,SR);
  while DosError=0 do begin
   GetFileNameExt(SR.Name)^:=#0;	{Extension entfernen}
   AppendMenu(m,MF_String,I,SR.Name);
   if I-310=KCTyp then CheckMenuItem(m,I,MF_ByCommand or MF_Checked);
   Inc(I);
   if I>329 then break;
   FindNext(SR);
  end;
 end;

procedure EnablePasteCommand(M:HMenu);
 begin
  EnableMenuItem(M,153,
    Bool2MenuGray(not IsClipboardFormatAvailable(CF_Text)));
 end;

procedure CalcSaum; assembler;
{bei WM_WinIniChange mu die Variable "Saum" mitgefhrt werden!}
 asm	call	GetBorderSizes
	shl	ax,1		{*2}
	mov	[Saum.x],ax
	shl	dx,1		{*2}
	mov	di,dx
	mov	al,SM_CYCaption
	call	GSM
	add	di,ax
	mov	al,SM_CYMenu
	call	GSM
	add	ax,di
	mov	[Saum.y],ax
 end;

procedure HandleSizing(fwSide:Byte; var R: TRect);
{Bearbeitet WM_Sizing auf Win95-Systemen}
 var
  Size: TPoint;
  I: Integer;
 begin
  I:=FindMagnify(R.right-R.left,R.bottom-R.top,Border);
  LongInt(Size):=WindowSize(I,Border);	{hier: Border niemals unwirksam}
  case fwSide of
   WMSZ_TopLeft,WMSZ_Top,WMSZ_TopRight: R.top:=R.bottom-Size.y; {R unten}
   else R.bottom:=R.top+Size.y;	{R klebt oben (blicher Fall)}
  end;
  case fwSide of
   WMSZ_TopLeft,WMSZ_Left,WMSZ_BottomLeft: R.left:=R.right-Size.x; {R rechts}
   else R.right:=R.left+Size.x;	{R klebt links (blicher Fall)}
  end;
 end;

function KCWndProc(Wnd:HWnd; Msg:Word; wParam:Word; lParam:LongInt):
  LongInt; export;
 const
  WM_ContinueInit=WM_User+10;
 var
  lPar: LongRec absolute lParam;
  mmi: PMinMaxInfo absolute lParam;
  pt: TPoint absolute lParam;
  SP: PChar absolute lParam;
  WH: PWaveHdr absolute lParam;
  CallOld: Boolean;
  SaveEmuBlock: Byte;		{whrend PASTE Emulator aktivieren}
  I: Integer;
  W: Word;
  R: TRect;
  PS: TPaintStruct;
  S: TS255;
 const
  SExt: array[0..15]of Char=#0;	{Filter-Merker (sonst ist's lstig)}

 begin
  CallOld:=false;
  KCWndProc:=0;
  case Msg of
   WM_Create: begin
    MainWnd:=Wnd;
    PS.hdc:=GetDC(Wnd);
    ScreenBPP:=GetDeviceCaps(PS.hdc,BitsPixel);
    ReleaseDC(Wnd,PS.hdc);
    MemKCSel:=PageAlloc(0);		{64K-Fenster}
    LoadConfig;				{setzt KCTyp usw.}
    SetSound(True);			{setzt Sound}
    TimeTaken:=Word(GetTickCount);
    TickTaken:=cTicks;
    W:=500; if KCTyp<>0 then W:=5000;
    SetTimer(Wnd,2,W,nil);
   end;

   WM_DisplayChange: begin	{wParam=BitPerPixel, lParam=TPoint(Bildgre)}
	{offenbar liefert in diesem Moment GetSystemMetrics noch alte Werte,
	 soda Magnify<>MaximumMagnify fehlschlgt!}
    ScreenBPP:=wParam;
    if (DispFlags and EntireDesktop =0)
    and (FullMag=0)
    and IsZoomed(Wnd)
    then begin
     SetWindowPos(Wnd,0,0,0,$7FFF,$7FFF,SWP_NoZOrder or SWP_NoMove or SWP_NoActivate);
    end;
   end;

   WM_WinIniChange: CalcSaum;

   WM_GetMinMaxInfo: with mmi^ do begin
    LongInt(ptMaxPosition):=GetMaxPos;	{NT+OS/2-Workaround}
    if DispFlags and EntireDesktop =0 then begin
     LongInt(ptMaxSize):=WindowSize(MaximumMagnify,Border);
    end;
    LongInt(ptMinTrackSize):=WindowSize(1,GetNormalBorder);
    if (DispFlags and ScalableWindow =0) and not IsZoomed(Wnd)
    then LongInt(ptMaxTrackSize):=
      WindowSize(MaxDisplayMagnify,GetNormalBorder);
   end;

   WM_Move: if (DispFlags and EntireDesktop =0) and IsZoomed(Wnd) then begin
    GetWindowRect(Wnd,R);	{Bewegungen erfassen fr Workaround}
    MaxPos:=PPoint(@R)^;
   end;

   WM_Sizing:			{Win9x-Nachricht}
   if (DispFlags and (ScalableWindow or SizingLock) =0)
   then begin
    if IsBadWritePtr(Pointer(lParam),8)	{unter NT4 leider der Fall}
    then begin
     asm or DispFlags,SizingLock end;		{fr immer sperren}
     asm int 3 end;
    end else HandleSizing(wParam,PRect(lParam)^);
   end;

   WM_WindowPosChanged:		{hier gibt es Fenster-Koordinaten}
   with PWindowPos(lParam)^ do begin
    CallOld:=true;
    if IsZoomed(Wnd)
    then Magnify:=MaximumMagnify
    else Magnify:=FindMagnify(cx,cy,GetNormalBorder);
   end;

   WM_Size: begin
    case wParam of
     SIZE_Minimized: begin
      ClrsRealized:=0;		{sonst Falschfarben nach Icon ffnen}
      SetBlock(EmuBlock or (EmuBlockMask and 1));
     end;
     SIZE_Maximized: begin	{Magnify wird auch in WM_SysCommand beackert}
      if ResizeLock <=1
      then ChrBoxChanged;	{mittig machen}
      SetBlock(EmuBlock and not 1);
     end;
     SIZE_Restored: begin	{mit Korrektur bei 2zeiligem Men}
      if ResizeLock <=1
      then ChrBoxChanged;	{mittig machen ODER Gre einschnappen lassen}
      I:=Integer(lPar.hi)-HiWord(ClientSize(Magnify,GetNormalBorder));
      if I<0 then begin		{sollte Null sein}
       GetWindowRect(Wnd,R);	{Korrektur - und hoffentlich keine...}
       Inc(ResizeLock);		{...weiteren Rekursionen!}
       SetWindowPos(Wnd,0,0,0,
	 R.right-R.left,R.bottom-R.top-I,SWP_NoZOrder or SWP_NoMove or SWP_NoActivate);
       Dec(ResizeLock);
      end;
      SetBlock(EmuBlock and not 1);
     end;
    end;
    DrawTitle;				{Titelzeile aktualisieren}
   end;

   WM_EnterIdle: if EmuBlockMask and 4 <>0
   then SetBlock(EmuBlock or 4)
   else IdleAction;

   WM_ActivateApp: if wParam<>0 then SetBlock(EmuBlock and not 2)
   else SetBlock(EmuBlock or (EmuBlockMask and 2));

   WM_QueryNewPalette: if ClrsRealized<32 then begin
    InvalWnd;
    asm inc WordRec[@result].lo end;
   end;

   WM_PaletteChanged: if wParam<>Wnd then begin
    ClrsRealized:=0;
    if WinGBM<>0 then ApplyColorTable;	{ob's wirkt?}
    InvalWnd;
   end;

   WM_EraseBkgnd: begin			{Null liefern lassen}
    asm or DispFlags,DrawFrame end;
    asm inc WordRec[@result].lo end;
   end;

   WM_Paint: begin
    BeginPaint(Wnd,PS);
    if DispFlags and DrawFrame <>0 then begin
     W:=MakeFrameRgn;
     I:=CreateSolidBrush(BorderRGB);
     FillRgn(PS.hdc,W,I);		{Rahmen zeichen}
     DeleteObject(I);
     DeleteObject(W);
     asm and DispFlags,not DrawFrame end;
    end;
    if hDisplay<>0 then begin
     LastPaintTime:=Word(GetTickCount);
     SelectPalette(PS.hDC,hPal,false);	{Mu auch hier sein!}
     if ClrsRealized<32 then ClrsRealized:=RealizePalette(PS.hDC);
{$R-}
     with ScreenBox do begin
      if WinGBM<>0 then begin
       if Magnify>1 then
	WinGStretchBlt(PS.hdc,left,top,right-left,bottom-top,
	 WinGDC,0,0,KCPixmap.x,KCPixmap.y)
       else WinGBitBlt(PS.hdc,left,top,KCPixmap.x,KCPixmap.y,
	 WinGDC,0,0);
      end else begin
       if Magnify>1 then
	StretchDIBits(PS.HDC,left,top,right-left,bottom-top,
	 0,0,KCPixmap.x,KCPixmap.y,Ptr(hDisplay,0),
	 KCPixmap.bi,DIB_Pal_Colors,SrcCopy)
       else SetDIBitsToDevice(PS.HDC,left,top,KCPixmap.x,KCPixmap.y,
	 0,0,0,KCPixmap.y,Ptr(hDisplay,0),
	 KCPixmap.bi,DIB_Pal_Colors);
      end;
     end;
{$IFOPT D+} {$R+} {$ENDIF}
     FillWord(InUpdate,sizeof(InUpdate) div 2,0);
     Regions:=MaxRegions;
     LastPaintTime:=(Word(GetTickCount)-LastPaintTime) div PERatio;
    end else FillRect(PS.hDC,PS.rcPaint,GetStockObject(Gray_Brush));
    DrawSelection(PS.HDC);
    if LineDrawn then DrawRandLinie(PS.hDC);
    EndPaint(Wnd,PS);
   end;

   WM_Copy: begin
    if OpenClipboard(Wnd) then begin
     EmptyClipboard;
     if ClipFlags and Zusatzgrafik <>0
     then SetClipboardData(CF_DIB,TakeScreenshot);
     CallEvent(KCEV_Copy,wParam,lParam);
     CloseClipboard;
     SetBlock(EmuBlock and not 8);	{jetzt kann Z80 weitermachen}
     if EmuBlockMask and 8 <>0 then RemoveAnySelection;
    end else MessageBeep(MB_IconStop);
   end;

   WM_Paste: begin
    if OpenClipboard(Wnd) then begin
     W:=GetClipboardData(CF_Text);
     if W<>0 then begin
      PasteString(GlobalLock(W));
      GlobalUnlock(W);
     end;
     CloseClipboard;
    end else MessageBeep(MB_IconStop);
   end;

   WM_Command: case wParam of
    2: SendMessage(Wnd,WM_SysCommand,SC_Close,0);

    101: asm int 3 end;			{Debug-Break}

    102: begin		{Datei laden}
     PrepareOFN;
     asm and LongRec(Ofn.flags).lo,not OFN_HideReadOnly end;
     if GetOpenFileName(ofn) then begin
      LoadFile(SFile,Integer(ofn.nFilterIndex),
	Integer(ofn.Flags) and OFN_ReadOnly <>0);
     end;
    end;
    103: CallEvent(KCEV_Repaint,0,0);	{Debug-Repaint}
    104: begin
     PrepareOFN;
     asm or LongRec(Ofn.flags).lo,OFN_HideReadOnly end;
     if GetSaveFileName(ofn) then begin
      SaveFile(SFile,Integer(ofn.nFilterIndex));
     end;
    end;

    105: MakeModeless(hModul,wParam,@ModulProc);
    106: WinExec('KCLOAD.EXE',SW_Show);
    107: if WinExec('EXPLORER.EXE',SW_Show)<32
    then WinExec('WINFILE.EXE',SW_Show);

    108: begin				{Installieren}
     RegSetRoot('.KCC',stKCEMU);
     RegSetRoot('.Z80',stKCEMU);
     RegSetRoot(stKCEMU,AppName);
     GetModuleFileName(Seg(HInstance),S,sizeof(S));
     lstrcat(S,' %1');
     RegSetRoot('KCEMU\shell\open\command',S);
     SaveConfig;
     Installed:=true;
    end;
    109: begin				{Deinstallieren}
     RegDeleteKey(HKCR,'.KCC');
     RegDeleteKey(HKCR,'.Z80');
     lParam:=RegDeleteKey(HKCR,stKCEMU);
     if lParam<>0 then begin
      MBox1(Wnd,122,PChar(lParam));	{Fehlercode %ld}
     end;
     Installed:=false;
    end;


{    151: ;				{Markieren}
    152: SendMessage(Wnd,WM_Copy,0,0);	{Kopieren}
    153: SendMessage(Wnd,WM_Paste,0,0);	{Einfgen (Text)}
    160: begin				{Linken Rand setzen}
     RandL:=MouseX;
     if RandR<=RandL then RandR:=KCPixmap.x div ChrBoxKC.x; {Ganz rechts!}
     if SelectedRegion<>0 then SelectionChanged;
    end;
    161: begin				{Rechten Rand setzen}
     RandR:=MouseX;
     if RandL>=RandR then RandL:=0;	{Ganz links!}
     if SelectedRegion<>0 then SelectionChanged;
    end;
    162: begin				{Umschalten: Rechteckig markieren}
     RandL:=0;
     if RandR=0 then RandR:=KCPixmap.x div ChrBoxKC.x
     else RandR:=0;			{Nichts was dazwischen pat}
     if SelectedRegion<>0 then SelectionChanged;
    end;

    201..203: SetMenuFlags(MenuFlags xor (1 shl (wParam-201)));

    204: MakeModeless(hKeymap,wParam,@KeymapProc);
    205: begin SetBlock(EmuBlock and not $10); DoNMI; end;	{F9-Block}
    206: begin MakeReset; end;
    207: begin PowerOn; end;
    307: StartDialog(0);
    208: StartDialog(1);
    209: StartDialog(2);
    210: StartDialog(3);
    211: StartDialog(4);

    230: SetBlock(EmuBlock xor $10);	{Run/Stop-Taste F9}

    301: MakeModeless(hDebug,wParam,@DebugProc);
    311..329: begin
     SetNewKC(wParam-310);	{mit einigen USER-KCs}
     if IsZoomed(Wnd) then Magnify:=MaximumMagnify;
     ChrBoxChanged;
    end;
    901: WinHelp(Wnd,HelpFile,HELP_Index,0);
    902: begin				{Schlsselwort-Suche}
     Keyword[0]:=#0;
     CallEvent(KCEV_GetKeyword,Word(-1),LongInt(@Keyword));
     if Keyword[0]<>#0 then SendMessage(Wnd,WM_Command,903,0)
     else MBox1(Wnd,121,nil);
    end;
    903: begin				{Schlsselwort gefunden}
     WinHelp(Wnd,CurrentHelpFile,HELP_PartialKey,LongInt(@Keyword));
    end;

    909: DialogBox(Seg(HInstance),MakeIntResource(wParam),Wnd,@AboutProc);
    910: if not IsIconic(Wnd) then begin
			{Gren-Umschaltung (ALT+ENTER)}
     I:=SW_ShowMaximized; if IsZoomed(Wnd) then I:=SW_ShowNormal;
     ShowWindow(Wnd,I)
    end;
    1001..1050: begin
     lstrcpy(CurrentHelpFile+GetMenuString(GetMenu(Wnd),wParam,
       CurrentHelpFile,sizeof(CurrentHelpFile)-4,MF_ByCommand),'.HLP');
    end;
    else MBox1(Wnd,123,nil);	{Nicht implementiert!}
   end;

   WM_KeyDown: case wParam of
    VK_Capital: PokeChar(#$16);
    VK_Pause: PokeKey($131B);	{STOP/ESC}
    VK_Prior: PokeKey($1011);	{Page Mode/HOME}
    VK_Next: PokeKey($0C12);	{Scroll Mode/CLS}
    VK_End: PokeKey($1318);	{Cursor ans Zeilenende/STOP}
    VK_Home: if Word(GetKeyState(VK_Shift)) and $FFFE<>0
    then AutoInsert:=not AutoInsert	{PC-verwhnte bedienen!}
    else PokeChar(#$19);	{Cursor auf Zeilenanfang/AutoInsert}
    VK_Left: PokeKey($1908);
    VK_Up: PokeKey($110B);
    VK_Right: PokeKey($1809);
    VK_Down: PokeKey($120A);
    VK_Insert: PokeKey($141A);	{INS/CLICK}
    VK_Delete: PokeKey($021F);	{DEL/CLLN}
    VK_Escape: PokeKey($1B03);
    VK_F1..VK_F7: PokeKey((wParam-VK_F1+$F1)*$101+$600); {F-Tasten}
   end;

   WM_KeyUp: CallEvent(KCEV_KeyUp,0,0);

   WM_Char: case Char(wParam) of
    '': PokeChar2($8E7B);	{''}
    '': PokeChar2($997C);	{''}
    '': PokeChar2($9A7D);	{''}
    '': PokeChar2($845B);	{''}
    '': PokeChar2($945C);	{''}
    '': PokeChar2($815D);	{''}
    '': PokeChar2($E17E);	{''}
    ' ': PokeKey($5B20);	{Vollcursor mit Shift}
    #8:  PokeKey($0F01);	{Backspace=CLR/HCOPY}
    #9:  PokeKey($1716);	{TAB als Shiftlock-Taste mibrauchen}
    #27: PokeKey($1B03);
    'A'..'Z': PokeChar(Char(wParam+$20));
    'a'..'z': PokeChar(Char(wParam-$20));
    else PokeChar(Char(wParam));{auch: Enter}
   end;

   WM_DropFiles: begin
    for I:=0 to Integer(DragQueryFile(wParam,$FFFF,nil,0))-1 do begin
     DragQueryFile(wParam,I,S,sizeof(S));
     LoadFile(S,0,false);
    end;
    DragFinish(wParam);
   end;

   WM_LButtonDown: begin
    if wParam and MK_RButton <>0 then begin
     if GetCapture=Wnd then ReleaseCapture;
     if LineDrawn then begin
      PS.hDC:=GetDC(Wnd);
      DrawRandLinie(PS.hDC);
      LineDrawn:=false;
      ReleaseDC(Wnd,PS.hDC);
     end;
     SendMessage(Wnd,WM_Paste,0,0)	{Einfgen (wie bei X und OS/2)}
    end else begin
     RemoveAnySelection;	{Selektion weg vom Bildschirm}
     pt.x:=Pix2ChrBoxX(pt.x);
     pt.y:=Pix2ChrBoxY(pt.y);
     SetRect(SelectedRect,pt.x,pt.y,pt.x,pt.y);
     SetCapture(Wnd);	{Mausereignisse GLOBAL abfangen}
     SetBlock(EmuBlock or (EmuBlockMask and 8));
    end;
   end;

   WM_MouseMove: if GetCapture=Wnd then begin
    if wParam and MK_LButton <>0 then MouseDrag(pt.x,pt.y);
    if wParam and MK_RButton <>0 then begin
     {bei Bewegungen mit rechts: Randlinie zeichnen}
     PS.hDC:=GetDC(Wnd);
     if LineDrawn then DrawRandLinie(PS.hDC);	{Linie lschen}
     MouseX:=Pix2ChrBoxX(pt.x);			{merken zum Rand setzen}
     DrawRandLinie(PS.hDC);
     LineDrawn:=true;
     ReleaseDC(Wnd,PS.hDC);
    end;
   end;

   WM_LButtonUp: if GetCapture=Wnd then begin
    ReleaseCapture;		{Globale Mausereignisse abschalten}
    if SelectedRegion=0 then SetBlock(EmuBlock and not 8);
   end;

   WM_RButtonDown: begin
    if wParam and MK_LButton <>0 then begin
     if GetCapture=Wnd then ReleaseCapture;
     SendMessage(Wnd,WM_Copy,0,0)	{Kopieren (wie bei X und OS/2)}
    end else begin
     MouseX:=Pix2ChrBoxX(pt.x);			{merken zum Rand setzen}
     SetCapture(Wnd);
    end;
   end;

   WM_RButtonUp: if GetCapture=Wnd then begin
    ReleaseCapture;
    W:=LoadMenu(Seg(HInstance),MakeIntResource(304));
    GetMenuString(W,903,S,sizeof(S),MF_ByCommand);	{"Hilfe zu: "}
    Keyword[0]:=#0;
    CallEvent(KCEV_GetKeyword,MouseX+(Pix2ChrBoxY(pt.y) shl 8),
      LongInt(@Keyword));
    if Keyword[0]<>#0 then begin	{Schlsselwort gefunden}
     lstrcat(S,Keyword);
     ModifyMenu(W,903,MF_String or MF_ByCommand,903,S);
    end else DeleteMenu(W,903,MF_ByCommand);
    EnablePasteCommand(W);
    ClientToScreen(Wnd,pt);
    if RandL>=RandR then CheckMenuItem(W,162,MF_Checked);
    TrackPopupMenu(GetSubMenu(W,0),TPM_LeftAlign or TPM_RightButton,
      pt.x,pt.y,0,Wnd,nil);
    DestroyMenu(W);
   end;

   WM_InitMenuPopup: case GetMenuItemID(wParam,0) of
    1001: FillMenuWithHelpfiles(wParam);
    311: FillMenuWithUserKCs(wParam);
    101: EnablePasteCommand(wParam);
   end;

   WM_MenuSelect: if LineDrawn		{vert. Hilfslinie zeichnen/lschen}
   xor (((wParam=160) or (wParam=161)) and (lPar.Hi<>0))
   then begin	{flchtige Linie zeichnen, beim Schlieen des Popup-Mens
    entfernt sie sich wieder, weil Windows WM_MenuSelect lPar.Hi=0 setzt}
    PS.hDC:=GetDC(Wnd);
    DrawRandLinie(PS.hDC);	{Linie zeichnen/lschen}
    ReleaseDC(Wnd,PS.hDC);
    LineDrawn:=not LineDrawn;
   end;

   WM_Timer: case wParam of
    1: begin
     Foreground:=not Foreground;
     Animate;
     if (DispFlags and BlinkHighColor <>0) and (ScreenBPP>8)
     and InvalBlink		{lieber wre mir ein GetDeviceCaps(Animate)}
     then AttachPalette;
    end;
    2: begin
     KillTimer(Wnd,2);
     if KCTyp=0 then begin
	{Men fr KC-Typauswahl automatisch ausklappen, um Neulinge
	 mit der Nase draufstoen zu lassen}
      PostMessage(Wnd,WM_SysCommand,SC_KeyMenu,LongInt('O'));
      PostMessage(Wnd,WM_KeyDown,Word('C'),$102E0001);
     end else if lstrlen(CmdLine)<>0
     then LoadFile(CmdLine,0,false);
    end;
   end;

   WM_EndSession: if (wParam<>0) and Installed then SaveConfig;

   WM_Close: begin
    if Installed then SaveConfig;
    WinHelp(Wnd,HelpFile,HELP_Quit,0);
    if hWav<>0 then WaveOutClose(hWav);
    if WaveOption=3 then asm
	in	al,61h
	and	al,not 3
	out	61h,al		{Sound ausschalten}
    end;
    WaveOption:=0;	{damit Sound nicht wieder eingeschaltet wird}
    PostQuitMessage(0);
   end;

   WM_Destroy: begin
    SetNewKC(0);
    PageFree(MemKCSel);
    DeleteObject(hPal);
    SetWinGUse(false);
   end;

   MM_WOM_Open: begin	{ffnen, wParam=Handle, lParam=ungenutzt}
    CurWaveHdr:=MakeWaveBlock(Waves[0]);
    NextWaveHdr:=MakeWaveBlock(Waves[1]);
   end;
   MM_WOM_Done: begin	{Daten vorhanden! wParam=Handle, lParam=pWaveHdr}
    If CurWaveHdr=nil then CurWaveHdr:=Pointer(lParam)
     else NextWaveHdr:=Pointer(lParam);
   end;
   MM_WOM_Close: begin
    FreeWaveBlock(wParam,Waves[0]);
    FreeWaveBlock(wParam,Waves[1]);
    SetSound(true);
   end;

   else CallOld:=true;
  end;
  if CallOld then KCWndProc:=DefWindowProc(Wnd,Msg,wParam,lParam);
 end;

{Unter Windows95 wird das VxD ggf. dynamisch ge- und entladen}
const
 KCEMU_Device_ID=$3E69;
const
 VxDName:array[0..9] of Char='KCEMU.386';
var
 VXDLDR_Entry:Pointer;
 OldExit:Pointer;

procedure NewExit; far; assembler;
 asm
	db	$66
	mov	ax,word ptr [OldExit]
	db	$66
	mov	word ptr [ExitProc],ax
	mov	ax,$0002	{Unload_VxD}
	mov	bx,KCEMU_Device_ID
	call	[VXDLDR_Entry]
 end;

procedure GetKCEmuVxDEntry; assembler;
 asm	xor	di,di
	mov	es,di
	mov	bx,KCEMU_Device_ID
	mov	ax,$1684	{Get Device API Entry Point}
	int	$2F
	mov	ax,es
	mov	word ptr [KCEmuVxDEntry],di
	mov	word ptr [KCEmuVxDEntry+2],ax
 end;

procedure FindKCEmuVxD; assembler;
 asm	call	GetKCEmuVxDEntry
	or	ax,ax		{<>0?}
	jnz	@@e		{ja, statisch geladen!}
	mov	bx,$0027	{VXDLDR-Device-ID}
	mov	ax,$1684
	int	$2F
	mov	ax,es
	or	ax,ax		{<>0?}
	jz	@@e		{nein, wohl kein Windows95?}
	mov	word ptr [VXDLDR_Entry],di
	mov	word ptr [VXDLDR_Entry+2],ax
	mov	dx,offset VxDName
	mov	ax,$0001	{Load_VxD}
	call	[VXDLDR_Entry]
	jc	@@e		{Fehler!}
	push	cs
	push	offset NewExit
	db	$66
	pop	ax
	db	$66
	xchg	word ptr [ExitProc],ax
	db	$66
	mov	word ptr [OldExit],ax
	call	GetKCEmuVxDEntry	{Zweiter Versuch}
@@e: end;

const
 wc: TWndClass=(		{Hauptfenster}
  style: CS_ByteAlignClient or CS_DblClks or CS_HRedraw or CS_VRedraw;
  lpfnWndProc: @KCWndProc;
  cbClsExtra: 0;
  cbWndExtra: 0;
  hInstance: Seg(HInstance);
  hIcon: 0;
  hCursor: 0;
  hbrBackground: 0;		{kein Hintergrund!}
  lpszMenuName: MakeIntResource(100);
  lpszClassName: stKCEMU);
 wc2: TWndClass=(		{Debug-Listenfenster ASM, MEM und STACK}
  style: CS_ParentDC or CS_DblClks;
  lpfnWndProc: @DebugListProc;
  cbClsExtra: 0;
  cbWndExtra: 2;		{speichert alle zustzlichen Daten dynamisch}
  hInstance: Seg(HInstance);
  hIcon: 0;
  hCursor: 0;
  hbrBackground: 0;
  lpszMenuName: nil;
  lpszClassName: 'KCDEB');

procedure CreateMainWindow;
 begin
  CalcSaum;
  MainWnd:=CreateWindowEx(WS_EX_AcceptFiles,
    stKCEMU,AppName,WS_OverlappedWindow,
    CW_UseDefault,CW_UseDefault,CW_UseDefault,CW_UseDefault,
    0,0,Seg(HInstance),nil);
  if MainWnd=0 then RunError(223);
  ShowWindow(MainWnd,CmdShow);
 end;

var
 Msg: TMsg;
 hAccel: THandle;

begin
 if HPrevInst=0 then begin
  wc.hIcon:=LoadIcon(Seg(HInstance),MakeIntResource(100));
  wc.hCursor:=LoadCursor(0,IDC_Arrow);
  RegisterClass(wc);
  wc2.hCursor:=wc.hCursor;
  RegisterClass(wc2);
 end;
 FindKCEmuVxD;
 hAccel:=LoadAccelerators(Seg(HInstance),MakeIntResource(100));
 LoadString(Seg(HInstance),100,AppName,sizeof(AppName));
 StdMBoxTitle:=AppName;

 EmuBlock:=$10;		{Blockiert durch F9}
 CurWaveHdr:=nil;NextWaveHdr:=nil; {keine Puffer verfgbar}
 CreateMainWindow;

 repeat
  if PeekMessage(Msg,0,0,0,PM_Remove) then begin
   if Msg.message=WM_Quit then break;
   if (hAccel<>0) and (TranslateAccelerator(MainWnd,hAccel,Msg)<>0)
   then continue;
   if (hKBWnd<>0) and IsDialogMessage(hKBWnd,Msg) then continue;
   TranslateMessage(Msg);
   DispatchMessage(Msg);
   continue;
  end;
  if not IdleAction then WaitMessage;
 until false;

 if hCommCtrl<>0 then FreeLibrary(hCommCtrl);

 Halt(Msg.wParam);
end.

